using System;
using System.Collections.Generic;
using System.Text;

namespace CS_CoupledPendula0
{
    public class CVector
    {
        public double x, y, z;
        //private double eps = 0.000001;
        static double eps = 0.000001;
//--------------------------------------------------------------------
        public CVector()
        {
            x = y = z = 0.0;
        }
        public CVector(double x0, double y0, double z0)
        {
            x = x0; y = y0; z = z0;
        }
//--------------------------------------------------------------------
        public static CVector operator +(CVector a, CVector b)
        {
            CVector c = new CVector();
            c.x = a.x + b.x;
            c.y = a.y + b.y;
            c.z = a.z + b.z;
            return c;
        }

        public static CVector operator -(CVector a, CVector b)
        {
            CVector c = new CVector();
            c.x = a.x - b.x;
            c.y = a.y - b.y;
            c.z = a.z - b.z;
            return c;
        }

        public static CVector operator *(CVector a, double b)
        {
            CVector c = new CVector();
            c.x = a.x * b;
            c.y = a.y * b;
            c.z = a.z * b;
            return c;
        }

        public static CVector operator *(double a, CVector b)
        {
            CVector c = new CVector();
            c.x = a * b.x;
            c.y = a * b.y;
            c.z = a * b.z;
            return c;
        }

        public static CVector operator /(CVector a, double b)
        {
            CVector c = new CVector();
            c.x = a.x / b;
            c.y = a.y / b;
            c.z = a.z / b;
            return c;
        }

        public double magnitude()
        {
            return (Math.Sqrt(x * x + y * y + z * z));
        }
        
        public CVector norm()
        {
            double mag = Math.Sqrt(this.x * x + y * y + z * z);

		    if(mag <= eps){ mag = 1.0;}
            x /= mag;
            y /= mag;
            z /= mag;
            if(Math.Abs(x) < eps) x = 0.0;
            if(Math.Abs(y) < eps) y = 0.0;
            if(Math.Abs(z) < eps) z = 0.0;
            CVector v = new CVector(x, y, z);
            return v;
        }

        public CVector norm2()
        {//̒l͕ۑ
            double mag = Math.Sqrt(this.x * x + y * y + z * z);
            CVector v = new CVector();

            if (mag <= eps) { mag = 1.0; }
            v.x = x / mag;
            v.y = y / mag;
            v.z = z / mag;
            if (Math.Abs(v.x) < eps) v.x = 0.0;
            if (Math.Abs(v.y) < eps) v.y = 0.0;
            if (Math.Abs(v.z) < eps) v.z = 0.0;
            return v;
        }

        public CVector reverse()
        {
            x = -x;
            y = -y;
            z = -z;
            CVector v = new CVector(x, y, z);
            return (v);
        }

        public CVector reverse2()
        {//̒l͕ۑ
	        CVector v = new CVector();
	        v.x = -x;
	        v.y = -y;
	        v.z = -z;
	        return(v);
        }

//---------------------------------------------------------------
        public static double vDot(CVector a, CVector b)
        {//
            return (a.x * b.x + a.y * b.y + a.z * b.z);
        }

        public static CVector vCross(CVector a, CVector b)
        {//O
            CVector v = new CVector();
            v.x = a.y * b.z - a.z * b.y;
            v.y = a.z * b.x - a.x * b.z;
            v.z = a.x * b.y - a.y * b.x;
            return v;
        }
        //xNgԋ
        public static double vDist(CVector a, CVector b)
        {
            CVector c = new CVector();
            c = b - a;
            return (c.magnitude());
        }
    }
}
