/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

2dUq
Runge-Kutta-Gill@
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

//eNX`t@C
#define FILENAME_IN "../../bmp/check3.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath5.h"
#include "../../myPrimitive5.h"
#include "../../myTexture5.h"
#include "../../bmpLoadSave.h"
#include "../../rigid.h"
#include "../../setup.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTexture();

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];

//^CXebv̋}ȕωɑΉ邽߂Ұ
double timeStep, timeStep0, timeStep1;

//VF[_vO
GLuint shaderProg;

double heightFix = 2.2;//Œ_̍
double omega1, theta1, omega2, theta2;//IC[@vZp
double len12, len21, mu, gl1, gl2;
//Runge-Kutta-GillŎgpz
double kk1[5], kk2[5], rr1[5], qq1[5], uu[5], rr2[5], qq2[5], vv[5];

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("SL_Double2");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ݒ
	init();
	initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");

	setupGLUI();//myGLUI.hɎ
	GLUI_Master.set_glutIdleFunc( idle );

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
	glDeleteProgram(shaderProg);
	deleteDisplayLists();
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.2, 0.2, 0.3, 1.0);

	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);

	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist= 5.0;
	view.vCnt = CVector(0.0, 0.0, 2.0);
	view.theta = -10.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;
	//parameters
	viscous = 0.0;
	timeRate = 1.0;

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	//eNX`[
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	setTexture();

	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initObject();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
}

void initObject()
{	
	flagFreeze = false;
	flagOneStep = false;
	countStrobo = 0;
	timeStrobo = 0.0;

	numRigid0 = 5;
	numRigid = numRigid0 + numStrobo;

	//萔
	len12 = length1 / length2;
	len21 = length2 / length1;
	gl1 = gravity / length1;
	gl2 = gravity / length2;
	mu = mass2 / (mass1 + mass2);
	//Uq^p[^̏l
	omega1 = omega10;//px  
	omega2 = omega20;
	theta1 = theta10 * DEG_TO_RAD;//XΊp(radɕϊ)
	theta2 = theta20 * DEG_TO_RAD;//XΊp(radɕϊ)
	//̔a
	double radius1 = length1 * sin(DEG_TO_RAD * theta10);
	double radius2 = radius1 + length2 * sin(DEG_TO_RAD * theta20);
	//
	double height1 = heightFix - length1 * cos(DEG_TO_RAD*theta10);
	double height2 = height1 - length2 * cos(DEG_TO_RAD*theta20);
	//Runge-Kutta-Gill@̏l
	qq1[0] = 0.0; qq2[0] = 0.0; uu[0] = omega10; vv[0] = omega20;

	//́i_j̏ݒ
	int i;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();
	//Œ_
	rigid[0].kind = BOX;
	rigid[0].color = RED;
	rigid[0].mass = 100;//C
	rigid[0].vSize = CVector(0.2, 0.2, 0.1);
	rigid[0].vPos = CVector(0.0, 0.0, heightFix+rigid[0].vSize.z/2.0);
	//1
	rigid[1].kind = SPHERE;
	rigid[1].color = CYAN;
	rigid[1].mass = mass1;
	rigid[1].vSize = CVector(1.0, 1.0, 1.0) * size1;
	rigid[1].vPos = CVector(0.0, radius1, height1);
	rigid[1].vEuler = CVector(theta10, 0.0, 0.0);//莩g̉]p
	//Uq1̖_
	rigid[2].kind = CYLINDER;
	rigid[2].vSize = CVector(0.025, 0.025, length1);
	rigid[2].vPos = CVector(rigid[1].vPos.x / 2.0, rigid[1].vPos.y / 2.0, (heightFix + height1) / 2.0);
	rigid[2].vEuler = rigid[1].vEuler;  
	//2
	rigid[3].kind = SPHERE;
	rigid[3].color = CYAN;
	rigid[3].mass = mass2;
	rigid[3].vSize = CVector(1.0, 1.0, 1.0) * size2;
	rigid[3].vPos = CVector(0.0, radius2, height2);
	rigid[3].vEuler = CVector(theta20, 0.0, 0.0);//莩g̉]p
	//Uq2̖_
	rigid[4].kind = CYLINDER;
	rigid[4].vSize = CVector(0.025, 0.025, length2);
	rigid[4].vPos = CVector(0.0, radius1 + length2 * sin(DEG_TO_RAD * theta20)/2.0, (height1 + height2) / 2.0);
	rigid[4].vEuler = rigid[3].vEuler;  

	//strobo
	for(i = numRigid0; i < numRigid; i++) 
	{
		if(((i-numRigid0) / 2) * 2 == i - numRigid0) 
		{
			rigid[i].color = CYAN;
			rigid[i].vSize = CVector(0.03, 0.03, 0.03);
			rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
		}
		else
		{
			rigid[i].color = YELLOW;
			rigid[i].vSize = CVector(0.03, 0.03, 0.03);
			rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
		}
	}
	rigid[3].select = 1;
	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
  
}

void setTexture()
{
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̎w 
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
	//eNX`̌JԂ@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	//eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	static int countStrobo = 0;
	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)
	{
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	glUseProgram(shaderProg);
	GLint imageLoc = glGetUniformLocation(shaderProg, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");

	for(int i = 0; i < numRigid0; i++) 
	{
		if(rigid[i].select == 1) glUniform1i(selLoc, 1);
		else glUniform1i(selLoc, 0);

		rigid[i].draw(false);
	}
	glUniform1i(selLoc, 0);
	if(flagStrobo)
		for(int i = numRigid0; i < numRigid; i++) rigid[i].draw(false);

	glUseProgram(0);

	timeStep = timeRate * dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	double alpha1; 
	double ss, cc, s1, s2, r1, r2, h1, h2, aa, pa, qa;
	//Wz
	static double a[] = { 0.0, 0.5, 0.5 * (2.0 - sqrt(2.0)), 0.5 * (2.0 + sqrt(2.0)), 1.0 / 6.0 };
	static double b[] = { 0.0, 2.0, 1.0, 1.0, 2.0 };
	static double c[] = { 0.0, 0.5, 0.5 * (2.0 - sqrt(2.0)), 0.5 * (2.0 + sqrt(2.0)), 0.5 };
	if(flagStart==true && flagFreeze == false && flagFreeze0 == false) 
	{
		//Runge-Kutta-Gill
		ss = sin(theta1 - theta2);
		cc = cos(theta1 - theta2);
		s1 = sin(theta1);
		s2 = sin(theta2);
		aa = mu * cc * cc -1.0;
		pa = mu * ss / aa;
		qa= gl1 / aa;

		alpha1 = pa * (omega1 * omega1 * cc + len21 * omega2 * omega2) + qa * (s1 - mu * cc * s2)
					   - (viscous / mass1) * omega1;

		for (int i = 1; i <= 4; i++)
		{
			kk1[i] = (pa * (uu[i-1] * uu[i-1] * cc + len21 * vv[i-1] * vv[i-1]) + qa * (s1 - mu * cc * s2) - (viscous / mass1) * uu[i-1]) * timeStep;
			rr1[i] = a[i] * (kk1[i] - b[i] * qq1[i - 1]);
			uu[i] = uu[i - 1] + rr1[i];
			qq1[i] = qq1[i - 1] + 3.0 * rr1[i] - c[i] * kk1[i];
				kk2[i] = (len12 * (ss * uu[i-1] * uu[i-1]  - cc * alpha1) - gl2 * s2 - (viscous / mass2) * vv[i-1]) * timeStep;
			rr2[i] = a[i] * (kk2[i] - b[i] * qq2[i-1]);
			vv[i] = vv[i-1] + rr2[i];
			qq2[i] = qq2[i-1] + 3.0 * rr2[i] - c[i] * kk2[i];
		}
		qq1[0] = qq1[4]; qq2[0] = qq2[4];
		uu[0] = uu[4]; vv[0] = vv[4];
		omega1 = uu[4];
		omega2 = vv[4];

		theta1 += omega1 * timeStep;
		theta2 += omega2 * timeStep;
		r1 = length1 * s1;
		r2 = r1 + length2 * s2;
		h1 = heightFix - length1 * cos(theta1);
		h2 = h1 - length2 * cos(theta2);
		//1
		rigid[1].vPos = CVector(0.0, r1, h1);
		rigid[1].vEuler = CVector(theta1 * RAD_TO_DEG, 0.0, 0.0);
		//_1
		rigid[2].vPos = CVector(0.0, r1 / 2.0,( heightFix + h1) / 2.0);
		rigid[2].vEuler = rigid[1].vEuler;
		//2
		rigid[3].vPos = CVector(0.0, r2, h2);
		rigid[3].vEuler = CVector(theta2 * RAD_TO_DEG, 0.0, 0.0);
		//_2
		rigid[4].vPos = CVector(0.0, (r1 + r2) / 2.0, (h1 + h2) / 2.0);
		rigid[4].vEuler = rigid[3].vEuler;

		if(flagOneStep) flagFreeze = true;

		elapseTime2 += timeStep;

		//Strobo
		if(countStrobo < numStrobo)
		{
			if( timeStrobo == 0.0) 
			{
				if((countStrobo/2) * 2 == countStrobo) rigid[numRigid0 + countStrobo].vPos = rigid[1].vPos;
				else                                   rigid[numRigid0 + countStrobo].vPos = rigid[3].vPos;
			}

			timeStrobo += timeStep;
			if(timeStrobo >= periodStrobo) {timeStrobo = 0.0; countStrobo ++;}
			if(countStrobo >= numStrobo) countStrobo = 0;
		}
	}

	if(flagFloor) glCallList(floor0);//En
	if(flagShadow) drawShadow();     //e
	if(flagCoordShow) 
	{
		drawWorldCoordinates(0.5); //[hԂ̍W
	}

	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", (int)((float)fps0 / timeRate), 10, 30);
		drawParam("timestep=%1.5f[s]", timeRate/(float)fps0, 200, 30);
		drawParam("elapsetime=%3.3f[s]", (float)elapseTime2, 400, 30);
	}
	//obt@̐؂ւ
	glutSwapBuffers();
}


