/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

2Rx̒PUq
Runge-Kutta-Gill
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

//eNX`t@C
#define FILENAME_IN "../../bmp/check3.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath5.h"
#include "../../myPrimitive5.h"
#include "../../myTexture5.h"
#include "../../bmpLoadSave.h"
#include "../../rigid.h"
#include "../../setup.h"
#include "myGLUI.h"


//֐̃vg^Cv錾
void init();
void idle();
void display();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTexture();

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];

//^CXebv̋}ȕωɑΉ邽߂Ұ
double timeStep, timeStep0, timeStep1;

//VF[_vO
GLuint shaderProg;

//PUqҰ
double heightFix = 2.0;//Œ_̍
double omegaT, theta;
double omegaP, phi;//IC[@̐lvZp
//Runge-Kutta-GillŎgpz
double kt[5], kp[5], rt[5], qt[5], uu[5], rp[5], qp[5], vv[5];

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("SL_Single1");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ݒ
	init();
	initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");

	setupGLUI();//myGLUI.hɎ
	GLUI_Master.set_glutIdleFunc( idle );

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
	glDeleteProgram(shaderProg);
	deleteDisplayLists();
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.2, 0.2, 0.3, 1.0);

	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist= 5.0;
	view.vCnt = CVector(0.0, 0.0, 1.5);
	view.theta = 15.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	//eNX`[
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	setTexture();

	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initObject();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
}

void initObject()
{	
	flagFreeze = false;
	flagOneStep = false;
	countStrobo = 0;
	timeStrobo = 0.0;

	numRigid0 = 3;
	numRigid = numRigid0 + numStrobo;

	//Uq^p[^̏l
	omegaT = omegaT0;           //px
	theta = theta0 * DEG_TO_RAD;//XΊp(radɕϊ)
	//~^̊px
	omegaP = omegaP0;//omegaP̏l
	//~^̏a
	double radius0 = length0 * sin(DEG_TO_RAD * theta0);
	//̂̍
	double height0 = heightFix - length0 * cos(DEG_TO_RAD*theta0);
	//Ίp̏l
	phi = M_PI / 2.0;//phȉl

	//Runge-Kutta-Gill@̏l
	qt[0] = 0.0; qp[0] = 0.0; uu[0] = omegaT0; vv[0] = omegaP0;

	//́i_j̏ݒ
	int i;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();
	//Œ_
	rigid[0].kind = BOX;
	rigid[0].color = RED;
	rigid[0].mass = 100;
	rigid[0].vSize = CVector(0.2, 0.2, 0.1);
	rigid[0].vPos = CVector(0.0, 0.0, heightFix+rigid[0].vSize.z/2.0);
	//
	rigid[1].kind = SPHERE;
	rigid[1].color = CYAN;
	rigid[1].mass = mass0;
	rigid[1].vSize = CVector(1.0, 1.0, 1.0) * size0;
	rigid[1].vPos = CVector(0.0, radius0, height0);
	rigid[1].vEuler = getEulerZ(rigid[1].vPos, CVector(0.0, 0.0, heightFix));//莩g̉]p
	//Uq̖_
	rigid[2].kind = CYLINDER;
	rigid[2].vSize = CVector(0.025, 0.025, length0);
	rigid[2].vPos = CVector(rigid[1].vPos.x / 2.0, rigid[1].vPos.y / 2.0, (heightFix + height0) / 2.0);
	rigid[2].vEuler = rigid[1].vEuler;  

	//strobo
	for(i = numRigid0; i < numRigid; i++) 
	{
		rigid[i].color = YELLOW;
		rigid[i].vSize = CVector(0.03, 0.03, 0.03);
		rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
	}

	rigid[1].select = 1;
	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
}

void setTexture()
{
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̎w 
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
	//eNX`̌JԂ@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	//eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	static int countStrobo = 0;
	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)
	{
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	glUseProgram(shaderProg);
	GLint imageLoc = glGetUniformLocation(shaderProg, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");

	for(int i = 0; i < numRigid0; i++) 
	{
		if(rigid[i].select == 1) glUniform1i(selLoc, 1);
		else glUniform1i(selLoc, 0);

		rigid[i].draw(false);
	}
	glUniform1i(selLoc, 0);
	if(flagStrobo)
		for(int i = numRigid0; i < numRigid; i++) rigid[i].draw(false);

	glUseProgram(0);

	timeStep = timeRate * dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	double alphaT, alphaP, rr, hh, ss, cc;
	//Wz
	static double a[] = { 0.0, 0.5, 0.5 * (2.0 - sqrt(2.0)), 0.5 * (2.0 + sqrt(2.0)), 1.0 / 6.0 };
	static double b[] = { 0.0, 2.0, 1.0, 1.0, 2.0 };
	static double c[] = { 0.0, 0.5, 0.5 * (2.0 - sqrt(2.0)), 0.5 * (2.0 + sqrt(2.0)), 0.5 };

	if(flagStart==true && flagFreeze == false && flagFreeze0 == false) 
	{
		ss = sin(theta);
		cc = cos(theta);
		if(fabs(omegaP0) <= 0.00001)
		{//IC[@ŒPUqƂĉ
			alphaT = - (gravity/length0) * ss - (viscous/mass0) * omegaT;
			alphaP = 0.0;
			omegaT += alphaT * timeStep;
			omegaP += alphaP * timeStep;
		}
		else
		{//QENb^EM@

			if(fabs(ss) < 0.001) flagStart = false; 

			for (int i = 1; i <= 4; i++)
			{
			kt[i] = (ss * cc * vv[i - 1] * vv[i - 1] - (gravity / length0) * ss - (viscous / mass0) * uu[i - 1]) * timeStep;
			rt[i] = a[i] * (kt[i] - b[i] * qt[i - 1]);
			uu[i] = uu[i - 1] + rt[i];
			qt[i] = qt[i - 1] + 3.0 * rt[i] - c[i] * kt[i];
			kp[i] = (-2.0 * (cc / ss) * uu[i-1] * vv[i-1] - (viscous / mass0) * vv[i-1]) * timeStep;
			rp[i] = a[i] * (kp[i] - b[i] * qp[i-1]);
			vv[i] = vv[i-1] + rp[i];
			qp[i] = qp[i-1] + 3.0 * rp[i] - c[i] * kp[i];
			}
			qt[0] = qt[4]; qp[0] = qp[4];
			uu[0] = uu[4]; vv[0] = vv[4];
			omegaT = uu[4];
			omegaP = vv[4];
		}
		theta += omegaT * timeStep;
		phi += omegaP * timeStep;
		rr = length0 * ss;
		hh = heightFix - length0 * cc;

		//
		rigid[1].vPos = CVector(rr * cos(phi), rr * sin(phi), hh);
		rigid[1].vEuler = getEulerZ( rigid[1].vPos, CVector(0.0, 0.0, heightFix));
		//_
		rigid[2].vPos = CVector(rigid[1].vPos.x / 2.0, rigid[1].vPos.y / 2.0,( heightFix + hh) / 2.0);
		rigid[2].vEuler = rigid[1].vEuler;
		
			 
		if(flagOneStep) flagFreeze = true;

		elapseTime2 += timeStep;

		//Strobo
		if(countStrobo < numStrobo)
		{
			if( timeStrobo == 0.0) 
			{
				rigid[numRigid0 + countStrobo].vPos = rigid[1].vPos;
			}

			timeStrobo += timeStep;
			if(timeStrobo >= periodStrobo) {timeStrobo = 0.0; countStrobo ++;}
			if(countStrobo >= numStrobo) countStrobo = 0;
		}
	}

	if(flagFloor) glCallList(floor0);//En
	if(flagShadow) drawShadow();     //e
	if(flagCoordShow) 
	{
		drawWorldCoordinates(0.5); //[hԂ̍W
	}

	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", (int)((double)fps0 / timeRate), 10, 30);
		drawParam("timestep=%1.5f[s]", timeRate/fps0, 200, 30);
		drawParam("elapsetime=%3.3f[s]", elapseTime2, 400, 30);
	}
	//obt@̐؂ւ
	glutSwapBuffers();
}
