﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace CS_EigenValue
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }
//---------------------------------------------------------------------
    //QRM qr = new QRM();//QR_Method.cs
    int freedom = 2;

    private void Form1_Load(object sender, EventArgs e)
    {
      cmbFreedom.Items.Add( "2");
      cmbFreedom.Items.Add( "3");
      cmbFreedom.Text = "2";
      if (freedom == 2)
      {
        txtMass0.Visible = false;
        txtMass3.Visible = false;
      }

      txtLength0.Text = "1.0";

      txtConstK0.Text = "10.0";
      txtConstK1.Text = "10.0";
      txtConstK2.Text = "10.0";

      txtMass0.Text = "1.0";
      txtMass1.Text = "1.0";
      txtMass2.Text = "1.0";
      txtMass3.Text = "1.0";

    }

    private void cmbFreedom_SelectedIndexChanged(object sender, EventArgs e)
    {
      freedom = Convert.ToInt32(cmbFreedom.Text);
      if (freedom == 2){
        txtMass0.Visible = false;
        txtMass3.Visible = false;
      }
      else if (freedom == 3){
        txtMass0.Visible = false;
        txtMass3.Visible = true;
      }
      
    }

    private void btnStart_Click(object sender, EventArgs e)
    {
      freedom = Convert.ToInt32(cmbFreedom.Text);
      double length0 = Convert.ToDouble(txtLength0.Text);
      double[] constK = new double[3];
      constK[0] = Convert.ToDouble(txtConstK0.Text);
      constK[1] = Convert.ToDouble(txtConstK1.Text);
      constK[2] = Convert.ToDouble(txtConstK2.Text);

      double[] mass = new double[4];
      double[,] kk = new double[4, 4];
      double[,] eigen0 = new double[4, 4];
      double[] lambda0 = new double[4];
      double[,] eigen = new double[4, 4];
      double[] lambda = new double[4];
      double[] omega = new double[4];
      double[] frequency = new double[4];
      double[] period = new double[4];
      double[,] ampRatio = new double[4, 4];
      int i, j;

      if (freedom == 2)
      {
        mass[1] = Convert.ToDouble(txtMass1.Text);
        mass[2] = Convert.ToDouble(txtMass2.Text);

        //係数行列の作成
        kk[0, 0] = eigen0[0, 0] = (constK[0]+constK[1])/ mass[1];
        kk[0, 1] = eigen0[0, 1] = -constK[1] / mass[1];
        kk[1, 0] = eigen0[1, 0] = -constK[1] / mass[2];
        kk[1, 1] = eigen0[1, 1] = (constK[1]+ constK[2])/ mass[2];
      }
      else if (freedom == 3)
      {
        mass[1] = Convert.ToDouble(txtMass1.Text);
        mass[2] = Convert.ToDouble(txtMass2.Text);
        mass[3] = Convert.ToDouble(txtMass3.Text);

        //係数行列の作成
        kk[0, 0] = eigen0[0, 0] = (constK[0] + constK[1]) / mass[1];
        kk[0, 1] = eigen0[0, 1] = -constK[1] / mass[1];
        kk[0, 2] = eigen0[0, 2] = 0.0;

        kk[1, 0] = eigen0[1, 0] = -constK[1] / mass[2];
        kk[1, 1] = eigen0[1, 1] = (constK[1] + constK[2]) / mass[2];
        kk[1, 2] = eigen0[1, 2] = -constK[2] / mass[2];

        kk[2, 0] = eigen0[2, 0] = 0.0;
        kk[2, 1] = eigen0[2, 1] = -constK[2] / mass[3];
        kk[2, 2] = eigen0[2, 2] =  constK[2] / mass[3];
      }
  
      //固有値の大きい順に求める
      QRM.QR_Method(kk, lambda0, freedom);
      QRM.EigenVector(eigen0, lambda0, freedom);
      //固有値の小さい順に並び替える
      for (i = 0; i < freedom; i++)
      {
        lambda[i] = lambda0[freedom - 1 - i];
        omega[i] = Math.Sqrt(lambda[i]);
        for (j = 0; j < freedom; j++)
        {
          eigen[i, j] = eigen0[freedom - 1 - i, j];
          //振幅比
          ampRatio[i, j] = eigen[i,j] / eigen[i,0];
        }
        frequency[i] = omega[i] / (2.0 * Math.PI);
        period[i] = 1.0 / frequency[i];
      }

      //listBox1に固有値を表示
      listBox1.Items.Add(" i     固有値     固有角振動数  　 固有振動数　固有周期");
      for (i = 0; i < freedom; i++) listBox1.Items.Add(" " + i.ToString() + "     " + lambda[i].ToString("00.0000")+ "      " + omega[i].ToString("0.0000" ) + "             " + frequency[i].ToString("0.0000" ) + "          " + period[i].ToString("0.0000" ) );
    
      listBox1.Items.Add("   ");//1行空白
      //振幅比
      listBox1.Items.Add(" i " + "   j" + "        振幅比");
      for(i = 0; i < freedom; i++)
        for(j = 0; j < freedom; j++)
          listBox1.Items.Add(" " + i.ToString() + "   " + j.ToString() + "      " + ampRatio[i, j].ToString("0.0000"));

      listBox1.Items.Add("   ");//1行空白   
    }
  }
} 