using System;
using System.Collections.Generic;
using System.Text;
//ǉ
using System.Windows.Forms;//MessageBox𗘗p邽

namespace CS_EigenValue
{
  public class QRM
  {
    public QRM()
    {
    }
    static double TOL = 1.0e-6;
    //-------------------------------------------------------------------
    //KEX̏@ɂẢ@
    public static void Gauss(double[,] a, double[] b, int n)
    {
      //́Fa[n,n]=Ws(vZω),b[n]=萔xNg, n=
      //óFb[n]=̉
      int i, j, k;
      double akk, p1, s;

      //Oi
      for (k = 0; k < n - 1; k++)
      {
        Pivoting(a, b, n, k);
        akk = a[k, k];
        for (i = k + 1; i < n; i++)
        {
          p1 = a[i, k] / akk;
          b[i] -= p1 * b[k];
          for (j = k; j < n; j++) a[i, j] -= p1 * a[k, j];
        }
      }

      //ޑ
      b[n - 1] /= a[n - 1, n - 1];
      for (i = n - 2; i >= 0; i--)
      {
        s = 0.0;
        for (j = i + 1; j < n; j++) s += a[i, j] * b[j];
        b[i] = (b[i] - s) / a[i, i];
      }
    }//Gauss
    //--------------------------------------------------------------
    private static void Pivoting(double[,] a, double[] b, int n, int k)
    {
      double piv, ch;
      int i, j, kk;

      piv = 0.0;//pivoting
      kk = k;
      for (i = k; i < n; i++)
      {
        if (piv < Math.Abs(a[i, k]))
        {
          piv = Math.Abs(a[i, k]);
          kk = i;
        }
      }
      if (piv == 0.0)
      {
        MessageBox.Show("Ƃł܂", "Pivoting");
        return;
      }
      if (kk != k)
      {
        for (j = k; j < n; j++)
        {
          ch = a[k, j]; a[k, j] = a[kk, j]; a[kk, j] = ch;
        }
        ch = b[k]; b[k] = b[kk]; b[kk] = ch;
      }
    }//Pivoting

    //-----------------------------------------------------------------------
    //HouseholderϊɂHessenbergs߂D
    private static void Householder(double[,] a, int n)
    {
      int i, j, k;
      double sum, sigma, norm, ud, uds;
      double[] u = new double[n];
      double[] d = new double[n];
      double[] ds = new double[n];

      for (k = 0; k <= n - 3; k++)
      {
        for (i = 0; i <= k; i++) u[i] = 0.0;
        for (i = k + 1; i < n; i++) u[i] = a[i, k];

        //ϊsH
        sum = 0.0;
        for (i = k + 1; i < n; i++) sum += u[i] * u[i];
        if (Math.Abs(u[k + 1]) < TOL) continue;
        sigma = Math.Sqrt(sum) * u[k + 1] / Math.Abs(u[k + 1]);
        u[k + 1] += sigma;
        norm = Math.Sqrt(2.0 * sigma * u[k + 1]);
        for (i = k + 1; i < n; i++) u[i] /= norm;

        //ϊ
        for (i = 0; i < n; i++)
        {
          d[i] = 0.0; ds[i] = 0.0;
          for (j = k + 1; j < n; j++)
          {
            d[i] += a[i, j] * u[j];
            ds[i] += a[j, i] * u[j];
          }
        }
        ud = 0.0; uds = 0.0;
        for (i = k + 1; i < n; i++)
        {
          ud += u[i] * d[i];
          uds += u[i] * ds[i];
        }
        for (i = 0; i < n; i++)
        {
          d[i] = 2.0 * (d[i] - ud * u[i]);
          ds[i] = 2.0 * (ds[i] - uds * u[i]);
        }
        for (i = 0; i < n; i++)
        {
          for (j = 0; j < n; j++)
            a[i, j] -= u[i] * ds[j] + d[i] * u[j];
        }
      }
    }//Householder

    private static void QR_Decomposition(double[,] a, int n)
    {
      //́Fa[n,n]=s(vZa[,]ω̂ŒӁj, n=
      //óFa[n,n]=ŗLliΊpj
      int i, j, k, m;
      double a00, a01, a10, a11, lam1, lam2, sum1, sum2, wa, mu;
      double sint, cost;
      double[] q = new double[n * n];
      double[] w = new double[n];

      m = n;
      //
      while (m != 1)
      {
        if (Math.Abs(a[m - 1, m - 2]) < TOL) { m--; continue; }
        //_ړ
        a00 = a[m - 2, m - 2]; a01 = a[m - 2, m - 1];
        a10 = a[m - 1, m - 2]; a11 = a[m - 1, m - 1];
        sum1 = a00 + a11;
        sum2 = a00 * a11 - a01 * a10;
        wa = sum1 * sum1 - 4.0 * sum2;
        if (wa < 0.0) wa = 0.0;
        else wa = Math.Sqrt(wa);
        lam1 = 0.5 * (sum1 + wa);
        lam2 = sum2 / lam1;
        if (Math.Abs(a11 - lam1) < Math.Abs(a11 - lam2)) mu = a11 - lam1;
        else mu = a11 - lam2;
        for (i = 0; i < m; i++) a[i, i] -= mu;
        //QR
        for (i = 0; i < m * m; i++) q[i] = 0.0;
        for (i = 0; i < m; i++) q[m * i + i] = 1.0;
        for (i = 0; i < m - 1; i++)
        {
          sum1 = Math.Sqrt(a[i, i] * a[i, i] + a[i + 1, i] * a[i + 1, i]);
          if (Math.Abs(sum1) < TOL)
          {
            sint = 0.0; cost = 0.0;
          }
          else
          {
            sint = a[i + 1, i] / sum1;
            cost = a[i, i] / sum1;
          }
          for (j = i + 1; j < m; j++)
          {
            sum2 = a[i, j] * cost + a[i + 1, j] * sint;
            a[i + 1, j] = -a[i, j] * sint + a[i + 1, j] * cost;
            a[i, j] = sum2;
          }
          a[i + 1, i] = 0.0; a[i, i] = sum1;
          for (j = 0; j < m; j++)
          {
            sum2 = q[m * j + i] * cost + q[m * j + i + 1] * sint;
            q[m * j + i + 1] = -q[m * j + i] * sint + q[m * j + i + 1] * cost;
            q[m * j + i] = sum2;
          }
        }
        for (i = 0; i < m; i++)
        {
          for (j = i; j < m; j++) w[j] = a[i, j];
          for (j = 0; j < m; j++)
          {
            sum1 = 0.0;
            for (k = i; k < m; k++) sum1 += w[k] * q[m * k + j];
            a[i, j] = sum1;
          }
        }
        for (i = 0; i < m; i++) a[i, i] += mu;
      }
    }//QR_Decomposition

    //Householder@QRɂŗLl@
    public static void QR_Method(double[,] a, double[] lambda, int n)
    {
      //́Fa[n,n]=s(vZωj, n=
      //óFlamda[n]=ŗLli傫j
      Householder(a, n);
      QR_Decomposition(a, n);
      //傫ɕבւ
      double max, c;
      int i, k1, k2;

      for (i = 0; i < n; i++) lambda[i] = a[i, i];
      for (k1 = 0; k1 < n - 1; k1++)
      {
        max = lambda[k1];
        for (k2 = k1 + 1; k2 < n; k2++)
        {
          if (max < lambda[k2])
          {
            max = lambda[k2];
            //ŗLľ
            c = lambda[k1];
            lambda[k1] = lambda[k2];
            lambda[k2] = c;
          }
        }
      }
    }
    
    public static void EigenVector(double[,] a, double[] lambda, int n)
    {
      //ŗLllamdam̂Ƃi傫ɂȂĂ̂Ƃ)ŗLxNgvZ
      //́Fa[n,n]=Ws
      //lambda[n]=ŗLl
      //n=,
      //óFa[n,n]=ŗLxNg

      int i, j, k;
      double norm;
      double[,] aa = new double[n, n];
      double[,] u = new double[n, n];//ŗLxNg
      double[] b = new double[n];//萔xNg
      double[] x = new double[n];//萔xNg,Ả

      //(A-I)X=B
      //x[n-1]=1ƂĒ萔xNgߑ̌ŗLxNgvZ
      for (i = 0; i < n - 1; i++) b[i] = -a[i, n - 1];//萔xNg͌Œ

      for (k = 0; k < n; k++)//ŗLl̑傫nvZ
      {
        for (i = 0; i < n; i++)
          for (j = 0; j < n; j++) aa[i, j] = a[i, j];
        for (i = 0; i < n - 1; i++)
        {
          aa[i, i] -= lambda[k];
          x[i] = b[i];
        }
        Gauss(aa, x, n - 1);//Ǎn1Ȃ
        //K
        x[n - 1] = 1.0;
        norm = 0.0;
        for (i = 0; i < n; i++) norm += x[i] * x[i];
        norm = Math.Sqrt(norm);
        for (i = 0; i < n; i++) u[i, k] = x[i] / norm;
      }
      for (k = 0; k < n; k++)
        for (i = 0; i < n; i++) a[i, k] = u[i, k];
    }
 
  }
}
