﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace CS_Spring23
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }
    //-----------------------------------------------------------------
    const int NUM_MAX = 500;
    double actTime;//実行時間[s]
    int numData;
    int freedom = 2;

    private void Form1_Load(object sender, EventArgs e)
    {
      cmbFreedom.Items.Add("2");
      cmbFreedom.Items.Add("3");
      cmbFreedom.Text = "2";
      if (freedom == 2)
      {
        txtMass3.Visible = false;
      }

      cmbActTime.Items.Add("500.0");
      cmbActTime.Items.Add("200.0");
      cmbActTime.Items.Add("100.0");
      cmbActTime.Items.Add("50.0");
      cmbActTime.Items.Add("20.0");
      cmbActTime.Items.Add("10.0");
      cmbActTime.Text = "20.0";

      cmbNumData.Items.Add("500");
      cmbNumData.Text = "500";

      txtLength0.Text = "1.0";
      txtConstK0.Text = "10.0";
      txtConstK1.Text = "10.0";
      txtConstK2.Text = "10.0";

      txtMass1.Text = "1.0";
      txtMass2.Text = "1.0";
      txtMass3.Text = "1.0";

      //初期変位量
      txtDisp1.Text = "0.2";
      txtDisp2.Text = "0.2";
      txtDisp3.Text = "0.0";

      if (freedom == 2)
      {
        txtMass3.Visible = false;
        txtDisp3.Visible = false;
        picSpace.Height = 300;
      }

      txtAmplitude.Text = "0.5";
      picSpace.Width = NUM_MAX + 80;
    }

    private void btnStart_Click(object sender, EventArgs e)
    {
      double timeStep = 0.001;//固定
      double length0 = Convert.ToDouble(txtLength0.Text);
      actTime = Convert.ToDouble(cmbActTime.Text);
      double[] constK = new double[3];
      constK[0] = Convert.ToDouble(txtConstK0.Text);
      constK[1] = Convert.ToDouble(txtConstK1.Text);
      constK[2] = Convert.ToDouble(txtConstK2.Text);

      numData = Convert.ToInt32(cmbNumData.Text);

      double[] mass = new double[4];
      double[] disp = new double[4];
      double[] leng = new double[4];
      //データ取り込み間隔
      int interval = (int)((actTime / timeStep) / NUM_MAX) / (NUM_MAX / numData);
      double[,] DISP = new double[4, NUM_MAX + 1];//変位確定値
      double[] pos = new double[4];
      double[] pos0 = new double[4];//初期位置
      double[] vel = new double[4];
      double[] acc = new double[4];
      double time;
      int cnt, count;

      if (freedom == 2)
      {
        mass[1] = Convert.ToDouble(txtMass1.Text);
        mass[2] = Convert.ToDouble(txtMass2.Text);
        disp[1] = Convert.ToDouble(txtDisp1.Text);
        disp[2] = Convert.ToDouble(txtDisp2.Text);

        time = 0.0;
        count = 0;
        cnt = 0;
        //初期状態
        leng[0] = length0 + disp[1];
        leng[1] = length0 - disp[1] + disp[2];
        leng[2] = length0 - disp[2];

        vel[1] = 0.0;
        vel[2] = 0.0;
        pos0[1] = -length0 / 2.0;
        pos0[2] = length0 / 2.0;
        pos[1] = pos0[1] + disp[1];
        pos[2] = pos0[2] + disp[2];
        
        while (time <= actTime && count < NUM_MAX)
        {
          //おもりの変位量
          disp[1] = pos[1] - pos0[1];
          disp[2] = pos[2] - pos0[2];
          for (int i = 1; i <= 2; i++)
          {
            if (i == 1)
              acc[1] = (-(constK[0] + constK[1]) * disp[1] + constK[1] * disp[2]) / mass[1];
            else
              acc[2] = (constK[1] * disp[1] - (constK[1] + constK[2]) * disp[2]) / mass[2];
            vel[i] += acc[i] * timeStep;
            pos[i] += vel[i] * timeStep;
          }

          if (cnt == 0)
          {//interval回に1回保存
            DISP[1, count] = disp[1];
            DISP[2, count] = disp[2];
            count++;
          }
          cnt++;
          if (cnt == interval) cnt = 0;

          time += timeStep;

        }
        MessageBox.Show("time = " + time.ToString() + ",  count = " + count.ToString());
        drawGraph2(DISP);
      }
      else if (freedom == 3)
      {
        mass[1] = Convert.ToDouble(txtMass1.Text);
        mass[2] = Convert.ToDouble(txtMass2.Text);
        mass[3] = Convert.ToDouble(txtMass3.Text);
        disp[1] = Convert.ToDouble(txtDisp1.Text);
        disp[2] = Convert.ToDouble(txtDisp2.Text);
        disp[3] = Convert.ToDouble(txtDisp3.Text);

        time = 0.0;
        count = 0;
        cnt = 0;
        //初期状態
        leng[0] = length0 + disp[1];
        leng[1] = length0 - disp[1] + disp[2];
        leng[2] = length0 - disp[2] + disp[3];

        vel[1] = 0.0;
        vel[2] = 0.0;
        vel[3] = 0.0;
        pos0[1] = -length0 / 2.0;
        pos0[2] = length0 / 2.0;
        pos0[3] = 3.0 * length0 / 2.0;
        pos[1] = pos0[1] + disp[1];
        pos[2] = pos0[2] + disp[2];
        pos[3] = pos0[3] + disp[3];

        while (time <= actTime && count < NUM_MAX)
        {
          //おもりの変位量
          disp[1] = pos[1] - pos0[1];
          disp[2] = pos[2] - pos0[2];
          disp[3] = pos[3] - pos0[3];

          for (int i = 1; i <= 3; i++)
          {
            if (i == 1)
              acc[1] = (-(constK[0] + constK[1]) * disp[1] + constK[1] * disp[2]) / mass[1];
            else if (i == 2)
              acc[2] = (constK[1] * disp[1] - (constK[1] + constK[2]) * disp[2] + constK[2] * disp[3]) / mass[2];
            else
              acc[3] = (constK[2] * (disp[2] - disp[3])) / mass[3];
            vel[i] += acc[i] * timeStep;
            pos[i] += vel[i] * timeStep;
          }

          if (cnt == 0)
          {//interval回に1回保存
            DISP[1, count] = disp[1];
            DISP[2, count] = disp[2];
            DISP[3, count] = disp[3];
            //MessageBox.Show("disp = " + disp[1].ToString() + "   constK=" + constK.ToString() + "   timeStep" + timeStep.ToString());
            count++;
          }
          cnt++;
          if (cnt == interval) cnt = 0;

          time += timeStep;
        }
        MessageBox.Show("time = " + time.ToString() + ",  count = " + count.ToString());
        //MessageBox.Show("DISP[1,0] = " + DISP[1,0].ToString() + "    DISP[1,10] = " + DISP[1,10].ToString());
        drawGraph3(DISP);
      }
    }
    //--------------------------------------------------------------------------------------------
    private void drawGraph2(double[,] DISP)
    {
      int i;
      float x0, y0, x1, y1, x2, y2;

      float amp = Convert.ToSingle(txtAmplitude.Text);
      float scale = (float)(0.2 * picSpace.Height / amp);

      picSpace.Image = new Bitmap(picSpace.Width, picSpace.Height);
      Graphics g = Graphics.FromImage(picSpace.Image);
      g.Clear(Color.White);

      //左端位置
      x0 = 50.0f;

      //disp[1]の描画
      y0 = (float)(picSpace.Height / 4.0f);

      Pen pen = new Pen(Color.Blue, 1);
      //縦軸
      g.DrawLine(pen, x0, y0 - (float)(amp * scale), x0, y0 + (float)(amp * scale));
      //横軸
      g.DrawLine(pen, x0, y0, x0 + (float)NUM_MAX, y0);
      //縦軸目盛
      g.DrawLine(pen, x0, y0 - (float)(amp * scale), x0 - 5.0f, y0 - (float)(amp * scale));
      g.DrawString(Convert.ToString(amp), new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 30, y0 - (float)(amp * scale + 10.0));
      g.DrawString("0", new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 20, y0 - 10);
      g.DrawString("-" + Convert.ToString(amp), new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 35, y0 + (float)(amp * scale - 10.0));
      g.DrawLine(pen, x0, y0 + (float)(amp * scale), x0 - 5.0f, y0 + (float)(amp * scale));
      //横軸目盛
      g.DrawLine(pen, x0 + 500, y0, x0 + 500, y0 - 20);
      g.DrawLine(pen, x0 + 250, y0, x0 + 250, y0 - 20);
      if (numData != 500) MessageBox.Show("numData=500としてください");
      if (actTime == 500.0) g.DrawString("500s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 200.0) g.DrawString("200s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 100.0) g.DrawString("100s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 480, y0 + 5);
      else if (actTime == 50.0) g.DrawString("50s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 20.0) g.DrawString("20s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 10.0) g.DrawString("10s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);

      //変位描画
      pen = new Pen(Color.Black, 2);
      x1 = x0;
      y1 = y0 - (float)(DISP[1, 0] * scale);

      for (i = 1; i < NUM_MAX; i++)
      {
        x2 = x0 + i;
        y2 = y0 - (float)(DISP[1, i] * scale);
        g.DrawLine(pen, x1, y1, x2, y2);
        x1 = x2; y1 = y2;
      }
      //凡例
      g.DrawString("disp[1]", new Font("Century", 10), new SolidBrush(Color.Black), 90, 5);

      //disp[2]の描画
      y0 = (float)(3.0f * picSpace.Height / 4.0f);
      pen = new Pen(Color.Blue, 1);
      //縦軸
      g.DrawLine(pen, x0, y0 - (float)(amp * scale), x0, y0 + (float)(amp * scale));
      //横軸
      g.DrawLine(pen, x0, y0, x0 + (float)NUM_MAX, y0);
      //縦軸目盛
      g.DrawLine(pen, x0, y0 - (float)(amp * scale), x0 - 5.0f, y0 - (float)(amp * scale));
      g.DrawString(Convert.ToString(amp), new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 30, y0 - (float)(amp * scale + 10.0));
      g.DrawString("0", new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 20, y0 - 10);
      g.DrawString("-" + Convert.ToString(amp), new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 35, y0 + (float)(amp * scale - 10.0));
      g.DrawLine(pen, x0, y0 + (float)(amp * scale), x0 - 5.0f, y0 + (float)(amp * scale));
      //横軸目盛
      g.DrawLine(pen, x0 + 500, y0, x0 + 500, y0 - 20);
      g.DrawLine(pen, x0 + 250, y0, x0 + 250, y0 - 20);
      if (numData != 500) MessageBox.Show("numData=500としてください");
      if (actTime == 500.0) g.DrawString("500s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 200.0) g.DrawString("200s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 100.0) g.DrawString("100s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 480, y0 + 5);
      else if (actTime == 50.0) g.DrawString("50s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 20.0) g.DrawString("20s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 10.0) g.DrawString("10s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);

      //変位描画
      pen = new Pen(Color.Black, 2);
      x1 = x0;
      y1 = y0 - (float)(DISP[2, 0] * scale);

      for (i = 1; i < NUM_MAX; i++)
      {
        x2 = x0 + i;
        y2 = y0 - (float)(DISP[2, i] * scale);
        g.DrawLine(pen, x1, y1, x2, y2);
        x1 = x2; y1 = y2;
      }
      //凡例
      g.DrawString("disp[2]", new Font("Century", 10), new SolidBrush(Color.Black), 90, 5 + picSpace.Height / 2.0f);

      g.Dispose();
      picSpace.Invalidate();
    }
    //----------------------------------------------------------------------------------------------
    private void drawGraph3(double[,] DISP)
    {
      int i;
      float x0, y0, x1, y1, x2, y2;

      float amp = Convert.ToSingle(txtAmplitude.Text);
      float scale = (float)(0.15 * picSpace.Height / amp);

      picSpace.Image = new Bitmap(picSpace.Width, picSpace.Height);
      Graphics g = Graphics.FromImage(picSpace.Image);
      g.Clear(Color.White);

      //左端位置
      x0 = 50.0f;

      //disp[1]の描画
      y0 = (float)(picSpace.Height / 6.0f);

      Pen pen = new Pen(Color.Blue, 1);
      //縦軸
      g.DrawLine(pen, x0, y0 - (float)(amp * scale), x0, y0 + (float)(amp * scale));
      //横軸
      g.DrawLine(pen, x0, y0, x0 + (float)NUM_MAX, y0);
      //縦軸目盛
      g.DrawLine(pen, x0, y0 - (float)(amp * scale), x0 - 5.0f, y0 - (float)(amp * scale));
      g.DrawString(Convert.ToString(amp), new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 30, y0 - (float)(amp * scale + 10.0));
      g.DrawString("0", new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 20, y0 - 10);
      g.DrawString("-" + Convert.ToString(amp), new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 35, y0 + (float)(amp * scale - 10.0));
      g.DrawLine(pen, x0, y0 + (float)(amp * scale), x0 - 5.0f, y0 + (float)(amp * scale));
      //横軸目盛
      g.DrawLine(pen, x0 + 500, y0, x0 + 500, y0 - 20);
      g.DrawLine(pen, x0 + 250, y0, x0 + 250, y0 - 20);
      //g.DrawString("-" + Convert.ToString(amp), new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 35, y0 + (float)(amp * scale - 10.0));
      if (numData != 500) MessageBox.Show("numData=500としてください");
      if (actTime == 500.0) g.DrawString("500s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 200.0) g.DrawString("200s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 100.0) g.DrawString("100s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 480, y0 + 5);
      else if (actTime == 50.0) g.DrawString("50s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 20.0) g.DrawString("20s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 10.0) g.DrawString("10s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);

      //変位描画
      pen = new Pen(Color.Black, 2);
      x1 = x0;
      y1 = y0 - (float)(DISP[1, 0] * scale);

      for (i = 1; i < NUM_MAX; i++)
      {
        x2 = x0 + i;
        y2 = y0 - (float)(DISP[1, i] * scale);
        g.DrawLine(pen, x1, y1, x2, y2);
        x1 = x2; y1 = y2;
      }
      //凡例
      g.DrawString("disp[1]", new Font("Century", 10), new SolidBrush(Color.Black), 90, 5);

      //disp[2]の描画
      y0 = (float)(3.0f * picSpace.Height / 6.0f);
      pen = new Pen(Color.Blue, 1);
      //縦軸
      g.DrawLine(pen, x0, y0 - (float)(amp * scale), x0, y0 + (float)(amp * scale));
      //横軸
      g.DrawLine(pen, x0, y0, x0 + (float)NUM_MAX, y0);
      //縦軸目盛
      g.DrawLine(pen, x0, y0 - (float)(amp * scale), x0 - 5.0f, y0 - (float)(amp * scale));
      g.DrawString(Convert.ToString(amp), new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 30, y0 - (float)(amp * scale + 10.0));
      g.DrawString("0", new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 20, y0 - 10);
      g.DrawString("-" + Convert.ToString(amp), new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 35, y0 + (float)(amp * scale - 10.0));
      g.DrawLine(pen, x0, y0 + (float)(amp * scale), x0 - 5.0f, y0 + (float)(amp * scale));
      //横軸目盛
      g.DrawLine(pen, x0 + 500, y0, x0 + 500, y0 - 20);
      g.DrawLine(pen, x0 + 250, y0, x0 + 250, y0 - 20);
      //g.DrawString("-" + Convert.ToString(amp), new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 35, y0 + (float)(amp * scale - 10.0));
      if (numData != 500) MessageBox.Show("numData=500としてください");
      if (actTime == 500.0) g.DrawString("500s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 200.0) g.DrawString("200s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 100.0) g.DrawString("100s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 480, y0 + 5);
      else if (actTime == 50.0) g.DrawString("50s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 20.0) g.DrawString("20s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 10.0) g.DrawString("10s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);

      //変位描画
      pen = new Pen(Color.Black, 2);
      x1 = x0;
      y1 = y0 - (float)(DISP[2, 0] * scale);

      for (i = 1; i < NUM_MAX; i++)
      {
        x2 = x0 + i;
        y2 = y0 - (float)(DISP[2, i] * scale);
        g.DrawLine(pen, x1, y1, x2, y2);
        x1 = x2; y1 = y2;
      }
      //凡例
      g.DrawString("disp[2]", new Font("Century", 10), new SolidBrush(Color.Black), 90, 5 + picSpace.Height / 3.0f);

      //disp[3]の描画
      y0 = (float)(5.0f * picSpace.Height / 6.0f);
      pen = new Pen(Color.Blue, 1);
      //縦軸
      g.DrawLine(pen, x0, y0 - (float)(amp * scale), x0, y0 + (float)(amp * scale));
      //      g.DrawLine(pen, x0, y0 * 1.8f, x0, y0 * 0.2f);
      //横軸
      g.DrawLine(pen, x0, y0, x0 + (float)NUM_MAX, y0);
      //縦軸目盛
      g.DrawLine(pen, x0, y0 - (float)(amp * scale), x0 - 5.0f, y0 - (float)(amp * scale));
      g.DrawString(Convert.ToString(amp), new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 30, y0 - (float)(amp * scale + 10.0));
      g.DrawString("0", new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 20, y0 - 10);
      g.DrawString("-" + Convert.ToString(amp), new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 35, y0 + (float)(amp * scale - 10.0));
      g.DrawLine(pen, x0, y0 + (float)(amp * scale), x0 - 5.0f, y0 + (float)(amp * scale));
      //横軸目盛
      g.DrawLine(pen, x0 + 500, y0, x0 + 500, y0 - 20);
      g.DrawLine(pen, x0 + 250, y0, x0 + 250, y0 - 20);
      //g.DrawString("-" + Convert.ToString(amp), new Font("Century", 10), new SolidBrush(Color.Blue), x0 - 35, y0 + (float)(amp * scale - 10.0));
      if (numData != 500) MessageBox.Show("numData=500としてください");
      if (actTime == 500.0) g.DrawString("500s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 200.0) g.DrawString("200s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 100.0) g.DrawString("100s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 480, y0 + 5);
      else if (actTime == 50.0) g.DrawString("50s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 20.0) g.DrawString("20s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);
      else if (actTime == 10.0) g.DrawString("10s", new Font("Century", 10), new SolidBrush(Color.Blue), x0 + 485, y0 + 5);

      //変位描画
      pen = new Pen(Color.Black, 2);
      x1 = x0;
      y1 = y0 - (float)(DISP[3, 0] * scale);

      for (i = 1; i < NUM_MAX; i++)
      {
        x2 = x0 + i;
        y2 = y0 - (float)(DISP[3, i] * scale);
        g.DrawLine(pen, x1, y1, x2, y2);
        x1 = x2; y1 = y2;
      }
      //凡例
      g.DrawString("disp[3]", new Font("Century", 10), new SolidBrush(Color.Black), 90, 5 + 2.0f * picSpace.Height / 3.0f);
      g.Dispose();
      picSpace.Invalidate();
    }
    //--------------------------------------------------------------------------------
    private void cmbFreedom_SelectedIndexChanged(object sender, EventArgs e)
    {
      freedom = Convert.ToInt32(cmbFreedom.Text);
      if (freedom == 2)
      {
        txtMass3.Visible = false;
        txtDisp3.Visible = false;
        picSpace.Height = 300;
      }
      else if (freedom == 3)
      {
        txtMass3.Visible = true;
        txtDisp3.Visible = true;
        picSpace.Height = 460;
      }
    }

  }
}