/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

AUq
Euler@
GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

//eNX`t@C
#define FILENAME_IN "../../bmp/check3.bmp"

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath5.h"
#include "../../myPrimitive5.h"
#include "../../myTexture5.h"
#include "../../bmpLoadSave.h"
#include "../../rigid.h"
#include "../../setup.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTexture();

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];

//^CXebv̋}ȕωɑΉ邽߂Ұ
double timeStep, timeStep0, timeStep1;

//VF[_vO
GLuint shaderProg;

double heightFix = 2.0;
double theta1, theta2;
CVector vPos1, vPos2, vVel1, vVel2;
CVector vPosFix1, vPosFix2;

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("SL_CoupledPendula");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ݒ
	init();
	initGlsl(&shaderProg, "../../shading.vert", "../../shading.frag");

	setupGLUI();//myGLUI.hɎ
	GLUI_Master.set_glutIdleFunc( idle );

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
	glDeleteProgram(shaderProg);
	deleteDisplayLists();
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.2, 0.2, 0.3, 1.0);

	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist= 5.0;
	view.vCnt = CVector(0.0, 0.0, 1.5);
	view.theta = 10.0;
	view.phi = 0.0;
	setCamera();
	view0 = view;
	//parameters
	viscous = 0.0;
	muK = 0.0;
	timeRate = 1.0;

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	//eNX`[
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	setTexture();

	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initObject();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
}

void initObject()
{	
	flagFreeze = false;
	flagOneStep = false;

	countStrobo = 0;
	timeStrobo = 0.0;
	numRigid0 = 2;
	numRigid = numRigid0 + numStrobo;

	//Uq^p[^̏l
	theta1 = theta10 * DEG_TO_RAD;//XΊp(radɕϊ)
	theta2 = theta20 * DEG_TO_RAD;//XΊp(radɕϊ)
	//yW
	double y10 = length1 * sin(theta1);
	double y20 = length2 * sin(theta2);
	//̂̍
	double height1 = heightFix - length1 * cos(theta1);
	double height2 = heightFix - length2 * cos(theta2);
	//ʒu
	vPos1 = CVector(0.0, -length0 / 2.0 + y10, height1);
	vPos2 = CVector(0.0,  length0 / 2.0 + y20, height2);
	//x
	vVel1 = CVector(velX10, velY10, 0.0);
	vVel2 = CVector(velX20, velY20, 0.0);
	//Œ_
	vPosFix1 = CVector(0.0, -length0 / 2.0, heightFix);
	vPosFix2 = CVector(0.0,  length0 / 2.0, heightFix);

	numSpring = 1;
	spring[0] = CSpring();
	spring[0].num3 = 20;//
	//spring[0].kind = S_CYLINDER;
	spring[0].kind = S_SPRING;
	spring[0].length0 = length0;//R
	spring[0].length = vDist(vPos1, vPos2);
	spring[0].vPos = (vPos1 + vPos2) / 2.0;
	spring[0].vEuler = getEulerZ(vPos1, vPos2);

	numRigid0 = 5;
	numRigid = numRigid0 + numStrobo;

	//́i_j̏ݒ
	int i;
	for(i = 0; i < numRigid; i++)	rigid[i] = CRigid();
	//Œ_
	rigid[0].kind = BOX;
	rigid[0].color = DARK_RED;
	rigid[0].vSize = CVector(0.2, 2.0, 0.1);
	rigid[0].vPos = CVector(0.0, 0.0, heightFix+rigid[0].vSize.z/2.0);
	//1
	rigid[1].kind = SPHERE;
	rigid[1].color = CYAN;
	rigid[1].vSize = CVector(0.15, 0.15, 0.15);
	rigid[1].vPos = vPos1;
	rigid[1].vEuler = getEulerZ(rigid[1].vPos, vPosFix1);//莩g̉]p
	//2
	rigid[2].kind = SPHERE;
	rigid[2].color = CYAN;
	//rigid[1].mass = mass1;
	rigid[2].vSize = CVector(0.15, 0.15, 0.15);
	rigid[2].vPos = vPos2;
	rigid[2].vEuler = getEulerZ(rigid[2].vPos, vPosFix2);//莩g̉]p
	//Uq1̖_
	rigid[3].kind = CYLINDER;
	rigid[3].vSize = CVector(0.025, 0.025, length1);
	rigid[3].vPos = CVector(rigid[1].vPos.x / 2.0,- length0/2.0 +y10 / 2.0, (heightFix + height1) / 2.0);
	rigid[3].vEuler = rigid[1].vEuler;  
	//Uq2̖_
	rigid[4].kind = CYLINDER;
	rigid[4].vSize = CVector(0.025, 0.025, length2);
	rigid[4].vPos = CVector(rigid[2].vPos.x / 2.0, length0/2.0 + y20 / 2.0, (heightFix + height2) / 2.0);
	rigid[4].vEuler = rigid[2].vEuler;  

	//strobo
	for(i = numRigid0; i < numRigid; i++) 
	{
		rigid[i].color = MAGENTA;
		rigid[i].vSize = CVector(0.03, 0.03, 0.03);
		rigid[i].vPos = CVector(1000.0, 1000.0, 1000.0);
	}

	rigid[1].select = 1;

	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
}

void setTexture()
{
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̎w 
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
	//eNX`̌JԂ@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
	//eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	static int countStrobo = 0;
	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
	  gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)
	{
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	glUseProgram(shaderProg);
	GLint imageLoc = glGetUniformLocation(shaderProg, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint wireLoc = glGetUniformLocation(shaderProg, "flagWire");
	glUniform1i(wireLoc, flagWireframe);
	GLint selLoc = glGetUniformLocation(shaderProg, "select");

	for(int i = 0; i < numRigid0; i++) 
	{
		if(rigid[i].select == 1) glUniform1i(selLoc, 1);
		else glUniform1i(selLoc, 0);

		rigid[i].draw(false);
	}
	spring[0].draw(false);
	glUniform1i(selLoc, 0);
	if(flagStrobo)
		for(int i = numRigid0; i < numRigid; i++) rigid[i].draw(false);

	glUseProgram(0);

	timeStep = timeRate * dt;
	//^CXebv}ɕωƂꎞt[YԂɂ
	if(timeStep < 1.2 * timeStep1 || timeStep > 0.8 * timeStep1) flagFreeze0 = false;
	if(timeStep > 5.0 * timeStep0 || timeStep < timeStep0 / 5.0) 
	{
		flagFreeze0 = true;
		timeStep1 = timeStep0;//̂Ƃ̕ωÕ^CXebvێ
	}
	timeStep0 = timeStep;//̃^CXebvێ

	double cc1, cc2, y1, y2, h1, h2;
	double len, disp, omega1, omega2, tt;
	CVector vAcc1, vAcc2, vTension1, vTension2,vDir1,vDir2,vDir0;
	double theta01 = theta1;//O^CXebv̐Up
	double theta02 = theta2;
	
	if(flagStart==true && flagFreeze == false && flagFreeze0 == false) 
	{
		tt = timeStep / 1000.0;
		for(int i = 0; i < 1000; i++)
		{
			//IC[@
			y1 = vDist(CVector(0.0,-length0/2.0, vPos1.z), vPos1);
			h1 = heightFix - vPos1.z;
			y2 = vDist(CVector(0.0, length0/2.0, vPos2.z), vPos2); 		
			h2 = heightFix - vPos2.z;
			theta1 = atan2(y1, h1);
			theta2 = atan2(y2, h2);
			omega1 = (theta1 - theta01) / tt;
			omega2 = (theta2 - theta02) / tt;
			cc1 = cos(theta1);
			cc2 = cos(theta2);
			//_̒PʃxNg
			vDir1 = vPos1 >> vPosFix1;
			vDir2 = vPos2 >> vPosFix2;
			//
			vTension1 = (length1 * omega1 * omega1 + gravity * cc1) * vDir1;//mass1͏Ă
			vTension2 = (length2 * omega2 * omega2 + gravity * cc2) * vDir2;//mass2͏Ă
			
			len = vDist(vPos1, vPos2);//ol̒
			if(flagLimit) {
				if(len < 0.5 * length0) len = 0.5 * length0;
				if(len > 2.0 * length0) len = 2.0 * length0;
			}
			disp = len - length0;     //ψ
			vDir0 = vPos1 >> vPos2;//ol̒PʃxNg
			vAcc1 = vTension1 + constK * disp *vDir0 / mass1 + CVector(0.0, 0.0, -gravity) - (viscous/mass1) * vVel1;
			vAcc2 = vTension2 - constK * disp *vDir0 / mass2 + CVector(0.0, 0.0, -gravity) - (viscous/mass2) * vVel2;

			vVel1 += vAcc1 * tt;
			vVel2 += vAcc2 * tt;
			vPos1 += vVel1 * tt;
			vPos2 += vVel2 * tt;
			//Œ_ړȂ悤ɂWUp狁߂
			vPos1.z = heightFix - length1 * cc1;
			vPos2.z = heightFix - length2 * cc2;
			if(vPos1.z >  heightFix -0.2) vPos1.z =  heightFix -0.2;
			if(vPos2.z >  heightFix -0.2) vPos2.z =  heightFix -0.2;
			theta01 = theta1;
			theta02 = theta2;

		}
		//
		rigid[1].vPos = vPos1;
		rigid[1].vEuler = getEulerZ( vPos1, vPosFix1);
		rigid[2].vPos = vPos2;
		rigid[2].vEuler = getEulerZ( vPos2, vPosFix2);
		//_
		rigid[3].vPos = (vPos1 + vPosFix1) / 2.0;
		rigid[3].vEuler = rigid[1].vEuler;
		rigid[4].vPos = (vPos2 + vPosFix2) / 2.0;
		rigid[4].vEuler = rigid[2].vEuler;
		spring[0].length = len;
		spring[0].vPos = (vPos1 + vPos2) / 2.0;
		spring[0].vEuler = getEulerZ(vPos1, vPos2);

		if(flagOneStep) flagFreeze = true;

		elapseTime2 += timeStep;

		//Strobo
		if(countStrobo < numStrobo)
		{
			if( timeStrobo == 0.0) 
			{
				rigid[numRigid0 + countStrobo].vPos = rigid[1].vPos;
			}

			timeStrobo += timeStep;
			if(timeStrobo >= periodStrobo) {timeStrobo = 0.0; countStrobo ++;}
			if(countStrobo >= numStrobo) countStrobo = 0;
		}
	}

	if(flagFloor) glCallList(floor0);//En
	if(flagShadow) drawShadow();       //e
	if(flagCoordShow) 
	{
		drawWorldCoordinates(0.5);   //[hԂ̍W
	}

	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", (int)((double)fps0 / timeRate), 10, 30);
		drawParam("timestep=%1.5f[s]", timeRate/fps0, 200, 30);
		drawParam("elapsetime=%3.3f[s]", elapseTime2, 400, 30);
	}
	//obt@̐؂ւ
	glutSwapBuffers();
}

