
#include "../../spring.h"

int numPoint;
int type = 1;
int mode = 0;
int rootNo;

class CSpringMass
{
public:
    CVector vPos;
	float speed;//isx
	float mass;//_P̎
    float constK;
	float drctnK;
	float damping;
	float drag;
    float length0;  //sprinĝP莩R
    float radius ;//a
	float direction, direction0;//isix̌oxCdegj
	double theta1;//OXp
	double theta2;//Xp

    CVector vForce0;//O͂̏l
	CSpring spring[MAX_SPRING];
	CRigid point[MAX_SPRING + 1];

    //o֐
    CSpringMass();
    void draw(bool flagShadow);
    void create();
    void calcSpringMass(double dt);
	void action0(double dt, double time);
	void action1(double dt, double time);
	void action2(double dt, double time);
private:
};
CSpringMass sm;
//---------------------------------------------------------------
CSpringMass::CSpringMass()
{
    vPos = CVector();
    length0 = 1.0;
	constK = 1000.0;
	drctnK = 100.0;
	mass = 1.0;
	drag = 0.0;
	damping = 0.0;
    radius = 0.03;
	theta1 = 20.0;//OXp
	theta2 = -10.0;//Xp
	vForce0 = CVector();
}
//-----------------------------------------------------------------
void CSpringMass::draw(bool flagShadow)
{
    int i;
    int r1, r2;

    //΂ˎ_\
    //_
    for(i = 0; i < numPoint; i++) {
        point[i].color = CYAN;
        if(point[i].flagFixed == true){
           // point[i].color= RED;
        }
        point[i].draw(flagShadow);
    }
    for(i = 0; i < numSpring; i++)
    {
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        spring[i].vPos = (point[r1].vPos + point[r2].vPos) / 2.0;
        spring[i].length = vDist(point[r1].vPos, point[r2].vPos);
        spring[i].vEuler = getEulerZ(point[r1].vPos, point[r2].vPos);
        spring[i].draw(flagShadow);
    }
}
//-----------------------------------------------------------------
void CSpringMass::create()
{
    int i, n1, n2;

	if(type == 0)
	{//4
		numSpring = 12;
		numPoint = 13;
		float wid = 0.2 * length0;
		float lenTrunk = 0.5 * length0;
		rootNo = 5;//S

		//point
		//㑫
		point[0].vPos = CVector(-wid, -lenTrunk, radius) + vPos;//
		point[1].vPos = CVector( wid, -lenTrunk, radius) + vPos;//E
		point[0].vSize = point[1].vSize = CVector(2.0, 2.0, 2.0) * radius;
		//
		point[2].vPos = CVector(-wid, -lenTrunk, radius + length0) + vPos;//
		point[3].vPos = CVector( wid, -lenTrunk, radius + length0) + vPos;//E
		point[2].vSize = point[3].vSize = CVector(3.0, 3.0, 3.0) * radius;
		//㓷
		point[4].vPos = CVector( 0.0, -lenTrunk, radius + length0) + vPos;
		point[4].vSize = CVector(5.0, 5.0, 5.0) * radius;
		//S
		point[5].vPos = CVector( 0.0, 0.0, radius + length0) + vPos;
		point[5].vSize = CVector(5.0, 5.0, 5.0) * radius;
		//O
		point[6].vPos = CVector( 0.0, lenTrunk, radius + length0) + vPos;
		point[6].vSize = CVector(5.0, 5.0, 5.0) * radius;
		//
		point[7].vPos = CVector( 0.0, 2.0*lenTrunk, radius + 1.5*length0) + vPos;//
		point[7].vSize = CVector(8.0, 8.0, 8.0) * radius;
		//
		point[8].vPos = CVector(-wid, lenTrunk, radius + length0) + vPos;//
		point[9].vPos = CVector( wid, lenTrunk, radius + length0) + vPos;//E
		point[8].vSize = point[9].vSize = CVector(3.0, 3.0, 3.0) * radius;
		//O
		point[10].vPos = CVector(-wid, lenTrunk, radius) + vPos;
		point[11].vPos = CVector( wid, lenTrunk, radius) + vPos;
		point[10].vSize = point[11].vSize = CVector(2.0, 2.0, 2.0) * radius;
		//̐[
		point[12].vPos = CVector( 0, -lenTrunk*1.8, radius + length0 * 1.2) + vPos;
		point[12].vSize = CVector(2.0, 3.0, 3.0) * radius;

		//spring
		//r(spring)
		spring[0].row1 = 0; spring[0].row2 = 2;//
		spring[1].row1 = 1; spring[1].row2 = 3;//E
		//(spring)
		spring[2].row1 = 2; spring[2].row2 = 4;//
		spring[3].row1 = 4; spring[3].row2 = 3;//E
		//w
		spring[4].row1 = 4; spring[4].row2 = 5;
		//Ow
		spring[5].row1 = 5; spring[5].row2 = 6;
		//
		spring[6].row1 = 6; spring[6].row2 = 7;
		//
		spring[7].row1 = 8; spring[7].row2 = 6;
		spring[8].row1 = 6; spring[8].row2 = 9;
		//Or
		spring[9].row1  = 8; spring[9].row2  = 10;//
		spring[10].row1 = 9; spring[10].row2 = 11;//E
		//
		spring[11].row1 = 4; spring[11].row2 = 12;
	}

	else if(type == 1)
	{//6(j
		numSpring = 16;
		numPoint = 17;
		float wid = 0.2 * length0;
		float lenTrunk = 0.5 * length0;
		rootNo = 9;//S
		//point
		//㑫
		point[0].vPos = CVector(-2.0*wid, -lenTrunk, radius) + vPos;//
		point[1].vPos = CVector( 2.0*wid, -lenTrunk, radius) + vPos;//E
		point[0].vSize = point[1].vSize = CVector(2.0, 2.0, 2.0) * radius;
		//G
		point[2].vPos = CVector(-wid, -lenTrunk, radius + length0) + vPos;//
		point[3].vPos = CVector( wid, -lenTrunk, radius + length0) + vPos;//E
		point[2].vSize = point[3].vSize = CVector(1.5, 1.5, 1.5) * radius;
		//㓷
		point[4].vPos = CVector( 0.0, -lenTrunk, radius + length0 * 0.7) + vPos;
		point[4].vSize = CVector(5.0, 5.0, 5.0) * radius;
		//
		point[5].vPos = CVector(-1.5*wid, 0.0, radius) + vPos;//
		point[6].vPos = CVector( 1.5*wid, 0.0, radius) + vPos;//E
		point[5].vSize = point[6].vSize = CVector(2.0, 2.0, 2.0) * radius;
		//G
		point[7].vPos = CVector(-wid, 0.0, radius + length0) + vPos;//
		point[8].vPos = CVector( wid, 0.0, radius + length0) + vPos;//E
		point[7].vSize = point[8].vSize = CVector(1.5, 1.5, 1.5) * radius;
		//S
		point[9].vPos = CVector( 0.0, 0.0, radius + length0 * 0.7) + vPos;
		point[9].vSize = CVector(3.0, 3.0, 3.0) * radius;
		//O
		point[10].vPos = CVector(-2.0*wid, lenTrunk, radius) + vPos;//
		point[11].vPos = CVector( 2.0*wid, lenTrunk, radius) + vPos;//E
		point[10].vSize = point[11].vSize = CVector(2.0, 2.0, 2.0) * radius;
		//OIiGj
		point[12].vPos = CVector(-wid, lenTrunk, radius + length0*1.2) + vPos;//
		point[13].vPos = CVector( wid, lenTrunk, radius + length0*1.2) + vPos;//E
		point[12].vSize = point[13].vSize = CVector(1.5, 1.5, 1.5) * radius;
		//O
		point[14].vPos = CVector( 0.0, lenTrunk, radius + length0) + vPos;
		point[14].vSize = CVector(5.0, 5.0, 5.0) * radius;
		//
		point[15].vPos = CVector( 0.0, 2.0*lenTrunk, radius + 1.5*length0) + vPos;//
		point[15].vSize = CVector(8.0, 8.0, 8.0) * radius;
		//̐[
		point[16].vPos = CVector( 0, -lenTrunk*1.8, radius + length0 * 1.0) + vPos;
		point[16].vSize = CVector(2.0, 3.0, 3.0) * radius;

		//spring
		//
		spring[0].row1 = 0; spring[0].row2 = 2;//
		spring[1].row1 = 1; spring[1].row2 = 3;//E
		//
		spring[2].row1 = 2; spring[2].row2 = 4;//
		spring[3].row1 = 3; spring[3].row2 = 4;//E
		//
		spring[5].row1 = 5; spring[5].row2 = 7;//
		spring[6].row1 = 6; spring[6].row2 = 8;//E
		//
		spring[7].row1 = 7; spring[7].row2 = 9;//
		spring[8].row1 = 8; spring[8].row2 = 9;//E
		//O
		spring[10].row1 = 10; spring[10].row2 = 12;//
		spring[11].row1 = 11; spring[11].row2 = 13;//E
		//O
		spring[12].row1 = 12; spring[12].row2 = 14;//
		spring[13].row1 = 13; spring[13].row2 = 14;//E
		//w
		spring[4].row1 = 4; spring[4].row2 = 9;
		//Ow
		spring[9].row1 = 9; spring[9].row2 = 14;
		//
		spring[14].row1 = 14; spring[14].row2 = 15;
		//
		spring[15].row1 = 4; spring[15].row2 = 16;
	}

	else if(type == 2)
	{//^
		numSpring = 21;
		numPoint = 22;
		float len1 = 0.25 * length0;
		float wid = 0.2 * length0;
		rootNo = 5;

		double lambda = 1.3 * length0;
		//_̈ʒu
		for(i = 0; i <= 9; i++)
		{//wíj
			point[i].vPos = CVector(0.0, -(float)(i-5) * len1, radius + length0 - (float)(i-5) * len1 + 0.2 * cos(2.0 * M_PI * (double)(i-5)*len1 / double(lambda) + M_PI/3.0) ) + vPos;
			point[i].vSize = CVector(2.0, 2.0, 2.0) * radius;
			point[0].vSize = CVector(5.0, 5.0, 5.0) * radius;
		}
		//
		point[10].vPos = CVector(-wid, 0.0, radius + 1.2 * length0) + vPos;//
		point[11].vPos = CVector( wid, 0.0, radius + 1.2 * length0) + vPos;//E
		point[10].vSize = point[11].vSize = CVector(3.0, 3.0, 3.0) * radius;
		//G
		point[12].vPos = CVector(-wid, 0.0, radius + length0 * 0.6) + vPos;//
		point[13].vPos = CVector( wid, 0.0, radius + length0 * 0.6) + vPos;//E
		point[12].vSize = point[13].vSize = CVector(2.0, 2.0, 2.0) * radius;
		//
		point[14].vPos = CVector(-wid*length0, 0.0, radius) + vPos;//
		point[15].vPos = CVector( wid*length0, 0.0, radius) + vPos;//E
		point[14].vSize = point[15].vSize = CVector(2.0, 2.0, 2.0) * radius;
		//
		point[16].vPos = point[3].vPos + CVector(-wid, 0.0, 0.0);
		point[17].vPos = point[3].vPos + CVector( wid, 0.0, 0.0);
		point[16].vSize = point[17].vSize = CVector(2.0, 2.0, 2.0) * radius;
		//I
		point[18].vPos = point[16].vPos + CVector(0.0, 0.0, - length0 * 0.3);
		point[19].vPos = point[17].vPos + CVector(0.0, 0.0, - length0 * 0.3);
		point[18].vSize = point[19].vSize = CVector(2.0, 2.0, 2.0) * radius;
		//
		point[20].vPos = point[18].vPos + CVector(0.0, length0 * 0.2, length0 * 0.1);
		point[21].vPos = point[19].vPos + CVector(0.0, length0 * 0.2, length0 * 0.1);
		point[20].vSize = point[21].vSize = CVector(2.0, 2.0, 2.0) * radius;
	
		//spring
		for(i = 0; i <= 8; i++)
		{//w
			spring[i].row1 = i; spring[i].row2 = i+1;
		}
		//
		spring[9].row1 = 10; spring[9].row2 = 5;//
		spring[10].row1 = 5; spring[10].row2 = 11;//E
		
		//
		spring[11].row1 = 10; spring[11].row2 = 12;//
		spring[12].row1 = 11; spring[12].row2 = 13;//E
		//
		spring[13].row1 = 12; spring[13].row2 = 14;//
		spring[14].row1 = 13; spring[14].row2 = 15;//E

		//
		spring[15].row1 = 16; spring[15].row2 = 3;
		spring[16].row1 = 3; spring[16].row2 = 17;
		//r
		spring[17].row1 = 16; spring[17].row2 = 18;
		spring[18].row1 = 17; spring[18].row2 = 19;
		//Or
		spring[19].row1 = 18; spring[19].row2 = 20;
		spring[20].row1 = 19; spring[20].row2 = 21;
	}
	//ol̎RƕxNg
	for(i = 0; i < numSpring; i++)
	{
		n1 = spring[i].row1; n2 = spring[i].row2;
		spring[i].length0 = vDist(point[n1].vPos, point[n2].vPos);
		spring[i].vDir0 = point[n1].vPos >> point[n2].vPos;
	}

    //_̃TCY,
    for(int i = 0; i < numPoint; i++){
        point[i].kind = SPHERE;
		point[i].mass = mass;
    }
	//ol
    for(int i = 0; i < numSpring; i++){
		spring[i].radius = radius;
        spring[i].kind = S_CYLINDER;
	}

	//islyłȂƂ_̈ʒu/ol̕xNgς
	float alpha;
	alpha = direction - M_PI/2.0;
	float x0 = point[rootNo].vPos.x;
	float y0 = point[rootNo].vPos.y;
	if(alpha != 0.0)
	{
		for(i = 0; i < numSpring; i++) spring[i].vDir0.rotZ(alpha * RAD_TO_DEG);
		for(int i = 0; i < numPoint; i++) point[i].vPos.rotZ_rad( point[rootNo].vPos, alpha);
	}
}

//-----------------------------------------------------------------------------
//1̃ol}Xf(hinge springlCRԂŉ^)
void CSpringMass::calcSpringMass(double dt)
{                                           
    int i, r1, r2;
    CVector vDir1, vDir2;
    CVector vFF, vRelativeVelocity;
    float dampingF;
    //float len;
	double angle;
    CVector vNormal;

	//͂̑a
    //ݒl
    for(i = 0; i  < numPoint; i++)
        point[i].vForce = point[i].vForce0 + CVector(0.0, 0.0, -gravity * mass);

	//olɂ
    for(i = 0; i < numSpring; i++){
        //e
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;//#1#2ւ̒PʃxNg
        spring[i].length = vDist(point[r1].vPos, point[r2].vPos);
        vFF = (constK * (spring[i].length - spring[i].length0)) * vDir1 ;
        point[r1].vForce += vFF ;//vDirƓ
        point[r2].vForce -= vFF ;//Ε
        //
        vRelativeVelocity = point[r1].vVelocity - point[r2].vVelocity;
        dampingF = damping * vDot(vRelativeVelocity, vDir1);
        point[r1].vForce -= dampingF * vDir1;//ΑxƂ͔Ε
        point[r2].vForce += dampingF * vDir1;//
    }

	//oll
	for(i = 0; i < numSpring; i++)
	{
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;
        vNormal = vCross(spring[i].vDir0, vDir1);
		vDir2 = vCross(vNormal, vDir1);
		angle = getAngle(spring[i].vDir0, vDir1);
        vFF = drctnK * angle * vDir2 / spring[i].length;
        point[r1].vForce += vFF;//vDir2Ɠ
        point[r2].vForce -= vFF ;
	}


    //SRƏʏ,lvZ
    for(i = 0; i < numPoint; i++)
    {
        if(point[i].flagFixed == true) continue; //Œ

        //CSRiSĂ̎_ɈlƉ)
        point[i].vForce -= drag * point[i].vVelocity;

		//ʏ
        if(point[i].vPos.z < radius)
        {
			//ʂɂ鎿_ɑ΂Ăׂ͂薀C^
            point[i].vForce -= (muK * mass * gravity) * point[i].vVelocity.norm2();
            //ʏɐ
            point[i].vPos.z = radius;
            //Ƃ̏Փ
            if(point[i].vVelocity.z < 0.0){ //_ƏʂƂ͒eՓ˂Ƃ

                point[i].vVelocity.z = - restitut * point[i].vVelocity.z ;
            }
        }
        //Euler@
        //x
		point[i].vAccel = point[i].vForce / mass;
        //x
        point[i].vVelocity += point[i].vAccel * dt;

        //ʒu
        point[i].vPos += point[i].vVelocity * dt;
    }
	vPos = point[rootNo].vPos;
}

//----------------------------------------------------------------------------------
void CSpringMass::action0(double timeStep, double time)
{
	int i;
	double theta, dist;
	double thetaDegL, thetaDegR;
	CVector vDirection = CVector(cos(direction), sin(direction), 0.0);//is̃xNg

	//r̐itj
	dist = vDot(point[2].vPos - point[0].vPos, vDirection);
	//r̊px
	theta = atan2(dist, point[2].vPos.z - point[0].vPos.z); 
	thetaDegL = theta * RAD_TO_DEG;
	//Er̐itj
	dist = vDot(point[3].vPos - point[1].vPos, vDirection);
	//Er̊px
	theta = atan2(dist, point[3].vPos.z - point[1].vPos.z); 
	thetaDegR = theta * RAD_TO_DEG;

	for(i = 2; i < numPoint; i++)
	{
		point[i].vVelocity.x = speed * cos(direction);
		point[i].vVelocity.y = speed * sin(direction);
	}

	if(mode == 0)
	{//㍶/OEŒCE/Oo,
		point[0].flagFixed = true;//㍶
		point[11].flagFixed = true;//OE
		point[1].flagFixed = false;//E
		point[10].flagFixed = false;//O
		point[1].vVelocity.x = 2.0*speed * cos(direction);
		point[1].vVelocity.y = 2.0*speed * sin(direction);
		point[1].vForce0.z = 100.0 * mass;
		point[10].vVelocity.x = 2.0*speed * cos(direction);
		point[10].vVelocity.y = 2.0*speed * sin(direction);
		point[10].vForce0.z = 100.0 * mass;
		if(thetaDegL > theta1/2.0) mode = 1;
	}
	else if(mode == 1)
	{//㍶/OEŒCE/Oo,
		point[0].flagFixed = true;//㍶
		point[11].flagFixed = true;//OE
		point[1].flagFixed = false;//E
		point[10].flagFixed = false;//O
		point[1].vVelocity.x = 2.0*speed * cos(direction);
		point[1].vVelocity.y = 2.0*speed * sin(direction);
		point[1].vForce0.z = 0.0;
		point[10].vVelocity.x = 2.0*speed * cos(direction);
		point[10].vVelocity.y = 2.0*speed * sin(direction);
		point[10].vForce0.z = 0.0;
		if(thetaDegL > theta1) mode = 2;
	}
	else if(mode == 2)
	{//E/OŒC㍶/OEo
		point[0].flagFixed = false;
		point[11].flagFixed = false;
		point[1].flagFixed = true;
		point[10].flagFixed = true;
		point[0].vVelocity.x = 2.0*speed * cos(direction);
		point[0].vVelocity.y = 2.0*speed * sin(direction);
		point[0].vForce0.z = 200.0 * mass;
		point[11].vVelocity.x = 2.0*speed * cos(direction);
		point[11].vVelocity.y = 2.0*speed * sin(direction);
		point[11].vForce0.z = 100.0 * mass;
		if(thetaDegR > theta1/2.0) mode = 3;
	}
	else if(mode == 3)
	{//E/OŒC㍶/OEo
		point[0].flagFixed = false;
		point[11].flagFixed = false;
		point[1].flagFixed = true;
		point[10].flagFixed = true;
		point[0].vVelocity.x = 2.0*speed * cos(direction);
		point[0].vVelocity.y = 2.0*speed * sin(direction);
		point[0].vForce0.z = 0.0;
		point[11].vVelocity.x = 2.0*speed * cos(direction);
		point[11].vVelocity.y = 2.0*speed * sin(direction);
		point[11].vForce0.z = 0.0;
		if(thetaDegR > theta1) mode = 0;
	}

	//isωƂ_̈ʒu/ol̕xNgς
	double alpha = direction - direction0;
	if(alpha != 0.0)
	{
		for(i = 0; i < numSpring; i++) spring[i].vDir0.rotZ(alpha * RAD_TO_DEG);
		for(int i = 0; i < numPoint; i++) point[i].vPos.rotZ_rad( point[rootNo].vPos, alpha);
		direction0 = direction;
	}

	calcSpringMass(timeStep);
}

//----------------------------------------------------------------------------------
void CSpringMass::action1(double timeStep, double time)
{
	int i;
	double theta, dist;
	double thetaDegL, thetaDegR;
	CVector vDirection = CVector(cos(direction), sin(direction), 0.0);//is̃xNg

	//r̐itj
	dist = vDot(point[2].vPos - point[0].vPos, vDirection);
	//r̊px
	theta = atan2(dist, point[2].vPos.z - point[0].vPos.z); 
	thetaDegL = theta * RAD_TO_DEG;
	//Er̐itj
	dist = vDot(point[3].vPos - point[1].vPos, vDirection);
	//Er̊px
	theta = atan2(dist, point[3].vPos.z - point[1].vPos.z); 
	thetaDegR = theta * RAD_TO_DEG;

	for(i = 2; i < numPoint; i++)
	{
		point[i].vVelocity.x = speed * cos(direction);
		point[i].vVelocity.y = speed * sin(direction);
	}

	if(mode == 0)
	{//㍶/E/OŒCE//OEo
		point[0].flagFixed = true;//㍶
		point[6].flagFixed = true;//E
		point[10].flagFixed = true;//O
		point[1].flagFixed = false;//E
		point[5].flagFixed = false;//
		point[11].flagFixed = false;//OE
		point[1].vVelocity.x = 2.0*speed * cos(direction);
		point[1].vVelocity.y = 2.0*speed * sin(direction);
		point[1].vForce0.z = 100.0 * mass;
		point[5].vVelocity.x = 2.0*speed * cos(direction);
		point[5].vVelocity.y = 2.0*speed * sin(direction);
		point[5].vForce0.z = 100.0 * mass;
		point[11].vVelocity.x = 2.0*speed * cos(direction);
		point[11].vVelocity.y = 2.0*speed * sin(direction);
		point[11].vForce0.z = 100.0 * mass;
		if(thetaDegL > theta1/2.0) mode = 1;
	}
	else if(mode == 1)
	{//㍶/E/OŒCE//OEo
		point[0].flagFixed = true;//㍶
		point[6].flagFixed = true;//E
		point[10].flagFixed = true;//O
		point[1].flagFixed = false;//E
		point[5].flagFixed = false;//
		point[11].flagFixed = false;//OE
		point[1].vVelocity.x = 2.0*speed * cos(direction);
		point[1].vVelocity.y = 2.0*speed * sin(direction);
		point[1].vForce0.z = 0.0;
		point[5].vVelocity.x = 2.0*speed * cos(direction);
		point[5].vVelocity.y = 2.0*speed * sin(direction);
		point[5].vForce0.z = 0.0;
		point[11].vVelocity.x = 2.0*speed * cos(direction);
		point[11].vVelocity.y = 2.0*speed * sin(direction);
		point[11].vForce0.z = 0.0;
		if(thetaDegL > theta1) mode = 2;
	}
	else if(mode == 2)
	{//E//OEŒC㍶/E/Oo
		point[0].flagFixed = false;//㍶
		point[6].flagFixed = false;//E
		point[10].flagFixed = false;//O
		point[1].flagFixed = true;//E
		point[5].flagFixed = true;//
		point[11].flagFixed = true;//OE
		point[0].vVelocity.x = 2.0*speed * cos(direction);
		point[0].vVelocity.y = 2.0*speed * sin(direction);
		point[0].vForce0.z = 100.0 * mass;
		point[6].vVelocity.x = 2.0*speed * cos(direction);
		point[6].vVelocity.y = 2.0*speed * sin(direction);
		point[6].vForce0.z = 100.0 * mass;
		point[10].vVelocity.x = 2.0*speed * cos(direction);
		point[10].vVelocity.y = 2.0*speed * sin(direction);
		point[10].vForce0.z = 100.0 * mass;
		if(thetaDegR > theta1/2.0) mode = 3;
	}
	else if(mode == 3)
	{//E//OEŒC㍶/E/Oo
		point[0].flagFixed = false;//㍶
		point[6].flagFixed = false;//E
		point[10].flagFixed = false;//O
		point[1].flagFixed = true;//E
		point[5].flagFixed = true;//
		point[11].flagFixed = true;//OE
		point[0].vVelocity.x = 2.0*speed * cos(direction);
		point[0].vVelocity.y = 2.0*speed * sin(direction);
		point[0].vForce0.z = 100.0 * mass;
		point[6].vVelocity.x = 2.0*speed * cos(direction);
		point[6].vVelocity.y = 2.0*speed * sin(direction);
		point[6].vForce0.z = 0.0;
		point[10].vVelocity.x = 2.0*speed * cos(direction);
		point[10].vVelocity.y = 2.0*speed * sin(direction);
		point[10].vForce0.z = 0.0 ;
		if(thetaDegR > theta1) mode = 0;
	}

	//isωƂ_̈ʒu/ol̕xNgς
	double alpha = direction - direction0;
	if(alpha != 0.0)
	{
		for(i = 0; i < numSpring; i++) spring[i].vDir0.rotZ(alpha * RAD_TO_DEG);
		for(int i = 0; i < numPoint; i++) point[i].vPos.rotZ_rad( point[rootNo].vPos, alpha);
		direction0 = direction;
	}

	calcSpringMass(timeStep);
}

//----------------------------------------------------------------------------------
void CSpringMass::action2(double timeStep, double time)
{
	int i;
	double theta, dist;
	double thetaDegL, thetaDegR;
	CVector vDirection = CVector(cos(direction), sin(direction), 0.0);//is̃xNg

	//r̐itj
	dist = vDot(point[10].vPos - point[14].vPos, vDirection);
	//r̊px
	theta = atan2(dist, point[10].vPos.z - point[14].vPos.z); 
	thetaDegL = theta * RAD_TO_DEG;
	//Er̐itj
	dist = vDot(point[11].vPos - point[15].vPos, vDirection);
	//Er̊px
	theta = atan2(dist, point[11].vPos.z - point[15].vPos.z); 
	thetaDegR = theta * RAD_TO_DEG;

	for(i = 0; i < numPoint; i++)
	{
		point[i].vVelocity.x = speed * cos(direction);
		point[i].vVelocity.y = speed * sin(direction);
	}

	if(mode == 0)
	{//ŒCE/o,
		point[14].flagFixed = true;
		point[15].flagFixed = false;
		point[15].vVelocity.x = 2.0*speed * cos(direction);
		point[15].vVelocity.y = 2.0*speed * sin(direction);
		point[13].vVelocity.x = 2.0*speed * cos(direction);
		point[13].vVelocity.y = 2.0*speed * sin(direction);
		point[13].vForce0.z = 200.0 * mass;//EЂグ
		point[20].vVelocity.x = 2.3*speed * cos(direction);
		point[20].vVelocity.y = 2.3*speed * sin(direction);
		point[21].vVelocity = CVector();
		if(thetaDegL > theta1/2.0) mode = 1;
	}
	else if(mode == 1)
	{//ŒCE/o,
		point[14].flagFixed = true;
		point[15].flagFixed = false;
		point[15].vVelocity.x = 2.0*speed * cos(direction);
		point[15].vVelocity.y = 2.0*speed * sin(direction);
		point[13].vVelocity.x = 2.0*speed * cos(direction);
		point[13].vVelocity.y = 2.0*speed * sin(direction);
		point[13].vForce0.z = 0.0;//EЂ
		point[20].vVelocity.x = 2.3*speed * cos(direction);
		point[20].vVelocity.y = 2.3*speed * sin(direction);
		point[21].vVelocity = CVector();
		if(thetaDegL > theta1) mode = 2;
	}

	else if(mode == 2)
	{//EŒC/Eo
		point[14].flagFixed = false;
		point[15].flagFixed = true;
		point[14].vVelocity.x = 2.0*speed * cos(direction);
		point[14].vVelocity.y = 2.0*speed * sin(direction);
		point[12].vVelocity.x = 2.0*speed * cos(direction);
		point[12].vVelocity.y = 2.0*speed * sin(direction);
		point[12].vForce0.z = 200.0 * mass;//Ђグ
		point[21].vVelocity.x = 2.3*speed * cos(direction);
		point[21].vVelocity.y = 2.3*speed * sin(direction);
		point[20].vVelocity = CVector();
		if(thetaDegR > theta1/2.0) mode = 3;
//printf("thetaDegL=%f, thetaDegR=%f \n", thetaDegL, thetaDegR);
	}
	else if(mode == 3)
	{//EŒC/Eo
		point[14].flagFixed = false;
		point[15].flagFixed = true;
		point[14].vVelocity.x = 2.0*speed * cos(direction);
		point[14].vVelocity.y = 2.0*speed * sin(direction);
		point[12].vVelocity.x = 2.0*speed * cos(direction);
		point[12].vVelocity.y = 2.0*speed * sin(direction);
		point[12].vForce0.z = 0.0 * mass;//Ђ
		point[21].vVelocity.x = 2.3*speed * cos(direction);
		point[21].vVelocity.y = 2.3*speed * sin(direction);
		point[20].vVelocity = CVector();
		if(thetaDegR > theta1) mode = 0;
//printf("thetaDegL=%f, thetaDegR=%f \n", thetaDegL, thetaDegR);
	}

	//isωƂ_̈ʒu/ol̕xNgς
	double alpha = direction - direction0;
	if(alpha != 0.0)
	{
		for(i = 0; i < numSpring; i++) spring[i].vDir0.rotZ(alpha * RAD_TO_DEG);
		for(int i = 0; i < numPoint; i++) point[i].vPos.rotZ_rad( point[rootNo].vPos, alpha);
		direction0 = direction;
	}
	calcSpringMass(timeStep);
}
