
#include "../../spring.h"

int numPoint;
int numDiv;//ԗ։~̕
int type = 0;
int mode = 0;
int rootNo;

class CSpringMass
{
public:
    CVector vPos;
	float speed;//isx
	CVector vOmega;
    CVector vEuler;
	float mass;//_P̎
    float constK;
	float drctnK;
	float damping;
	float drag;
    float length0;//sprinĝP莩Riԗւtj
	float Length;//Oւƌւ̒SԂ̋
    float radius ;//ai_j
	float direction, direction0;//isix̌oxCdegj
	float ang, ang0;//

    CVector vForce0;//O͂̏l
	CSpring spring[MAX_SPRING];
	CRigid point[MAX_SPRING + 1];
	CRigid pole[2];

    //o֐
    CSpringMass();
    void draw(bool flagShadow);
    void create();
    void calcSpringMass(double dt);
	void action0(double dt, double time);
	void action1(double dt, double time);
	void action2(double dt, double time);
private:
};
CSpringMass sm;
//---------------------------------------------------------------
CSpringMass::CSpringMass()
{
    vPos = CVector();
    length0 = 1.0;
	Length = 2.5 * length0;
	constK = 1000.0;
	drctnK = 100.0;
	mass = 1.0;
	drag = 0.0;
	damping = 0.0;
    radius = 0.03;
	vForce0 = CVector();
}
//-----------------------------------------------------------------
void CSpringMass::draw(bool flagShadow)
{
    int i;
    int r1, r2;
    CVector vEuler0, vEuler1;

    //΂ˎ_\
    //_
    for(i = 0; i < numPoint; i++) {
        point[i].color = CYAN;
        if(point[i].flagFixed == true){
            //point[i].color= RED;
        }
        point[i].draw(flagShadow);
    }
    for(i = 0; i < numSpring; i++)
    {
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        spring[i].vPos = (point[r1].vPos + point[r2].vPos) / 2.0;
        spring[i].length = vDist(point[r1].vPos, point[r2].vPos);
        spring[i].vEuler = getEulerZ(point[r1].vPos, point[r2].vPos);
        spring[i].draw(flagShadow);
    }
}
//-----------------------------------------------------------------
void CSpringMass::create()
{
	int i, k, n1, n2;
	if(type == 0)
	{//֎
		numSpring = 2 * numDiv;
		numPoint = numDiv + 1;//S܂
		rootNo = 0;

		//point
		//S
		point[0].vPos = CVector(0.0, 0.0, 0.0) + vPos;//{płx𒆐SƂ
		//~
		for(i = 1; i <= numDiv; i++)
		{
			double phi = 2.0 * M_PI * (double)(i - 1) / (double)numDiv;
			point[i].vPos.x = 0.0;
			point[i].vPos.y = length0 * cos(phi);
			point[i].vPos.z = length0 * sin(phi);
			point[i].vPos += vPos;
		}
		//spring
		for(i = 0; i < numDiv; i++)
		{//spoke(tj

			spring[i].row1 = 0; 
			spring[i].row2 = i + 1;
		}
		for(i = 0; i < numDiv; i++)
		{//ԗ։~
			spring[i + numDiv].row1 = i + 1; 
			if(i < numDiv-1)
				spring[i + numDiv].row2 = i + 2;
			else
				spring[i + numDiv].row2 = 1;
		}

	}
	else if(type == 1)
	{//֎
		numSpring = 4 * numDiv + 16;
		numPoint = 2 * numDiv + 11;
		Length = 3.0 * length0 ;

		//point
		//Oւ̒S
		point[0].vPos = CVector(0.0, Length/2.0, 0.0) + vPos;//{płx𒆐SƂ
		for(i = 1; i <= numDiv; i++)
		{//O։~
			double phi = 2.0 * M_PI * (double)(i - 1) / (double)numDiv;
			point[i].vPos.x = 0.0;
			point[i].vPos.y = length0 * cos(phi) + Length / 2.0;
			point[i].vPos.z = length0 * sin(phi);
			point[i].vPos += vPos;
		}
		//spring
		for(i = 0; i < numDiv; i++)
		{//spoke(tj
			spring[i].row1 = 0; 
			spring[i].row2 = i + 1;
		}
		
		for(i = 0; i < numDiv; i++)
		{//ԗ։~
			k = numDiv + i;
			spring[k].row1 = i + 1; 
			if(i < numDiv-1)
				spring[k].row2 = i + 2;
			else
				spring[k].row2 = 1;
		}
		
		//point
		//ւ̒S
		point[numDiv+1].vPos = CVector(0.0, -Length/2.0, 0.0) + vPos;//{płx𒆐SƂ
		for(i = 1; i <= numDiv; i++)
		{//։~
			k = numDiv + i + 1;
			double phi = 2.0 * M_PI * (double)(i - 1) / (double)numDiv;
			point[k].vPos.x = 0.0;
			point[k].vPos.y = length0 * cos(phi) - Length / 2.0;
			point[k].vPos.z = length0 * sin(phi);
			point[k].vPos += vPos;
		}
		//spring
		for(i = 0; i < numDiv; i++)
		{//spoke(tj
			k = 2 * numDiv + i;
			spring[k].row1 = numDiv + 1; 
			spring[k].row2 = numDiv + i + 2;
		}
		for(i = 0; i < numDiv; i++)
		{//։~
			k = 3 * numDiv + i;
			spring[k].row1 = numDiv + i + 2; 
			if(i < numDiv-1)
				spring[k].row2 = numDiv + i + 3;
			else
				spring[k].row2 = numDiv + 2;
		}

		//Ԏ
		float wid = length0 ;//Ԏ̒(j
		point[numDiv*2+2].vPos = CVector(-wid/2.0, Length/2.0, 0.0) + vPos;//O 
		point[numDiv*2+3].vPos = CVector( wid/2.0, Length/2.0, 0.0) + vPos;//OE
		point[numDiv*2+4].vPos = CVector(-wid/2.0,-Length/2.0, 0.0) + vPos;//㍶ 
		point[numDiv*2+5].vPos = CVector( wid/2.0,-Length/2.0, 0.0) + vPos;//E
		spring[numDiv * 4].row1 = 0    ; spring[numDiv * 4].row2 = numDiv*2 + 2;//O 
		spring[numDiv * 4 + 1].row1 = 0; spring[numDiv * 4 + 1].row2 = numDiv*2 + 3;//OE 
		spring[numDiv * 4 + 2].row1 = numDiv+1; spring[numDiv * 4 + 2].row2 = numDiv*2 + 4;//㍶ 
		spring[numDiv * 4 + 3].row1 = numDiv+1; spring[numDiv * 4 + 3].row2 = numDiv*2 + 5;//E 
		//Th
		point[numDiv*2+6].vPos =  CVector(-wid/2.0, wid, length0*1.5) + vPos;//O
		point[numDiv*2+7].vPos =  CVector( wid/2.0, wid, length0*1.5) + vPos;//OE
		point[numDiv*2+8].vPos =  CVector(-wid/2.0,-wid, length0*1.5) + vPos;//㍶
		point[numDiv*2+9].vPos =  CVector( wid/2.0,-wid, length0*1.5) + vPos;//E
        spring[numDiv*4+4].row1 = numDiv*2+6;  spring[numDiv*4+4].row2 = numDiv*2+7;
        spring[numDiv*4+5].row1 = numDiv*2+8;  spring[numDiv*4+5].row2 = numDiv*2+9;
        spring[numDiv*4+6].row1 = numDiv*2+6;  spring[numDiv*4+6].row2 = numDiv*2+8;
        spring[numDiv*4+7].row1 = numDiv*2+7;  spring[numDiv*4+7].row2 = numDiv*2+9;
		//Th4ƎԎ̒[̎_
        spring[numDiv*4+8].row1 = numDiv*2+6;   spring[numDiv*4+8].row2 = numDiv*2+2;
        spring[numDiv*4+9].row1 = numDiv*2+7;   spring[numDiv*4+9].row2 = numDiv*2+3;
        spring[numDiv*4+10].row1 = numDiv*2+8;  spring[numDiv*4+10].row2 = numDiv*2+4;
        spring[numDiv*4+11].row1 = numDiv*2+9;  spring[numDiv*4+11].row2 = numDiv*2+5;
		//Th̒S
		point[numDiv*2+10].vPos =  CVector(0.0, 0.0, length0 * 1.5) + vPos;
		rootNo = numDiv*2+10;
		spring[numDiv*4+12].row1 = rootNo; spring[numDiv*4+12].row2 = numDiv*2+6;
		spring[numDiv*4+13].row1 = rootNo; spring[numDiv*4+13].row2 = numDiv*2+7;
		spring[numDiv*4+14].row1 = rootNo; spring[numDiv*4+14].row2 = numDiv*2+8;
		spring[numDiv*4+15].row1 = rootNo; spring[numDiv*4+15].row2 = numDiv*2+9;

	}

	else if(type == 2)
	{//l֎
		numSpring = 8 * numDiv + 12;
		numPoint = 4 * numDiv + 9;
		Length = 3.0 * length0;
		float wid = 2.0 * length0;//Ŝ̕
		float wid0 = wid / 2;//̕

		//O֍̒S
		point[0].vPos = CVector(-wid/2.0, Length/2.0, 0.0) + vPos;//{płx𒆐SƂ
		for(i = 1; i <= numDiv; i++)
		{//O։~
			double phi = 2.0 * M_PI * (double)(i - 1) / (double)numDiv;
			point[i].vPos.x = -wid /2.0;
			point[i].vPos.y = length0 * cos(phi) + Length / 2.0;
			point[i].vPos.z = length0 * sin(phi);
			point[i].vPos += vPos;
		}
		//spring
		for(i = 0; i < numDiv; i++)
		{//spoke(tj
			spring[i].row1 = 0; 
			spring[i].row2 = i + 1;
		}
		for(i = 0; i < numDiv; i++)
		{//O։~ 
			k = numDiv + i;
			spring[k].row1 = i + 1; 
			if(i < numDiv-1)
				spring[k].row2 = i + 2;
			else
				spring[k].row2 = 1;
		}
		//O։E̒S
		point[numDiv+1].vPos = CVector( wid/2.0,  Length/2.0, 0.0) + vPos;//{płx𒆐SƂ
		
		for(i = 1; i <= numDiv; i++)
		{//O։E~
			k = numDiv + i + 1;
			double phi = 2.0 * M_PI * (double)(i - 1) / (double)numDiv;
			point[k].vPos.x = wid / 2.0;
			point[k].vPos.y = length0 * cos(phi) + Length / 2.0;
			point[k].vPos.z = length0 * sin(phi);
			point[k].vPos += vPos;
		}
		//spring
		for(i = 0; i < numDiv; i++)
		{//spoke(tj
			k = 2 * numDiv + i;
			spring[k].row1 = numDiv + 1; 
			spring[k].row2 = numDiv + i + 2;
		}
		for(i = 0; i < numDiv; i++)
		{//ԗ։~
			k = 3 * numDiv + i;
			spring[k].row1 = numDiv + i + 2; 
			if(i < numDiv-1)
				spring[k].row2 = numDiv + i + 3;
			else
				spring[k].row2 = numDiv + 2;
		}

		//֍̒S
		point[2*numDiv+2].vPos = CVector(-wid/2.0, -Length/2.0, 0.0) + vPos;//{płx𒆐SƂ
		for(i = 1; i <= numDiv; i++)
		{//~
			k = 2*numDiv + i + 2;
			double phi = 2.0 * M_PI * (double)(i - 1) / (double)numDiv;
			point[k].vPos.x = -wid / 2.0;
			point[k].vPos.y = length0 * cos(phi) - Length / 2.0;
			point[k].vPos.z = length0 * sin(phi);
			point[k].vPos += vPos;
		}
		//spring
		for(i = 0; i < numDiv; i++)
		{//spoke(tj
			k = 4 * numDiv + i;
			spring[k].row1 = 2 * numDiv + 2; 
			spring[k].row2 = 2 * numDiv + i + 3;
		}
		for(i = 0; i < numDiv; i++)
		{//֍~
			k = 5 * numDiv + i;
			spring[k].row1 = 2*numDiv + i + 3; 
			if(i < numDiv-1)
				spring[k].row2 = 2*numDiv + i + 4;
			else
				spring[k].row2 = 2*numDiv + 3;
		}
		//։E̒S
		point[3*numDiv+3].vPos = CVector(wid/2.0, -Length/2.0, 0.0) + vPos;//{płx𒆐SƂ
		for(i = 1; i <= numDiv; i++)
		{//~
			k = 3*numDiv + i + 3;
			double phi = 2.0 * M_PI * (double)(i - 1) / (double)numDiv;
			point[k].vPos.x =  wid / 2.0;
			point[k].vPos.y = length0 * cos(phi) - Length / 2.0;
			point[k].vPos.z = length0 * sin(phi);
			point[k].vPos += vPos;
		}
		//spring
		for(i = 0; i < numDiv; i++)
		{//spoke(tj
			k = 6 * numDiv + i;
			spring[k].row1 = 3*numDiv + 3; 
			spring[k].row2 = 3*numDiv + i + 4;
		}
		for(i = 0; i < numDiv; i++)
		{//ԗ։~
			k = 7 * numDiv + i;
			spring[k].row1 = 3*numDiv + i + 4; 
			if(i < numDiv-1)
				spring[k].row2 = 3*numDiv + i + 5;
			else
				spring[k].row2 = 3*numDiv + 4;
		}

		int k0 = 4 * numDiv + 4;//܂ł̎_
		//point
		point[k0 + 0].vPos = CVector(-wid0/2.0, Length/2.0, 0.0) + vPos;//O 
		point[k0 + 1].vPos = CVector( wid0/2.0, Length/2.0, 0.0) + vPos;//OE
		point[k0 + 2].vPos = CVector(-wid0/2.0,-Length/2.0, 0.0) + vPos;//㍶ 
		point[k0 + 3].vPos = CVector( wid0/2.0,-Length/2.0, 0.0) + vPos;//E
		//̒S
		point[k0 + 4].vPos = CVector(0.0, 0.0, 0.0) + vPos;
		rootNo = k0 + 4;
		//spring
		int n0 = numDiv * 8;//܂ł̃ol
		spring[n0 + 0].row1 = 0 ; spring[n0 + 0].row2 = k0;
		spring[n0 + 1].row1 = k0; spring[n0 + 1].row2 = k0 + 1; 
		spring[n0 + 2].row1 = k0 + 1; spring[n0 + 2].row2 = numDiv + 1;
		spring[n0 + 3].row1 = 2*numDiv+2; spring[n0 + 3].row2 = k0 + 2;
        spring[n0 + 4].row1 = k0 + 2;  spring[n0 + 4].row2 = k0 + 3;
        spring[n0 + 5].row1 = k0 + 3;  spring[n0 + 5].row2 = 3*numDiv+3;
        spring[n0 + 6].row1 = rootNo;  spring[n0 + 6].row2 = k0;
        spring[n0 + 7].row1 = rootNo;  spring[n0 + 7].row2 = k0 + 1;
        spring[n0 + 8].row1 = rootNo;  spring[n0 + 8].row2 = k0 + 2;
        spring[n0 + 9].row1 = rootNo;  spring[n0 + 9].row2 = k0 + 3;
        spring[n0 + 10].row1 = k0;  spring[n0 + 10].row2 = k0 + 2;
        spring[n0 + 11].row1 = k0 + 1;  spring[n0 + 11].row2 = k0 + 3;

	}
//printf("numPoint=%d numSpring=%d \n", numPoint, numSpring);
	//ol̎RƕxNg
	for(int i = 0; i < numSpring; i++)
	{
		n1 = spring[i].row1; n2 = spring[i].row2;
		spring[i].length0 = vDist(point[n1].vPos, point[n2].vPos);
		spring[i].vDir0 = point[n1].vPos >> point[n2].vPos;
	}

    //_̃TCY,
    for(int i = 0; i < numPoint; i++){
        point[i].kind = SPHERE;
		point[i].vSize = CVector(2.0, 2.0, 2.0) * radius;
		point[i].mass = mass;
    }
	//ol
    for(int i = 0; i < numSpring; i++){
		spring[i].radius = radius;
        spring[i].kind = S_CYLINDER;
	}

	//islyłȂƂ_̈ʒu/ol̕xNgς
	double alpha = direction - M_PI/2.0;
	for(int i = 0; i < numSpring; i++) spring[i].vDir0.rotZ_rad(alpha);
	for(i = 0; i < numPoint; i++)
	{//_W
		point[i].vPos.rotZ_rad(point[rootNo].vPos, alpha);//z]
	}
}

//-----------------------------------------------------------------------------
//1̃ol}Xf(hinge springlCRԂŉ^)
void CSpringMass::calcSpringMass(double dt)
{                                           
    int i, r1, r2;
    CVector vDir1, vDir2;
    CVector vFF, vRelativeVelocity;
    float dampingF;
	double angle;
    CVector vNormal;

	//͂̑a
    //ݒl
    for(i = 0; i  < numPoint; i++)
        point[i].vForce = point[i].vForce0 + CVector(0.0, 0.0, -gravity * mass);

	//olɂ
    for(i = 0; i < numSpring; i++){
        //e
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;//#1#2ւ̒PʃxNg
        spring[i].length = vDist(point[r1].vPos, point[r2].vPos);
        vFF = (constK * (spring[i].length - spring[i].length0)) * vDir1 ;
        point[r1].vForce += vFF ;//vDirƓ
        point[r2].vForce -= vFF ;//Ε
        //
        vRelativeVelocity = point[r1].vVelocity - point[r2].vVelocity;
        dampingF = damping * vDot(vRelativeVelocity, vDir1);
        point[r1].vForce -= dampingF * vDir1;//ΑxƂ͔Ε
        point[r2].vForce += dampingF * vDir1;//
    }

	//oll(Ɉv悤ɃgN𔭐j
	for(i = 0; i < numSpring; i++)
	{
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;
        vNormal = vCross(spring[i].vDir0, vDir1);
		vDir2 = vCross(vNormal, vDir1);
		angle = getAngle(spring[i].vDir0, vDir1);
        vFF = drctnK * angle * vDir2 / spring[i].length;
        point[r2].vForce -= vFF ;
        point[r1].vForce += vFF;//vDir2Ɠ
	}

    //SRƏʏ,lvZ
    for(i = 0; i < numPoint; i++)
    {
        if(point[i].flagFixed == true) continue; //Œ

        //CSRiSĂ̎_ɈlƉ)
        point[i].vForce -= drag * point[i].vVelocity;

		//ʏ
        if(point[i].vPos.z < radius)
        {
			//ʂɂ鎿_ɑ΂Ăׂ͂薀C^
            //point[i].vForce -= (muK * mass * gravity) * point[i].vVelocity.norm2();
            //ʏɐ
            point[i].vPos.z = radius;
            //Ƃ̏Փ
            if(point[i].vVelocity.z < 0.0){ //_ƏʂƂ͒eՓ˂Ƃ

                point[i].vVelocity.z = - restitut * point[i].vVelocity.z ;
            }
        }
        //Euler@
        //x
		point[i].vAccel = point[i].vForce / mass;
        //x
        point[i].vVelocity += point[i].vAccel * dt;

        //ʒu
        point[i].vPos += point[i].vVelocity * dt;
    }
	vPos = point[rootNo].vPos;
}

//----------------------------------------------------------------------------------
void CSpringMass::action0(double timeStep, double time)
{
	int i;
	rootNo = 0;//S_
	double theta;
	double omega = speed / length0;//ԗւ̉]x

	theta = -omega * timeStep;//-x]({p, radPʁj
	point[rootNo].vVelocity.y = speed * sin(direction);
	point[rootNo].vVelocity.x = speed * cos(direction);

	//Ԃ̉]CisωƂ_̈ʒu/ol̕xNgς
	double alpha = direction - direction0;//rad

	for(i = 0; i < numSpring; i++)
	{//ol̊
		spring[i].vDir0.rotX_rad( theta * sin(direction));
		spring[i].vDir0.rotY_rad(-theta * cos(direction));
		spring[i].vDir0.rotZ_rad( alpha);
	}
	for(i = 0; i < numPoint; i++)
	{//_W
		point[i].vPos.rotX_rad(point[rootNo].vPos, theta);//x]
		point[i].vPos.rotZ_rad(point[rootNo].vPos, alpha);//z]
	}
	direction0 = direction;
	
	calcSpringMass(timeStep);
}

//----------------------------------------------------------------------------------
void CSpringMass::action1(double timeStep, double time)
{
	int i;
	int center1 = 0;//Oւ̒S_
	int center2 = numDiv+1;
	double theta;
	double omega = speed / length0;//ԗւ̉]x

	theta = -omega * timeStep;//-x]({pj
	point[center1].vVelocity.y = speed * sin(direction);
	point[center1].vVelocity.x = speed * cos(direction);
		

	point[center2].vVelocity.y = speed * sin(ang);
	point[center2].vVelocity.x = speed * cos(ang);

	//Ԃ̉]CisωƂ_̈ʒu/ol̊xNgς
	//O
	double alpha = direction - direction0;//rad

	for(i = 0; i < 2*numDiv; i++)
	{//ol̕
		spring[i].vDir0.rotX_rad( theta * sin(direction));
		spring[i].vDir0.rotY_rad(-theta * cos(direction));
		spring[i].vDir0.rotZ_rad( alpha);
	}

	for(i = 0; i <= numDiv; i++)
	{//_̍W
		point[i].vPos.rotX_rad(point[center1].vPos, theta);//x]
		point[i].vPos.rotZ_rad(point[center1].vPos, alpha);//z]
	}
	direction0 = direction;
	
	//ւ̐is(rad)
	ang = atan2( point[center1].vPos.y - point[center2].vPos.y, 
                         point[center1].vPos.x - point[center2].vPos.x);
	alpha = ang - ang0;//ω

	for(i = 2*numDiv; i < 4*numDiv; i++)
	{
		spring[i].vDir0.rotX_rad( theta * sin(ang));
		spring[i].vDir0.rotY_rad(-theta * cos(ang));
		spring[i].vDir0.rotZ_rad( alpha);
	}

	for(i = numDiv+1; i <= 2*numDiv+1; i++)
	{
		point[i].vPos.rotX_rad(point[center2].vPos, theta);//x]
		point[i].vPos.rotZ_rad(point[center2].vPos, alpha);//z]
	}
	ang0 = ang;

	//̎_ColrootNo𒆐SɌւƓɉ]
	if(alpha != 0.0)
	{
		for(i = 4*numDiv; i < numSpring; i++) spring[i].vDir0.rotZ_rad(alpha);
		for(i = 2*numDiv+2; i < numPoint; i++) point[i].vPos.rotZ_rad(point[rootNo].vPos, alpha);
	}

	calcSpringMass(timeStep);
}

//----------------------------------------------------------------------------------
void CSpringMass::action2(double timeStep, double time)
{
	int i;
	int center1 = 0;//O֍̒S_
	int center2 = numDiv+1;//O։E̒S_
	int center3 = numDiv*2+2;//֍̒S_
	int center4 = numDiv*3+3;//։E̒S_
	double theta;
	double omega = speed / length0;//ԗւ̉]x

	theta = -omega * timeStep;//-x]({pj
	point[center1].vVelocity.x = speed * cos(direction);
	point[center1].vVelocity.y = speed * sin(direction);
	point[center2].vVelocity.x = speed * cos(direction);
	point[center2].vVelocity.y = speed * sin(direction);
		
	//ւ̐is(̕j
	ang = atan2( point[center1].vPos.y - point[center3].vPos.y, 
                         point[center1].vPos.x - point[center3].vPos.x);
	point[center3].vVelocity.x = speed * cos(ang);
	point[center3].vVelocity.y = speed * sin(ang);
	point[center4].vVelocity.x = speed * cos(ang);
	point[center4].vVelocity.y = speed * sin(ang);
	
	//Ԃ̉]CisωƂ_̈ʒu/ol̊xNgς
	float x, y, z, alpha;
	//O
	alpha = direction - direction0;

	for(i = 0; i < 4*numDiv; i++)
	{
		spring[i].vDir0.rotX_rad( theta * sin(direction));
		spring[i].vDir0.rotY_rad(-theta * cos(direction));
		spring[i].vDir0.rotZ_rad( alpha);
	}
	direction0 = direction;

	//O֍̎_
	for(i = 0; i <= numDiv; i++)
	{
		point[i].vPos.rotX_rad(point[center1].vPos, theta);//x]
		point[i].vPos.rotZ_rad(point[center1].vPos, alpha);//z]
	}
	//O։E̎_
	for(i = numDiv + 1; i <= 2*numDiv+1; i++)
	{
		point[i].vPos.rotX_rad(point[center2].vPos, theta);//x]
		point[i].vPos.rotZ_rad(point[center2].vPos, alpha);//z]
	}
	
	
	alpha = ang - ang0;

	for(i = 4*numDiv; i < 8*numDiv; i++)
	{
		spring[i].vDir0.rotX_rad( theta * sin(ang));
		spring[i].vDir0.rotY_rad(-theta * cos(ang));
		spring[i].vDir0.rotZ_rad( alpha);
	}
	ang0 = ang;

	//֍
	for(i = 2*numDiv+2; i <= 3*numDiv+2; i++)
	{
		point[i].vPos.rotX_rad(point[center3].vPos, theta);//x]
		point[i].vPos.rotZ_rad(point[center3].vPos, alpha);//z]
	}
	//։E
	for(i = 3*numDiv+3; i <= 4*numDiv+3; i++)
	{
		point[i].vPos.rotX_rad(point[center4].vPos, theta);//x]
		point[i].vPos.rotZ_rad(point[center4].vPos, alpha);//z]
	}

	//̎_ColrootNo𒆐Sɉ]
	if(alpha != 0.0)
	{
		for(i = 8*numDiv; i < numSpring; i++) spring[i].vDir0.rotZ_rad(alpha);
		for(i = 4*numDiv+4; i < numPoint; i++) point[i].vPos.rotZ_rad(point[rootNo].vPos, alpha);
	}

	calcSpringMass(timeStep);
}
