
const float pi = 3.14159265;

//-------------------------------------------------------------------
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerPos;
//uniform sampler2DRect samplerVel;
uniform int texWidth;
uniform float amp;
uniform float freq;
uniform float lambda;
uniform float sourceY;
uniform float interval;
uniform float size;
uniform int nSource;
uniform int mode;
uniform int boundary;
uniform float time;

varying vec2 texPos;

//float lambda0 = lambda;// * float(texWidth) / size;//TCYϊ		
float makeWave(vec2 pos);

void main(void)
{
	vec4 position;//, velocity;
	position = texture2DRect(samplerPos, texPos);
	vec2 pos = texPos.xy - vec2(float((texWidth)/2), float((texWidth)/2));
	//TCYϊ
	pos *= size / float(texWidth);

	//gl
	position.z = makeWave(pos);	

	gl_FragColor = position;		
}
//--------------------------------------------------------------------
float getSingleWave(float r)
{
    float phase = 2.0 * pi * ( freq * time - r / lambda);
    float a = 0.0;
    
    if(phase >= 0.0 && phase < pi) a = sin(phase) / (0.1 + sqrt(r));
    else a = 0.0;
    
	if(a > 1.0) a = 1.0;
	if(a < -1.0) a = -1.0;
    return( a );
}

//--------------------------------------------------------------------
float getContinuousWave(float r)
{
    float phase = 2.0 * pi * ( freq * time - r / lambda);
    float a = 0.0;
    
    if(phase >= 0.0) a = sin(phase) / (0.001 + sqrt(r));
    else a = 0.0;
    
	if(a > 1.0) a = 1.0;
	if(a < -1.0) a = -1.0;
    return( a );
}
//-----------------------------------------------------------------------------
void getReflectionWave(inout float wave, float r)
{
	if(boundary == 1)//RE
	{
	  if(mode == 0) wave += amp * getSingleWave(r);
	  else          wave += amp * getContinuousWave(r);
	}
	else if(boundary == 2) //Œ苫E
	{
	  if(mode == 0) wave -= amp * getSingleWave(r);
	  else          wave -= amp * getContinuousWave(r);
	}
}
//--------------------------------------------------------
float makeWave(vec2 pos)
{
	int i, j, k;
	float r;
	vec2 source[20];//~`g̒S

	//g
	for(int k = 0; k < nSource; k++)
	{
		source[k].x = interval * (-0.5 * float(nSource-1) + float(k));
		source[k].y = sourceY;
	}

	float wave = 0.0;

	for(k = 0; k < nSource; k++)
	{
		r = length(pos - source[k]);
		if(mode == 0) wave += amp * getSingleWave(r);
		else          wave += amp * getContinuousWave(r);
	}
	if(boundary == 0) return wave;//
	
	vec2 sourceR;//˔g̒S
	//˂1񂾂Ɍ
	//-xEɂ锽
	for(k = 0; k < nSource; k++)
	{
		sourceR.x = -float(texWidth) - source[k].x; sourceR.y = source[k].y;
		r = length(pos - sourceR);
		getReflectionWave(wave, r);
	}
	//+xEɂ锽
	for(k = 0; k < nSource; k++)
	{
		sourceR.x = float(texWidth) - source[k].x; sourceR.y = source[k].y;
		r = length(pos - sourceR);
		getReflectionWave(wave, r);
	}
	//-yEɂ锽
	for(k = 0; k < nSource; k++)
	{
		sourceR.x = source[k].x; sourceR.y = -float(texWidth) - source[k].y;
		r = length(pos - sourceR);
		getReflectionWave(wave, r);
	}
	//+yEɂ锽
	for(k = 0; k < nSource; k++)
	{
		sourceR.x = source[k].x; sourceR.y = float(texWidth) - source[k].y;
		r = length(pos - sourceR);
		getReflectionWave(wave, r);
	}
}
//--------------------------------------------------------


