const float pi = 3.14159265;
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerWave;
uniform int texWidth;//_~[܂XSiq
uniform int nDummy;
uniform float size0;//ۂ1ӂ̒(_~[܂܂j
uniform int nSource;
uniform float sourceY;
uniform float interval;
uniform float amp;
uniform float freq;
uniform float waveVel;
uniform float drag0;
uniform float dt;
uniform float time;
uniform int mode;
uniform int boundary;

varying vec2 texPos;
int texHeight = texWidth;
float makeWave(vec2 pos, float v0);

void main(void)
{
	int nSlice0 = texWidth - 2 * nDummy - 1;//L̈̕iiqj
	vec4 wave = texture2DRect(samplerWave, texPos);
	
	//̈̒S_ɕύX
	vec2 pos = texPos.xy - vec2(float((texWidth)/2), float((texHeight)/2));
	//TCYϊ
	pos *= size0 / float(nSlice0);
	wave.r = makeWave(pos, wave.r);//g̔g쐬(xj

	float accel = 0.0;
	float d = size0 / float(nSlice0);//iqԊu	
	float dd = d * d;
	float drag = drag0;
	int nm = nDummy;          //˂̂Ƃ̗L̈拫Eԍ	
	int np = nSlice0 + nDummy;//˂̂Ƃ̗L̈拫Eԍ
	int im, ip, jm, jp;
	float zmi, zpi, zmj, zpj;
	float coef;

    int i = int(texPos.x);
    int j = int(texPos.y);

	float dragMax = 5.0;

	if(boundary == 0)//B_NON
	{
		if(j < nm) drag = drag0 + dragMax * float(nm - j) / float(nDummy);
		if(j > np) drag = drag0 + dragMax * float(j - np) / float(nDummy);
		if(i < nm) drag = drag0 + dragMax * float(nm - i) / float(nDummy);
		if(i > np) drag = drag0 + dragMax * float(i - np) / float(nDummy);
	}
	
	im = i-1; ip = i+1; jm = j-1; jp = j+1;
	if(im < 0) zmi = 0.0;
	else zmi = texture2DRect(samplerWave, texPos + vec2(-1.0, 0.0)).g;
	if(ip > texWidth) zpi = 0.0;
	else zpi = texture2DRect(samplerWave, texPos + vec2( 1.0, 0.0)).g;
	if(jm < 0) zmj = 0.0;
	else zmj = texture2DRect(samplerWave, texPos + vec2( 0.0,-1.0)).g;
	if(jp > texHeight) zpj = 0.0;
	else zpj = texture2DRect(samplerWave, texPos + vec2( 0.0, 1.0)).g;

	if(im < 0 || jm < 0 || ip > texWidth || jp > texWidth) coef = 3.0;
	else coef = 4.0;

	accel = (waveVel * waveVel) * ((zmi + zpi + zmj + zpj) - coef * wave.g) / dd;

	//SR
	accel -= drag * wave.r;
	//x̍XV
	wave.r += accel * dt;

	gl_FragColor = wave;
}
//--------------------------------------------------------
float makeWave(vec2 pos, float v0)
{
	int k;
	vec2 source;//g̈ʒu

	float value = v0;
	float period = 1.0 / freq;
	for(k = 0; k < nSource; k++)
	{
		source.x = floor(interval * (-0.5 * float(nSource-1) + float(k)));
		source.y = sourceY;

		if(pos.x == source.x && pos.y == source.y)
		{
			if(mode == 0)//SINGLE
			{
				if(time < period) value = amp * sin(2.0 * pi * freq * time);
			}
			else  value = amp * sin(2.0 * pi * freq * time);
		}
	}
	return value;
}
