const float pi = 3.14159265;
#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerWave;
uniform int texWidth;//_~[܂XSiq
uniform int nDummy;
uniform float size0;//ۂ1ӂ̒(_~[܂܂j
uniform int nSource;
uniform float sourceY;
uniform float interval;
uniform float amp;
uniform float freq;
uniform float drag0;
uniform float waveVel;
uniform int mode;
uniform float coefB;
uniform float coefDown;
uniform float coefUp;
uniform float dt;
uniform float time;
uniform vec3 posObj[2]; //V̂̈ʒu
uniform vec3 sizeObj[2];//̃TCY
uniform vec3 velObj[2]; //̑x

varying vec2 texPos;
int texHeight = texWidth;

int nSlice0 = texWidth - 2 * nDummy - 1;//L̈̕iiqj
float makeWave(vec2 pos, float v0);
float decideRegion(vec2 texPos, inout vec4 wave);

void main(void)
{
	int nm = nDummy;          //˂̂Ƃ̗L̈拫Eԍ	
	int np = nSlice0 + nDummy;//˂̂Ƃ̗L̈拫Eԍ
	float d = size0 / float(nSlice0);//iqԊu	
	float dd = d * d;
	
	vec4 wave0 = texture2DRect(samplerWave, texPos);//ړ_
	
	//̈̒S_ɕύX
	vec2 pos = texPos.xy - vec2(float((texWidth)/2), float((texHeight)/2));
	//TCYϊ
	pos *= size0 / float(nSlice0);//g̒ړ_ʒu
	
	wave0.r = makeWave(pos, wave0.r);//g̔g쐬(xj

	float drag = drag0;

    int i = int(texPos.x);
    int j = int(texPos.y);
    
    //ˏI[
	float dragMax = 5.0;
	if(j < nm) drag = drag0 + dragMax * float(nm - j) / float(nDummy);
	if(j > np) drag = drag0 + dragMax * float(j - np) / float(nDummy);
	if(i < nm) drag = drag0 + dragMax * float(nm - i) / float(nDummy);
	if(i > np) drag = drag0 + dragMax * float(i - np) / float(nDummy);

	//EW߂
	float cc, c[4];
	vec4 wave[4];
	vec2 offset[4];
	offset[0] =  vec2(-1.0, 0.0);
	offset[1] =  vec2( 1.0, 0.0);
	offset[2] =  vec2( 0.0,-1.0);
	offset[3] =  vec2( 0.0, 1.0);
	for(int i = 0; i < 4; i++)
	{
		wave[i] = texture2DRect(samplerWave, texPos + offset[i]);
		if(wave[i].a == 1.0) c[i] = 0.0;//CPUŐݒ肵ŒQ
		else 
		{
			wave[i].a = decideRegion(texPos + offset[i], wave[i]);
			if(wave[i].a == 0.0) c[i] = 1.0;//
			else c[i] = coefB;//V
		}
	}

	wave0.a = decideRegion(texPos, wave0);//ړ_̗̈攻
	if(wave[0].a == 1.0 || wave[1].a == 1.0 || wave[2].a == 1.0 || wave[3].a == 1.0) cc = 3.0;
	else
	{
		if(wave0.a == 0.0) cc = 4.0;//
		else cc = 3.0 + coefB;      //V
	}


	//IC[@
	float accel;
	if(wave0.a == 0.0 || wave0.a == 2.0)//ړ_ʂ܂͕V
		accel = (waveVel * waveVel) * (c[0]*wave[0].g + c[1]*wave[1].g 
		       + c[2]*wave[2].g + c[3]*wave[3].g - cc * wave0.g) / dd;
	else //n/ŒQ
		accel = 0.0;
	
	//SR
	accel -= drag * wave0.r;
	//x̍XV
	wave0.r += accel * dt;

	gl_FragColor = wave0;
}

//--------------------------------------------------------
float makeWave(vec2 pos, float v0)
{
	int k;
	vec2 source;//g̈ʒu

	float value = v0;
	float period = 1.0 / freq;
	for(k = 0; k < nSource; k++)
	{
		source.x = floor(interval * (-0.5 * float(nSource-1) + float(k)));
		source.y = sourceY;

		if(pos.x == source.x && pos.y == source.y)
		{
			if(mode == 0)//SINGLE
			{
				if(time < period) value = amp * sin(2.0 * pi * freq * time);
			}
			else  value = amp * sin(2.0 * pi * freq * time);
		}
	}
	return value;
}
//------------------------------------------------------------------------------
float decideRegion(vec2 texPos, inout vec4 wave)
{
	if( wave.a == 1.0) return 1.0;//CPUŐݒ肵ŒQ

	float cc = 0.0;
	vec2 pos = texPos.xy - vec2(float((texWidth)/2), float((texHeight)/2));
	//TCYϊ
	pos *= size0 / float(nSlice0);//g̒ړ_ʒu
	float R, Rm;
	for(int k = 0; k < 2; k++)
	{
		float dist = distance(pos, posObj[k].xy);
		if(abs(wave.g - posObj[k].z) < sizeObj[k].z / 2.0 )
		{
			R =  (sizeObj[k].x + sizeObj[k].y + sizeObj[k].z) / 6.0;//ϔa
			Rm = max(max(sizeObj[k].x, sizeObj[k].y), sizeObj[k].z) / 2.0; //ő唼a
			if(dist < R)
			{
				//Ƃړ_łΐʂ(ׂċŋߎj
				if(velObj[k].z < 0.0) wave.r += velObj[k].z * coefDown;
				
				cc = 2.0;
			}
			else if(dist > Rm && dist < Rm + 0.5)
			{
				//̂̑O̐ʂ
				float strength = dot(pos - posObj[k].xy, velObj[k].xy);
				if(strength > 0.0) wave.r += strength * coefUp;
			}
		}
	}

	return cc;
}
//--------------------------------------------------------------------------------
