//~`g쐬
//g쐬̍Wnx-yʁAz
#define MAX_SLICE 100//ő啪iӓj
#define MAX_SOURCE  20//Sg
//int numWave;//
enum Mode { SINGLE, CONTINUOUS};
enum Boundary {B_NON, B_FREE, B_FIXED};

class CWave
{
public:
	int nSource;//g
	int nSlice; //
	int kind;   //PCA
	float period;
	float lambda;
	float amp0;
	float sizeX;
	float sizeY;
	float sourceX[MAX_SOURCE],  sourceY[MAX_SOURCE]; //~`g̒SW
	float sourceRX[MAX_SOURCE], sourceRY[MAX_SOURCE];//˔g̒SW
	
	float data[(MAX_SLICE+1)*(MAX_SLICE+1)];//Wave̍f[^
	Mode mode;
	Boundary boundary;
	//o֐
	CWave();
	void draw();
	void clear();
	void makeWave(float elapseTime);
	void makeWaveFree(float elapseTime);
	void makeWaveFixed(float elapseTime);

private:
	float getSingleWave(float r, float elapseTime, int k);
	float getContinuousWave(float r, float elapseTime, int k);

};
CWave wave;
//-------------------------------------------------------------------
CWave::CWave()
{
	nSource = 1;
	nSlice = 100;
	period = 1.0;
	lambda = 2.0;
	amp0 = 0.05;
	mode = SINGLE;
	boundary = B_NON;
	sizeX = 50.0;
	sizeY = 50.0;
}
//--------------------------------------------------------
void CWave::draw()
{
	static float diffuse[] = { 0.4f, 0.6f, 0.9f, 1.0f} ;
	static float ambient[] = { 0.1f, 0.2f, 0.3f, 1.0f};
	static float specular[]= { 1.0f, 1.0f, 1.0f, 1.0f};

	glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
	glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
	glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
	glMaterialf(GL_FRONT,GL_SHININESS,10);

	drawElevation(nSlice, nSlice, sizeX, sizeY, 0, data);
}
//----------------------------------------------------------------
void CWave::clear()
{
	for(int j = 0; j <= nSlice; j++)
	for(int i = 0; i <= nSlice; i++) data[j * (nSlice + 1) + i] = 0.0;
}
//-----------------------------------------------------------------------
float CWave::getSingleWave(float r, float time, int k)
{
    float phase;
    float a = 0.0;

    phase = 2.0 * M_PI * ( time / period - r / lambda);

    if(phase >= 0.0 && phase < M_PI) 
		a = (float)( amp0 * sin(phase) )  / (0.1 + sqrt(r)) ;
 
	if(a > amp0) a = amp0;
	if(a < -amp0) a = -amp0;
    return( a );
}
//------------------------------------------------------------------------
float CWave::getContinuousWave(float r, float time, int k)
{
    float phase;
    float a = 0.0;

    phase = 2.0 * M_PI * ( time / period - r / lambda);

    if(phase >= 0.0) 
		a = (float)( amp0 * sin(phase) )  / (0.001 + sqrt(r)) ;

	if(a > amp0) a = amp0;
	if(a < -amp0) a = -amp0;
    return( a );
}
//-------------------------------------------------------------------------
void CWave::makeWave(float elapseTime)
{
	int i, j, k;
	float x, y, r;
	float meshX = sizeX / (float)nSlice;
	float meshY = sizeY / (float)nSlice;

	clear();

	for(k = 0; k < nSource; k++)
	{
		for(j = 0; j <= nSlice; j++)
		{
			y = (float)( - nSlice / 2 + j) * meshY - sourceY[k];
			for(i = 0; i <= nSlice; i++)
			{
				x = (float)( - nSlice / 2 + i) * meshX - sourceX[k];
				r = sqrt( x * x + y * y);//g̋
				if(mode == SINGLE)
					data[j * (nSlice + 1) + i] += getSingleWave(r, elapseTime, k);
				else
					data[j * (nSlice + 1) + i] += getContinuousWave(r, elapseTime, k);

			}
		}
	}

}
//-------------------------------------------------------------------------
void CWave::makeWaveFree(float elapseTime)
{
	int i, j, k;
	float x, y, r;
	float meshX = sizeX / (float)nSlice;
	float meshY = sizeY / (float)nSlice;

	clear();

	for(k = 0; k < nSource; k++)
	{
		for(j = 0; j <= nSlice; j++)
		{
			y = (float)( - nSlice / 2 + j) * meshY - sourceY[k];
			for(i = 0; i <= nSlice; i++)
			{
				x = (float)( - nSlice / 2 + i) * meshX - sourceX[k];
				r = sqrt( x * x + y * y);//g̋
				if(mode == SINGLE)
					data[j * (nSlice + 1) + i] += getSingleWave(r, elapseTime, k);
				else
					data[j * (nSlice + 1) + i] += getContinuousWave(r, elapseTime, k);
			}
		}
	}
	//˂1񂾂Ɍ
	//-xEɂ锽
	for(k = 0; k < nSource; k++)
	{
		sourceRX[k] = -sizeX - sourceX[k]; sourceRY[k] = sourceY[k];
	}
	for(k = 0; k < nSource; k++)
	{
		for(j = 0; j <= nSlice; j++)
		{
			y = (float)( - nSlice / 2 + j) * meshY - sourceRY[k];
			for(i = 0; i <= nSlice; i++)
			{
				x = (float)( - nSlice / 2 + i) * meshX - sourceRX[k];
				r = sqrt( x * x + y * y);//g̋
				if(mode == SINGLE)
					data[j * (nSlice + 1) + i] += getSingleWave(r, elapseTime, k);
				else
					data[j * (nSlice + 1) + i] += getContinuousWave(r, elapseTime, k);
			}
		}
	}
	//+xEɂ锽
	for(k = 0; k < nSource; k++)
	{
		sourceRX[k] = sizeX - sourceX[k]; sourceRY[k] = sourceY[k];
	}
	for(k = 0; k < nSource; k++)
	{
		for(j = 0; j <= nSlice; j++)
		{
			y = (float)( - nSlice / 2 + j) * meshY - sourceRY[k];
			for(i = 0; i <= nSlice; i++)
			{
				x = (float)( - nSlice / 2 + i) * meshX - sourceRX[k];
				r = sqrt( x * x + y * y);//g̋
				if(mode == SINGLE)
					data[j * (nSlice + 1) + i] += getSingleWave(r, elapseTime, k);
				else
					data[j * (nSlice + 1) + i] += getContinuousWave(r, elapseTime, k);
			}
		}
	}
	//-yEɂ锽
	for(k = 0; k < nSource; k++)
	{
		sourceRX[k] = sourceX[k] ; sourceRY[k] = -sizeY - sourceY[k];
	}
	for(k = 0; k < nSource; k++)
	{
		for(j = 0; j <= nSlice; j++)
		{
			y = (float)( - nSlice / 2 + j) * meshY - sourceRY[k];
			for(i = 0; i <= nSlice; i++)
			{
				x = (float)( - nSlice / 2 + i) * meshX - sourceRX[k];
				r = sqrt( x * x + y * y);//g̋
				if(mode == SINGLE)
					data[j * (nSlice + 1) + i] += getSingleWave(r, elapseTime, k);
				else
					data[j * (nSlice + 1) + i] += getContinuousWave(r, elapseTime, k);
			}
		}
	}
	//+yEɂ锽
	for(k = 0; k < nSource; k++)
	{
		sourceRX[k] = sourceX[k]; sourceRY[k] = sizeY - sourceY[k];
	}
	for(k = 0; k < nSource; k++)
	{
		for(j = 0; j <= nSlice; j++)
		{
			y = (float)( - nSlice / 2 + j) * meshY - sourceRY[k];
			for(i = 0; i <= nSlice; i++)
			{
				x = (float)( - nSlice / 2 + i) * meshX - sourceRX[k];
				r = sqrt( x * x + y * y);//g̋
				if(mode == SINGLE)
					data[j * (nSlice + 1) + i] += getSingleWave(r, elapseTime, k);
				else
					data[j * (nSlice + 1) + i] += getContinuousWave(r, elapseTime, k);
			}
		}
	}

}
//-------------------------------------------------------------------------
void CWave::makeWaveFixed(float elapseTime)
{
	int i, j, k;
	float x, y, r;
	float meshX = sizeX / (float)nSlice;
	float meshY = sizeY / (float)nSlice;

	clear();

	for(k = 0; k < nSource; k++)
	{
		for(j = 0; j <= nSlice; j++)
		{
			y = (float)( - nSlice / 2 + j) * meshY - sourceY[k];
			for(i = 0; i <= nSlice; i++)
			{
				x = (float)( - nSlice / 2 + i) * meshX - sourceX[k];
				r = sqrt( x * x + y * y);//g̋
				if(mode == SINGLE)
					data[j * (nSlice + 1) + i] += getSingleWave(r, elapseTime, k);
				else
					data[j * (nSlice + 1) + i] += getContinuousWave(r, elapseTime, k);
			}
		}
	}
	//˂1񂾂Ɍ
	//-xEɂ锽
	for(k = 0; k < nSource; k++)
	{
		sourceRX[k] = -sizeX - sourceX[k]; sourceRY[k] = sourceY[k];
	}
	for(k = 0; k < nSource; k++)
	{
		for(j = 0; j <= nSlice; j++)
		{
			y = (float)( - nSlice / 2 + j) * meshY - sourceRY[k];
			for(i = 0; i <= nSlice; i++)
			{
				x = (float)( - nSlice / 2 + i) * meshX - sourceRX[k];
				r = sqrt( x * x + y * y);//g̋
				if(mode == SINGLE)
					data[j * (nSlice + 1) + i] -= getSingleWave(r, elapseTime, k);
				else
					data[j * (nSlice + 1) + i] -= getContinuousWave(r, elapseTime, k);
			}
		}
	}
	//+xEɂ锽
	for(k = 0; k < nSource; k++)
	{
		sourceRX[k] = sizeX - sourceX[k]; sourceRY[k] = sourceY[k];
	}
	for(k = 0; k < nSource; k++)
	{
		for(j = 0; j <= nSlice; j++)
		{
			y = (float)( - nSlice / 2 + j) * meshY - sourceRY[k];
			for(i = 0; i <= nSlice; i++)
			{
				x = (float)( - nSlice / 2 + i) * meshX - sourceRX[k];
				r = sqrt( x * x + y * y);//g̋
				if(mode == SINGLE)
					data[j * (nSlice + 1) + i] -= getSingleWave(r, elapseTime, k);
				else
					data[j * (nSlice + 1) + i] -= getContinuousWave(r, elapseTime, k);
			}
		}
	}
	//-yEɂ锽
	for(k = 0; k < nSource; k++)
	{
		sourceRX[k] = sourceX[k] ; sourceRY[k] = -sizeY - sourceY[k];
	}
	for(k = 0; k < nSource; k++)
	{
		for(j = 0; j <= nSlice; j++)
		{
			y = (float)( - nSlice / 2 + j) * meshY - sourceRY[k];
			for(i = 0; i <= nSlice; i++)
			{
				x = (float)( - nSlice / 2 + i) * meshX - sourceRX[k];
				r = sqrt( x * x + y * y);//g̋
				if(mode == SINGLE)
					data[j * (nSlice + 1) + i] -= getSingleWave(r, elapseTime, k);
				else
					data[j * (nSlice + 1) + i] -= getContinuousWave(r, elapseTime, k);
			}
		}
	}
	//+yEɂ锽
	for(k = 0; k < nSource; k++)
	{
		sourceRX[k] = sourceX[k]; sourceRY[k] = sizeY - sourceY[k];
	}
	for(k = 0; k < nSource; k++)
	{
		for(j = 0; j <= nSlice; j++)
		{
			y = (float)( - nSlice / 2 + j) * meshY - sourceRY[k];
			for(i = 0; i <= nSlice; i++)
			{
				x = (float)( - nSlice / 2 + i) * meshX - sourceRX[k];
				r = sqrt( x * x + y * y);//g̋
				if(mode == SINGLE)
					data[j * (nSlice + 1) + i] -= getSingleWave(r, elapseTime, k);
				else
					data[j * (nSlice + 1) + i] -= getContinuousWave(r, elapseTime, k);
			}
		}
	}
}
