
#define MAX_SLICE 160//ő啪iӓj
#define MAX_SOURCE  21//Sg

enum WaveMode { SINGLE, CONTINUOUS };
enum Boundary { B_NON, B_FREE, B_FIXED };

class CWave2D
{
public:
	int nSource;//g
	int nSlice;//
	int nSlice0;//L
	int nDummy;//_~[iБj

	float freq;
	float amp0;
	float size0;//L̈1ӂ̒
	float size;//_~[܂1ӂ̒
	int sourceI[MAX_SOURCE], sourceJ[MAX_SOURCE];//~`g̒SW
	float velocity[MAX_SLICE+1][MAX_SLICE+1];//z̑x
	float position[MAX_SLICE+1][MAX_SLICE+1];//
	bool flagFixed[MAX_SLICE+1][MAX_SLICE+1];
	WaveMode mode;
	Boundary boundary;
	float waveVel;
    float drag0;

    //F
    //o֐
    CWave2D();
    void draw(bool flagShadow);
    void initialize();
    void calcWaveEquation(double dt);
private:
};
CWave2D wave;
//---------------------------------------------------------------
CWave2D::CWave2D()
{
    nSlice = 160;
	nSlice0 = 100;
	nDummy = 30;
	size0 = 10.0;
	size = 10.0;
	nSource = 1;
	mode = SINGLE;
	boundary = B_FREE;
	freq = 1.0;
	waveVel = 1.0;//`x
	drag0 = 0.5;//SR
}
//-----------------------------------------------------------------
void CWave2D::draw(bool flagShadow)
{
    int i, j, np;
    float data[(MAX_SLICE+1) * (MAX_SLICE+1)]; //_W()

	static float diffuse[] = { 0.4f, 0.6f, 0.9f, 1.0f};
	static float ambient[] = { 0.1f, 0.2f, 0.3f, 1.0f};
	static float specular[]= { 1.0f, 1.0f, 1.0f, 1.0f};

	glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
	glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
	glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
	glMaterialf(GL_FRONT,GL_SHININESS,10);

	//e_̍W
    for(j = nDummy; j <= nSlice0 + nDummy; j++){
	    for(i = nDummy; i <= nSlice0 + nDummy; i++){
		    np = (j - nDummy) * (nSlice0 + 1) + i - nDummy;
		    data[np] = position[i][j];
	    }
    }
	drawElevation(nSlice0, nSlice0, size0, size0, 0, data);
}

//-----------------------------------------------------------------
void CWave2D::initialize()
{
    int i, j;

    //_̃TCYCʒu
    for(i = 0; i <= nSlice; i++)
        for(j = 0; j <= nSlice; j++){
			velocity[i][j] = 0.0;
			position[i][j] = 0.0;
			flagFixed[i][j] = false;
        }
}

//-----------------------------------------------------------------------------
//Q̃ol}Xf(hinge springlCRԂŉ^)
void CWave2D::calcWaveEquation(double dt)
{                        
    int i, j;
	float accel = 0.0;
	float d = size0 / (float)nSlice0;//iqԊu
	float dd = d * d;
	float drag = drag0;
	int nm = (nSlice - nSlice0) / 2;//˂̂Ƃ̗L̈拫Eԍ	
	int np = (nSlice + nSlice0) / 2;
	int im, ip, jm, jp;
	float zmi, zpi, zmj, zpj;
	float dragMax = 1.0;
	float coef = 4.0;

    //point̑xƈʒu̍XV(Euler@)
    for(j = 0; j <= nSlice; j++)
    { 
        for(i = 0; i <= nSlice; i++)
        {
            if(flagFixed[i][j] == true) continue; //Œ
			drag = drag0;
			if(boundary == B_NON)
			{
				if(j < nm) drag = drag0 + dragMax * (float)(nm - j) / (float)nDummy;
				if(j > np) drag = drag0 + dragMax * (float)(j - np) / (float)nDummy;
				if(i < nm) drag = drag0 + dragMax * (float)(nm - i) / (float)nDummy;
				if(i > np) drag = drag0 + dragMax * (float)(i - np) / (float)nDummy;
			}
			im = i-1; ip = i+1; jm = j-1; jp = j+1;
			if(im < 0) zmi = 0.0; 
			else zmi = position[i-1][j];
			if(ip > nSlice) zpi = 0.0;
			else zpi = position[i+1][j];
			if(jm < 0) zmj = 0.0;
			else zmj = position[i][j-1];
			if(jp > nSlice) zpj = 0.0;
			else zpj = position[i][j+1];

			if(im < 0.0 || jm < 0.0 || ip > nSlice || jp > nSlice) coef = 3.0;
			else coef = 4.0;

			accel = (waveVel * waveVel) * ((zmi + zpi + zmj + zpj) - coef * position[i][j]) / dd;
  
			//SR
			accel -= drag * velocity[i][j];
            //x
            velocity[i][j] += accel * dt;
            //ʒu
            position[i][j] += velocity[i][j] * dt;
         }
    }
}

