
//collision3D.h

void collisionWithFree(int i, int j, float dt);
void collisionWithFixed(int i, int j, float dt);
float checkCollision(int i, int j, CVector &vNormal);

void collision(float dt)
{
	int i, j;

	for(i = 0; i < numRigid0; i++) 
	{
		if(rigid[i].flagFixed == true) continue;
		rigid[i].action(dt);
	}

	for(i = 0; i < numRigid0; i++)
	{   
		if(rigid[i].flagFixed == true) continue;

		for(j = 0; j < numRigid0; j++)
		{
			if(i == j) continue;

			//Eŗ\
			float d = vDist2(rigid[i].vPos, rigid[j].vPos);//2拗
			float a = rigid[i].boundingR + rigid[j].boundingR;
			if(d > a*a) continue;
			if(rigid[j].flagFixed == false)
				collisionWithFree(i, j, dt);//Ώۍ̂Free
			else                                                     
				collisionWithFixed(i, j, dt);//Ώۍ̂fixed
		}
	}
}
//--------------------------------------------------------------------------
void collisionWithFree(int i, int j, float dt)
{
	float rikiseki;
	float vn1, vn2;//@̑傫
	float muc,B, m1, m2;
	CVector vVelocityP1, vVelocityP2;//x
	CVector vNormal;//ڍ̂猩Փ˖ʂ̖@
	CVector vTangential;//ڐ
	CVector vDir, vA1, vA2, vRg1, vRg2;

	float depth = checkCollision(i, j, vNormal);//Փ˔
	if(depth < 0.0) return;

	rigid[i].vForce = CVector();
	rigid[i].vTorque = CVector();
	rigid[j].vForce = CVector();
	rigid[j].vTorque = CVector();

	vRg1 = rigid[i].vGravityToPoint;
	vRg2 = rigid[j].vGravityToPoint;
	m1 = rigid[i].mass;
	m2 = rigid[j].mass;

	vVelocityP1 = rigid[i].vVelocity + vCross(rigid[i].vOmega, vRg1);
	vn1 = vDot(vVelocityP1, vNormal);
	vVelocityP2 = rigid[j].vVelocity + vCross(rigid[j].vOmega, vRg2);
	vn2 = vDot(vVelocityP2, vNormal);

	//Փˉ
	vTangential = vCross( vNormal, vCross((vVelocityP1 - vVelocityP2), vNormal));
	vTangential.norm();
	//͐
	rikiseki = - (restitut + 1.0) * (vn1 - vn2) / (1.0/m1 + 1.0/m2
		  + vDot(vNormal , vCross((rigid[i].mInertiaInverse * vCross(vRg1, vNormal)), vRg1))
		  + vDot(vNormal , vCross((rigid[j].mInertiaInverse * vCross(vRg2, vNormal)), vRg2)));
	//͂̑a
	rigid[i].vForce += (vNormal) * rikiseki / dt;
	rigid[j].vForce -= (vNormal) * rikiseki / dt;
	//͂̃[gigNj̑a
	rigid[i].vTorque += vCross(vRg1, vNormal) * rikiseki / dt;
	rigid[j].vTorque -= vCross(vRg2, vNormal) * rikiseki / dt;

	//Cl
	vA1 = vCross(((rigid[i].mInertiaInverse * vCross(vRg1, vTangential))) , vRg1);
	vA2 = vCross(((rigid[j].mInertiaInverse * vCross(vRg2, vTangential))) , vRg2);
	B = - vDot(vTangential, (vVelocityP1-vVelocityP2)) / (1.0f/m1+1.0f/m2+ vDot(vTangential,(vA1+vA2)));
	muc = fabs(B / rikiseki);
	if(muK >= muc)
	{
		rigid[i].vForce +=  vTangential* B / dt;
		rigid[i].vTorque += vCross(vRg1, vTangential) * B / dt;
		rigid[j].vForce -=  vTangential* B / dt;
		rigid[j].vTorque -= vCross(vRg2, vTangential) * B / dt;
	}
	else
	{
		rigid[i].vForce +=  muK * (rikiseki / dt) * vTangential;
		rigid[i].vTorque += vCross(vRg1, vTangential) * muK * rikiseki / dt;
		rigid[j].vForce -=  muK * (rikiseki / dt) * vTangential;
		rigid[j].vTorque -= vCross(vRg2, vTangential) * muK * rikiseki / dt;
	}
	//Փ˔莞ɂ߂荞񂾕
	rigid[i].vPos -= (depth/2.0+0.01) * vNormal;//0.01͕mɂ邽				
	rigid[j].vPos += (depth/2.0+0.01) * vNormal;

	//ʒu]px̍XV
	// iԖڂ̍
	rigid[i].vAccel = rigid[i].vForce / m1;    //x
	rigid[i].vVelocity += rigid[i].vAccel * dt;//x
	rigid[i].vAlpha = rigid[i].mInertiaInverse * rigid[i].vTorque;//px̍XV
	rigid[i].vOmega += rigid[i].vAlpha * dt;          //px

	// jԂ̍
	rigid[j].vAccel = rigid[j].vForce / m2;
	rigid[j].vVelocity += rigid[j].vAccel * dt;
	rigid[j].vAlpha = rigid[j].mInertiaInverse * rigid[j].vTorque;
	rigid[j].vOmega += rigid[j].vAlpha * dt;

}
//------------------------------------------------------------------------------
void collisionWithFixed(int i, int j, float dt)
{
	double rikiseki;
	double vn1;//@̑傫
	double muc, B, m1;
	CVector vVelocityP1;//x
	CVector vNormal;//ڍ̂猩Փ˖ʂ̖@
	CVector vTangential;//ڐ
	CVector vDir, vA1, vRg1;

	float depth = checkCollision(i, j, vNormal);//Փ˔
	if(depth < 0.0) return;

	rigid[i].vForce = rigid[i].vForce0;
	rigid[i].vTorque = CVector();

	vRg1 = rigid[i].vGravityToPoint;
	m1 = rigid[i].mass;

	vVelocityP1 = rigid[i].vVelocity + vCross(rigid[i].vOmega, vRg1);
	vn1 = vDot(vVelocityP1 , vNormal);

	//Փˉ
	vTangential = vCross( vNormal, vCross(vVelocityP1, vNormal));
	vTangential.norm();
	//͐
	rikiseki = - (restitut + 1.0) * vn1 / (1.0/m1 
		  + vDot(vNormal , vCross((rigid[i].mInertiaInverse * vCross(vRg1, vNormal)), vRg1)));
	//͂̑a
	rigid[i].vForce += (vNormal) * rikiseki / dt;
	//͂̃[gigNj̑a
	rigid[i].vTorque += vCross(vRg1, vNormal) * rikiseki / dt;

	//Cl
	vA1 = vCross(((rigid[i].mInertiaInverse * vCross(vRg1, vTangential))) , vRg1);
	B = - vDot(vTangential, vVelocityP1) / (1.0f/m1 + vDot(vTangential, vA1));
	muc = fabs(B / rikiseki);
	if(muK >= muc)
	{
		rigid[i].vForce +=  vTangential* B / dt;
		rigid[i].vTorque += vCross(vRg1, vTangential) * B / dt;
	}
	else
	{
		rigid[i].vForce +=  muK * (rikiseki / dt) * vTangential;
		rigid[i].vTorque += vCross(vRg1, vTangential) * muK * rikiseki / dt;
	}

	//Փ˔莞ɂ߂荞񂾕
	rigid[i].vPos -= (depth + 0.001) * vNormal;

	//ʒu]px̍XV
	//iԖڂ̍
	rigid[i].vAccel = rigid[i].vForce / rigid[i].mass;//x
	rigid[i].vVelocity += rigid[i].vAccel * dt;       //x

	rigid[i].vAlpha = rigid[i].mInertiaInverse * rigid[i].vTorque;//px̍XV
	rigid[i].vOmega += rigid[i].vAlpha * dt;          //px
}

//--------------------------------------------------------------------------------------------
float checkCollision(int i, int j, CVector &vNormal)
{//Փ˔

	float depth;
	if(rigid[i].kind == SPHERE)
	{
		switch(rigid[j].kind ) 
		{
			case SPHERE://m
				depth = rigid[i].collisionSphereWithSphere(rigid[j], vNormal);
				return depth;
				break;
			case CUBE:
				depth = rigid[i].collisionSphereWithCube(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionCubeWithSphere(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case CYLINDER://~
				depth = rigid[i].collisionSphereWithCylinder(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionCylinderWithSphere(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case ELLIPSOID:
				depth = rigid[j].collisionEllipsoidWithSphere(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();	
				return depth;
				break;
		}
	}

	else if(rigid[i].kind == CUBE)
	{
		switch(rigid[j].kind)
		{
			case SPHERE:
				depth = rigid[i].collisionCubeWithSphere(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionSphereWithCube(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case CUBE:
				depth = rigid[i].collisionCubeWithCube(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionCubeWithCube(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case CYLINDER://()~
				depth = rigid[i].collisionCubeWithCylinder(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionCylinderWithCube(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;

			case ELLIPSOID://ȉ~
				depth = rigid[i].collisionCubeWithEllipsoid(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionEllipsoidWithCube(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
		}
	}

	else if(rigid[i].kind == CYLINDER)//()~
	{
		switch(rigid[j].kind )
		{
			case SPHERE:
				depth = rigid[i].collisionCylinderWithSphere(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionSphereWithCylinder(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case CUBE:
				//ԂύX
				depth = rigid[j].collisionCubeWithCylinder(rigid[i], vNormal);
				if(depth >= 0.0) {vNormal.reverse();return depth;}
				depth = rigid[i].collisionCylinderWithCube(rigid[j], vNormal);
				return depth;
				break;
			case CYLINDER://~m
				depth = rigid[i].collisionCylinderWithCylinder(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionCylinderWithCylinder(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
			break;
			case ELLIPSOID:
				depth = rigid[i].collisionCylinderWithEllipsoid(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionEllipsoidWithCylinder(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
		}
	}

	else if(rigid[i].kind == ELLIPSOID)//#1ȉ~
	{
		switch(rigid[j].kind) 
		{ 
			case ELLIPSOID:
				depth = rigid[i].collisionEllipsoidWithEllipsoid(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionEllipsoidWithEllipsoid(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case SPHERE:
				depth = rigid[i].collisionEllipsoidWithSphere(rigid[j], vNormal);
				return depth;
				break;
			case CUBE:
				//ύX
				depth = rigid[j].collisionCubeWithEllipsoid(rigid[i], vNormal);
				if(depth >= 0.0) {vNormal.reverse();return depth;}
				depth = rigid[i].collisionEllipsoidWithCube(rigid[j], vNormal);
				return depth;
				break;
			case CYLINDER:
				depth = rigid[i].collisionEllipsoidWithCylinder(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionCylinderWithEllipsoid(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
		}
	}
	return NON_COLLISION;
}

