
//collision3D.h

void collisionWithFree(int i, int j, float dt);
void collisionWithRest(int i, int j, float dt);
float checkCollision(int i, int j, CVector &vNormal);

void collision(float dt)
{
	int i, j;

	for(i = 0; i < numRigid0; i++) 
	{
		if(rigid[i].wall == 1) continue;
		rigid[i].action3D(dt);//^(rigid3D.h)
	}

	if(!flagCollision) return;

	for(i = 0; i < numRigid0; i++)
	{   
		if(rigid[i].wall == 1) continue;

		if(rigid[i].state == RESTING || rigid[i].state == RESTING_ON_FLOOR) continue;
		for(j = numWall; j < numRigid0; j++)
		{
//printf("i = %d   j=%d is rest \n",i, j);
			if(i == j) continue;

			//Eŗ\
			float d = vDist2(rigid[i].vPos, rigid[j].vPos);//2拗
			float a = rigid[i].boundingR + rigid[j].boundingR;
			if(d > a*a) continue;
			if(rigid[j].state == FREE || rigid[j].state == FREE_ON_FLOOR)
				collisionWithFree(i, j, dt);//Ώۍ̂o
			else                                                     
				collisionWithRest(i, j, dt);//Ώۍ̂Î~
		}
		for(j = 0; j < numWall; j++) 
		{
			float a = rigid[i].vSize.x / 2.0 + wallThickness / 2.0;
			if(j == 0)//̕
				if(rigid[i].vPos.x - a > -wallWidthX/2.0) continue;
			if(j == 1)//
				if(rigid[i].vPos.y - a > -wallWidthY/2.0) continue;
			if(j == 2)//E
				if(rigid[i].vPos.y + a <  wallWidthY/2.0) continue;
			if(j == 3)//O
				if(rigid[i].vPos.x + a <  wallWidthX/2.0) continue;

			collisionWithRest(i, j, dt);//Ώۍ̂
		}
	}

	float distEnforce = 0.5;//
	CVector vDir;
	for(i = numWall; i < numRigid; i++)
	{ 
		if(flagSeparate && !rigid[i].wall)
		{
			//(x,y,z̃TCYxłȂΗpsj
			for(j = 0; j < numRigid; j++)
			{
				float a = (rigid[i].vSize.x + rigid[j].vSize.x)/2.5;
				float d = vDist(rigid[i].vPos, rigid[j].vPos);//
				if(d < 0.1) vDir = CVector(1.0, 1.0, 0.0);//[߂荞񂾏ꍇ
				else vDir = rigid[i].vPos >> rigid[j].vPos;
				if(d < a)
				{
					if(!rigid[i].wall) rigid[i].vPos -= distEnforce * vDir;
					if(!rigid[j].wall) rigid[j].vPos += distEnforce * vDir;
				}
			}
		}
	}
}
//--------------------------------------------------------------------------
void collisionWithFree(int i, int j, float dt)
{
	float rikiseki;
	float vn1, vn2;//@̑傫
	float muc,B, m1, m2;
	CVector vVelocityP1, vVelocityP2;//x
	CVector vNormal;//ڍ̂猩Փ˖ʂ̖@
	CVector vTangential;//ڐ
	CVector vDir, vA1, vA2, vRg1, vRg2;

	float depth = checkCollision(i, j, vNormal);//Փ˔
	if(depth < 0.0) return;

	rigid[i].vForce = CVector();
	rigid[i].vTorque = CVector();
	rigid[j].vForce = CVector();
	rigid[j].vTorque = CVector();

	vRg1 = rigid[i].vGravityToPoint;
	vRg2 = rigid[j].vGravityToPoint;
	m1 = rigid[i].mass;
	m2 = rigid[j].mass;

	vVelocityP1 = rigid[i].vVelocity + vCross(rigid[i].vOmega, vRg1);
	vn1 = vDot(vVelocityP1, vNormal);
	vVelocityP2 = rigid[j].vVelocity + vCross(rigid[j].vOmega, vRg2);
	vn2 = vDot(vVelocityP2, vNormal);

	//Փˉ
	vTangential = vCross( vNormal, vCross((vVelocityP1 - vVelocityP2), vNormal));
	vTangential.norm();
	//͐
	rikiseki = - (restitut + 1.0) * (vn1 - vn2) / (1.0/m1 + 1.0/m2
		  + vDot(vNormal , vCross((rigid[i].mInertiaInverse * vCross(vRg1, vNormal)), vRg1))
		  + vDot(vNormal , vCross((rigid[j].mInertiaInverse * vCross(vRg2, vNormal)), vRg2)));
	//͂̑a
	rigid[i].vForce += (vNormal) * rikiseki / dt;
	rigid[j].vForce -= (vNormal) * rikiseki / dt;
	//͂̃[gigNj̑a
	rigid[i].vTorque += vCross(vRg1, vNormal) * rikiseki / dt;
	rigid[j].vTorque -= vCross(vRg2, vNormal) * rikiseki / dt;

	//Cl
	vA1 = vCross(((rigid[i].mInertiaInverse * vCross(vRg1, vTangential))) , vRg1);
	vA2 = vCross(((rigid[j].mInertiaInverse * vCross(vRg2, vTangential))) , vRg2);
	B = - vDot(vTangential, (vVelocityP1-vVelocityP2)) / (1.0f/m1+1.0f/m2+ vDot(vTangential,(vA1+vA2)));
	muc = fabs(B / rikiseki);
	if(muK >= muc)
	{
		rigid[i].vForce +=  vTangential* B / dt;
		rigid[i].vTorque += vCross(vRg1, vTangential) * B / dt;
		rigid[j].vForce -=  vTangential* B / dt;
		rigid[j].vTorque -= vCross(vRg2, vTangential) * B / dt;
	}
	else
	{
		rigid[i].vForce +=  muK * (rikiseki / dt) * vTangential;
		rigid[i].vTorque += vCross(vRg1, vTangential) * muK * rikiseki / dt;
		rigid[j].vForce -=  muK * (rikiseki / dt) * vTangential;
		rigid[j].vTorque -= vCross(vRg2, vTangential) * muK * rikiseki / dt;
	}
	//Փ˔莞ɂ߂荞񂾕
	rigid[i].vPos -= (depth/2.0+0.01) * vNormal;//0.01͕mɂ邽				
	rigid[j].vPos += (depth/2.0+0.01) * vNormal;

	//ppɂ锽͂^
	rigid[i].vForce -= depth * cSpring * vNormal;
	rigid[j].vForce += depth * cSpring * vNormal;

	if(flagRest && rigid[i].state == FREE_ON_FLOOR && rigid[j].state == FREE_ON_FLOOR)
	{
	  if(flagRest && (rigid[i].vVelocity.magnitude() + 0.2 * rigid[i].vOmega.magnitude()) < restValue) 
		{
			rigid[i].setResting();
			return;
		}
	}

	//ʒu]px̍XV
	// iԖڂ̍
	rigid[i].vAccel = rigid[i].vForce / m1;    //x
	rigid[i].vVelocity += rigid[i].vAccel * dt;//x
	rigid[i].vAlpha = rigid[i].mInertiaInverse * rigid[i].vTorque;//px̍XV
	rigid[i].vOmega += rigid[i].vAlpha * dt;          //px

	// jԂ̍
	rigid[j].vAccel = rigid[j].vForce / m2;
	rigid[j].vVelocity += rigid[j].vAccel * dt;
	rigid[j].vAlpha = rigid[j].mInertiaInverse * rigid[j].vTorque;
	rigid[j].vOmega += rigid[j].vAlpha * dt;

}
//------------------------------------------------------------------------------
void collisionWithRest(int i, int j, float dt)
{
	double rikiseki;
	double vn1;//@̑傫
	double muc, B, m1;
	CVector vVelocityP1;//x
	CVector vNormal;//ڍ̂猩Փ˖ʂ̖@
	CVector vTangential;//ڐ
	CVector vDir, vA1, vRg1;

	float depth = checkCollision(i, j, vNormal);//Փ˔
	if(depth < 0.0) return;

	rigid[i].vForce = rigid[i].vForce0;
	rigid[i].vTorque = CVector();

	vRg1 = rigid[i].vGravityToPoint;
	m1 = rigid[i].mass;

	vVelocityP1 = rigid[i].vVelocity + vCross(rigid[i].vOmega, vRg1);
	vn1 = vDot(vVelocityP1 , vNormal);

	//Փˉ
	vTangential = vCross( vNormal, vCross(vVelocityP1, vNormal));
	vTangential.norm();
	//͐
	rikiseki = - (restitut + 1.0) * vn1 / (1.0/m1 
		  + vDot(vNormal , vCross((rigid[i].mInertiaInverse * vCross(vRg1, vNormal)), vRg1)));
	//͂̑a
	rigid[i].vForce += (vNormal) * rikiseki / dt;
	//͂̃[gigNj̑a
	rigid[i].vTorque += vCross(vRg1, vNormal) * rikiseki / dt;

	//printf("i=%d, J=%f, mv=%f \n", i, rikiseki, rigid[i].mass * rigid[i].vVelocity.magnitude()); 
	//^ʂ󂯂Ƃo
	if(fabs(rikiseki) > awakeValue && rigid[j].wall == 0)
	{
		if(awakeMode == ONLY) rigid[j].state = FREE;
		else
		{
			for(int k = 0; k < numRigid0; k++) rigid[k].state = FREE;//o
			flagRest = false;
		}
		collisionWithFree(i, j, dt);
		return;
	}

	//Cl
	  vA1 = vCross(((rigid[i].mInertiaInverse * vCross(vRg1, vTangential))) , vRg1);
	  B = - vDot(vTangential, vVelocityP1) / (1.0f/m1 + vDot(vTangential, vA1));
	muc = fabs(B / rikiseki);
	if(muK >= muc)
	{
		rigid[i].vForce +=  vTangential* B / dt;
		rigid[i].vTorque += vCross(vRg1, vTangential) * B / dt;
	}
	else
	{
		rigid[i].vForce +=  muK * (rikiseki / dt) * vTangential;
		rigid[i].vTorque += vCross(vRg1, vTangential) * muK * rikiseki / dt;
	}

	//Փ˔莞ɂ߂荞񂾕
	rigid[i].vPos -= (depth + 0.001) * vNormal;

	//Î~ڐG(ppɂ锽)
	rigid[i].vForce +=  - depth * cSpring * vNormal;

	if(rigid[i].vPos.z > rigid[j].vPos.z)
	{
		if((rigid[i].vVelocity.magnitude() + 0.2 * rigid[i].vOmega.magnitude()) < restValue) 
		{
			rigid[i].setResting();
			return;
		}
	}

	//ʒu]px̍XV
	//iԖڂ̍
	rigid[i].vAccel = rigid[i].vForce / rigid[i].mass;//x
	rigid[i].vVelocity += rigid[i].vAccel * dt;       //x

	rigid[i].vAlpha = rigid[i].mInertiaInverse * rigid[i].vTorque;//px̍XV
	rigid[i].vOmega += rigid[i].vAlpha * dt;          //px
}

//--------------------------------------------------------------------------------------------
float checkCollision(int i, int j, CVector &vNormal)
{//Փ˔

	float depth;
	if(rigid[i].kind == SPHERE)
	{
		switch(rigid[j].kind ) 
		{
			case SPHERE://m
				depth = rigid[i].collisionSphereWithSphere(rigid[j], vNormal);
				return depth;
				break;
			case CUBE:
			case BOX:
			case PET:
			case VEHICLE:
				depth = rigid[i].collisionSphereWithCube(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionCubeWithSphere(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case CYLINDER://~
			case COLUMN:
				depth = rigid[i].collisionSphereWithCylinder(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionCylinderWithSphere(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case ELLIPSOID:
				depth = rigid[j].collisionEllipsoidWithSphere(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();	
				return depth;
				break;
			case TORUS:
				depth = rigid[j].collisionTorusWithSphere(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();	
				return depth;
				break;
			case CONE:
			case PYRAMID:
				depth = rigid[j].collisionSuperWithSphere(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();	
				return depth;
				break;
		}
	}

	else if(rigid[i].kind == CUBE || rigid[i].kind == BOX || rigid[i].kind == PET || rigid[i].kind == VEHICLE)
	{
		switch(rigid[j].kind)
		{
			case SPHERE:
				depth = rigid[i].collisionCubeWithSphere(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionSphereWithCube(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case CUBE:
			case BOX:
			case PET:
			case VEHICLE:
				depth = rigid[i].collisionCubeWithCube(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionCubeWithCube(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case CYLINDER://()~
			case COLUMN:
				depth = rigid[i].collisionCubeWithCylinder(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionCylinderWithCube(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;

			case ELLIPSOID://ȉ~
				depth = rigid[i].collisionCubeWithEllipsoid(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionEllipsoidWithCube(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case TORUS://g[X
				depth = rigid[i].collisionWithTorus(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionTorusWithCube(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case CONE:
			case PYRAMID:
				depth = rigid[i].collisionCubeWithSuper(rigid[j], vNormal);
//printf("AAA depth= %f \n", depth);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionSuperWithCube(rigid[i], vNormal);
//printf("BBB depth= %f \n", depth);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
    }
	}

  else if(rigid[i].kind == CYLINDER || rigid[i].kind == COLUMN)//()~
  {
    switch(rigid[j].kind )
		{
			case SPHERE:
				depth = rigid[i].collisionCylinderWithSphere(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionSphereWithCylinder(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case CUBE:
			case BOX:
			case PET:
			case VEHICLE:
				//ԂύX
				depth = rigid[j].collisionCubeWithCylinder(rigid[i], vNormal);
				if(depth >= 0.0) {vNormal.reverse();return depth;}
				depth = rigid[i].collisionCylinderWithCube(rigid[j], vNormal);
				return depth;
				break;
			case CYLINDER://~m
			case COLUMN:
				depth = rigid[i].collisionCylinderWithCylinder(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionCylinderWithCylinder(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
        break;
			case ELLIPSOID:
				depth = rigid[i].collisionCylinderWithEllipsoid(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionEllipsoidWithCylinder(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case TORUS:
				depth = rigid[i].collisionWithTorus(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionTorusWithCylinder(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case CONE:
			case PYRAMID:
				depth = rigid[i].collisionCylinderWithSuper(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionSuperWithCylinder(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
		}
  }

  else if(rigid[i].kind == ELLIPSOID)//#1ȉ~
  {
    switch(rigid[j].kind) 
    { 
			case ELLIPSOID:
				depth = rigid[i].collisionEllipsoidWithEllipsoid(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionEllipsoidWithEllipsoid(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case SPHERE:
				depth = rigid[i].collisionEllipsoidWithSphere(rigid[j], vNormal);
				return depth;
				break;
			case CUBE:
			case BOX:
			case PET:
			case VEHICLE:
				//ύX
				depth = rigid[j].collisionCubeWithEllipsoid(rigid[i], vNormal);
				if(depth >= 0.0) {vNormal.reverse();return depth;}
				depth = rigid[i].collisionEllipsoidWithCube(rigid[j], vNormal);
				return depth;
				break;
			case CYLINDER:
			case COLUMN:
				depth = rigid[i].collisionEllipsoidWithCylinder(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionCylinderWithEllipsoid(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case TORUS:
				depth = rigid[i].collisionWithTorus(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionTorusWithEllipsoid(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case CONE:
			case PYRAMID:
				depth = rigid[i].collisionEllipsoidWithSuper(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionSuperWithEllipsoid(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
		}
	}

	else if(rigid[i].kind == TORUS)
	{
		switch(rigid[j].kind) 
		{
		case TORUS:
				depth = rigid[i].collisionWithTorus(rigid[j], vNormal);
				return depth;
				break;
			case SPHERE:
				depth = rigid[i].collisionTorusWithSphere(rigid[j], vNormal);
				return depth;
				break;
			case CUBE:
			case BOX:
			case PET:
			case VEHICLE:
				depth = rigid[i].collisionTorusWithCube(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionWithTorus(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case CYLINDER:
			case COLUMN:
				depth = rigid[i].collisionTorusWithCylinder(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionWithTorus(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case ELLIPSOID:
				depth = rigid[i].collisionTorusWithEllipsoid(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionWithTorus(rigid[i], vNormal);
				if(depth >= 0.0)vNormal.reverse();
				return depth;
				break;
			case CONE:
			case PYRAMID:
				depth = rigid[i].collisionTorusWithSuper(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionWithTorus(rigid[i], vNormal);
				if(depth >= 0.0)vNormal.reverse();
				return depth;
				break;
		}
	}
	else if(rigid[i].kind == CONE || rigid[i].kind == PYRAMID)
	{
		switch(rigid[j].kind) 
		{
			case CONE:
			case PYRAMID:
				depth = rigid[i].collisionSuperWithSuper(rigid[j], vNormal);
				return depth;
				break;
			case SPHERE:
				depth = rigid[i].collisionSuperWithSphere(rigid[j], vNormal);
				return depth;
				break;
			case CUBE:
			case BOX:
			case PET:
			case VEHICLE:

				//ύX
				depth = rigid[j].collisionCubeWithSuper(rigid[i], vNormal);
				if(depth >= 0.0) { vNormal.reverse(); return depth;}
				depth = rigid[i].collisionSuperWithCube(rigid[j], vNormal);
				return depth;
				break;
			case CYLINDER:
			case COLUMN:
				depth = rigid[i].collisionSuperWithCylinder(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionCylinderWithSuper(rigid[i], vNormal);
				if(depth >= 0.0) vNormal.reverse();
				return depth;
				break;
			case ELLIPSOID:
				depth = rigid[i].collisionSuperWithEllipsoid(rigid[j], vNormal);
				if(depth >= 0.0) return depth;
				depth = rigid[j].collisionEllipsoidWithSuper(rigid[i], vNormal);
				if(depth >= 0.0)vNormal.reverse();
				return depth;
				break;
			case TORUS:
				depth = rigid[i].collisionWithTorus(rigid[j], vNormal);
				return depth;
				depth = rigid[j].collisionSuperWithSuper(rigid[i], vNormal);
				if(depth >= 0.0)vNormal.reverse();
				return depth;
				break;
		}
	}
	return NON_COLLISION;
}

