#include <stdio.h>

#define M_PI 3.14159265358979323846

//@vZ[`
void calcNormal(float* p1,float* p2,float* p3,float* nn)
{
	CVector A = CVector(p2[0] - p1[0], p2[1] - p1[1], p2[2] - p1[2]);
	CVector B = CVector(p3[0] - p2[0], p3[1] - p2[1], p3[2] - p2[2]);
	CVector n = vCross(A , B);//O
	n.norm();
	nn[0] = n.x; nn[1] = n.y; nn[2] = n.z;
}

//------------------------------------------------------------------------------
void drawPlateZ(float s)//x-y
{//ʂ̖@
	float p[4][3] = 
	{ { s/2.0,-s/2.0, 0.0}, { s/2.0, s/2.0, 0.0}, {-s/2.0, s/2.0, 0.0}, 
	  {-s/2.0,-s/2.0, 0.0}};

	glBegin(GL_QUADS);
		glNormal3f(0.0, 0.0, 1.0); //z̖@
		glVertex3fv(p[0]);
		glVertex3fv(p[1]);
		glVertex3fv(p[2]);
		glVertex3fv(p[3]);
	glEnd();
}
//------------------------------------------------------------------------------
void drawPlateY(float s)//x-z
{//ʂ̖@y
	float p[4][3] = 
	{ { s/2.0, 0.0, s/2.0}, { s/2.0, 0.0,-s/2.0}, {-s/2.0, 0.0,-s/2.0}, {-s/2.0, 0.0, s/2.0}};

	glBegin(GL_QUADS);
		glNormal3f(0.0, 1.0, 0.0); //y̖@
		glVertex3fv(p[0]);
		glVertex3fv(p[1]);
		glVertex3fv(p[2]);
		glVertex3fv(p[3]);
	glEnd();
}

//-----------------------------------------------------------------------

void drawCube(float s)
{
	float p[8][3] = 
	{ {0.5*s,0.5*s,0.5*s}, {-0.5*s,0.5*s,0.5*s}, {-0.5*s,-0.5*s,0.5*s}, 
	  {0.5*s,-0.5*s,0.5*s},{0.5*s,0.5*s,-0.5*s}, {-0.5*s,0.5*s,-0.5*s},
	  {-0.5*s,-0.5*s,0-0.5*s}, {0.5*s,-0.5*s,-0.5*s}
	};

	glBegin(GL_QUADS);
		glNormal3f(0.0f,0.0f,1.0f); //z
		glVertex3fv(p[0]); glVertex3fv(p[1]);
		glVertex3fv(p[2]); glVertex3fv(p[3]);

		glNormal3f(1.0f,0.0f,0.0f); //x(ʁj
		glVertex3fv(p[0]); glVertex3fv(p[3]);
		glVertex3fv(p[7]); glVertex3fv(p[4]);

		glNormal3f(0.0f,1.0f,0.0f); //y
		glVertex3fv(p[0]); glVertex3fv(p[4]);
		glVertex3fv(p[5]); glVertex3fv(p[1]);

	 	glNormal3f(-1.0f,0.0f,0.0f); //-x
		glVertex3fv(p[1]); glVertex3fv(p[5]);
		glVertex3fv(p[6]); glVertex3fv(p[2]);

		glNormal3f(0.0f,-1.0f,0.0f); //-y
		glVertex3fv(p[2]); glVertex3fv(p[6]);
		glVertex3fv(p[7]); glVertex3fv(p[3]);

		glNormal3f(0.0f,0.0f,-1.0f); //-z
		glVertex3fv(p[4]); glVertex3fv(p[7]);
		glVertex3fv(p[6]); glVertex3fv(p[5]);
	glEnd();
}

//-----------------------------------------------------------------
void drawGridPlate(float sizeX, float sizeY, int nSliceX, int nSliceY)
{//xyʁCS͌_
	int i, j;
	//double ;
	float p[2][3];
	float pitchX = sizeX / (float)nSliceX;
	float pitchY = sizeY / (float)nSliceY;

	for(j = 0; j < nSliceY; j++)
	{
		//_zW
		p[0][2] = 0.0;
		p[1][2] = 0.0;

		glBegin(GL_TRIANGLE_STRIP);
		for(i = 0; i <= nSliceX; i++)
		{

			p[0][0] = (float)i * pitchX - sizeX / 2.0;//xW
			p[0][1] = (float)(j+1) * pitchY - sizeY / 2.0;//yW
			p[1][0] = (float)i * pitchX - sizeX / 2.0;//xW
			p[1][1] = (float)j * pitchY - sizeY / 2.0;//yW

			glNormal3f(0.0, 0.0, 1.0);//@xNg
			glVertex3fv(p[0]);//_W
			glVertex3fv(p[1]);//_W			
		}
		glEnd();
	}
}

//-----------------------------------------------------------------
void drawGridLines(float sizeX, float sizeY, int nSliceX, int nSliceY)
{//xyʁCS͌_(wireframepj
	int i, j;
	//double ;
	float p[2][3];
	float pitchX = sizeX / (float)nSliceX;
	float pitchY = sizeY / (float)nSliceY;

	for(j = 0; j < nSliceY; j++)
	{
		//_zW
		p[0][2] = 0.0;
		p[1][2] = 0.0;

		glBegin(GL_LINES);
		for(i = 0; i <= nSliceX; i++)
		{
			p[0][0] = (float)i * pitchX - sizeX / 2.0;//xW
			p[0][1] = (float)j * pitchY - sizeY / 2.0;//yW
			p[1][0] = (float)i * pitchX - sizeX / 2.0;//xW
			p[1][1] = (float)(j+1) * pitchY - sizeY / 2.0;//yW

			glNormal3f(0.0, 0.0, 1.0);//@xNg
			glVertex3fv(p[0]);//_W
			glVertex3fv(p[1]);//_W			
		}
		glEnd();
	}

	for(i = 0; i < nSliceX; i++)
	{
		//_zW
		p[0][2] = 0.0;
		p[1][2] = 0.0;
		glBegin(GL_LINES);
		for(j = 0; j <= nSliceY; j++)
		{
			p[0][0] = (float)i * pitchX - sizeX / 2.0;//xW
			p[0][1] = (float)j * pitchY - sizeY / 2.0;//yW
			p[1][0] = (float)(i+1) * pitchX - sizeX / 2.0;//xW
			p[1][1] = (float)j * pitchY - sizeY / 2.0;//yW

			glNormal3f(0.0, 0.0, 1.0);//@xNg
			glVertex3fv(p[0]);//_W
			glVertex3fv(p[1]);//_W			
		}
		glEnd();
	}
}

//-----------------------------------------------------------------------
void drawSphere(float radius, int nSlice, int nStack)
{
	int i, j;
	double r0, r1, th0, th1, phi;
	double p[2][3];

	for(j = 0; j < nStack; j++)
	{
		//j=0͖kɓ_(x=0, y=0, z=radius)
		//Vp
		th0 = M_PI * (double)j / (double)nStack;
		th1 = M_PI * (double)(j+1) / (double)nStack;
		//x-yʂɓea
		r0 = radius * sin(th0);
		r1 = radius * sin(th1);
		//_zW
		p[0][2] = radius * cos(th0);
		p[1][2] = radius * cos(th1);

		glBegin(GL_TRIANGLE_STRIP);
		for(i = 0; i <= nSlice; i++)
		{
			phi = 2.0 * M_PI * (double)i / (double)nSlice;
			//_xyW(i=0object݂ĉE[) 
			p[0][0] =   r0 * sin(phi);//xW
			p[0][1] = - r0 * cos(phi);//yW
			p[1][0] =   r1 * sin(phi);//xW
			p[1][1] = - r1 * cos(phi);//yW

			glNormal3dv(p[0]);//@xNg
			glVertex3dv(p[0]);//_W

			glNormal3dv(p[1]);//@xNg
			glVertex3dv(p[1]);//_W			
		}
		glEnd();
	}
}
//----------------------------------------------------------------------
void drawCylinder(float rBottom, float rTop, float height, int nSlice, int nStack)
{ //z
	//~(rBottom=rTop))A~A~(rTop = 0.0)
	//rBottom:ꔼa, rTop:ꔼa
	//nSlice--xyfʕ
	//nStack---
	//̂̒S͉Ə̒

	int i, j;
	double x, y, z, z0, z1;
	double theta;
	double theta0 = 2.0*M_PI/(double)nSlice;
	//(Top)
	glBegin(GL_TRIANGLE_FAN);
	glNormal3f(0.0, 0.0, 1.0);
	glVertex3f(0.0, 0.0, height/2.0);
	for(i = 0; i <= nSlice; i++) 
	{ 
		theta = theta0 * (double)i;
		x = (float)(rTop * cos(theta)); //x
		y = (float)(rTop * sin(theta)); //
		z = height/2.0;
		glVertex3f(x, y, z);
	}
	glEnd();

	//(Bottom)
	glBegin(GL_TRIANGLE_FAN);
	glNormal3f(0.0, 0.0, -1.0);
	glVertex3f(0.0, 0.0, -height/2.0);
	for(i = 0; i <= nSlice; i++) 
	{ 
		theta = theta0 * (double)(nSlice - i);
		x = (float)(rBottom * cos(theta)); //x
		y = (float)(rBottom * sin(theta)); //
		z = -height/2.0;
		glVertex3f(x, y, z);
	}
	glEnd();

	double s, t0, t1, r0, r1, phi;
	double p[2][3], n[3];

	double rr = rBottom - rTop;
	double nz = rr / sqrt(rr*rr + height*height);
  double nxy = sqrt(1.0 - nz * nz);
	//
	for(j = 0; j < nStack; j++)
	{
		//j=0͏(x=0, y=0, z=height/2)
		//2tW
		t0 = (double)j / (double)nStack;
		t1 = (double)(j+1) / (double)nStack;
		//ʂ̍
		z0 = height * (1.0 - t0);
		z1 = height * (1.0 - t1);
		//a
		r0 = rBottom + (rTop - rBottom) * z0 / height;
		r1 = rBottom + (rTop - rBottom) * z1 / height;

		//_zW
		p[0][2] = z0 - height / 2.0;
		p[1][2] = z1 - height / 2.0;

		glBegin(GL_QUAD_STRIP);
		for(i = 0; i <= nSlice; i++)
		{
			//sW
			s = (double)i / (double)nSlice;
			phi = 2.0 * M_PI * s + M_PI / 6.0;
			//_xyW
			p[0][0] = r0 * cos(phi);//xW
			p[0][1] = r0 * sin(phi);//yW
			p[1][0] = r1 * cos(phi);//xW
			p[1][1] = r1 * sin(phi);//yW
			//@xNg
			n[0] = nxy * cos(phi);
			n[1] = nxy * sin(phi);
			n[2] = nz;

			glNormal3dv(n);//@xNg
			glVertex3dv(p[0]);//_W
			glVertex3dv(p[1]);//_W
		}
		glEnd();
	}
}
//----------------------------------------------------------------------
void drawCylinder(float rBottom, float rTop, float height, float thick, int nSlice, int nStack)
{ //݂̂钆~
	//z
	//~(rBottom=rTop))A~A~(rTop = 0.0)
	//rBottom:ꔼa, rTop:ꔼaij
	//nSlice--xyfʕ
	//nStack---
	//̂̒S͉Ə̒

	int i, j;
	double x, y, z, z0, x1, y1,z1;
	double theta;
	double theta0 = 2.0*M_PI/(double)nSlice;
	//(Top)
	glBegin(GL_QUAD_STRIP);
	glNormal3f(0.0, 0.0, 1.0);
	//glVertex3f(0.0, 0.0, height/2.0);
	for(i = 0; i <= nSlice; i++) 
	{ 
		theta = theta0 * (double)i;
		x = (float)(rTop * cos(theta)); //x(j
		y = (float)(rTop * sin(theta)); //y(j
		x1 = (float)((rTop + thick) * cos(theta)); //x(Oj
		y1 = (float)((rTop + thick) * sin(theta)); //y(Oj
		z = height/2.0;
		glVertex3f(x, y, z);
		glVertex3f(x1, y1, z);
	}
	glEnd();

	//(Bottom)
	glBegin(GL_QUAD_STRIP);
	glNormal3f(0.0, 0.0, -1.0);
	for(i = 0; i <= nSlice; i++) 
	{ 
		theta = theta0 * (double)(nSlice - i);
		x = (float)(rBottom * cos(theta)); //x(j
		y = (float)(rBottom * sin(theta)); //(j
		x1 = (float)((rBottom + thick) * cos(theta)); //x(Oj
		y1 = (float)((rBottom + thick) * sin(theta)); //y(Oj
		z = -height/2.0;
		glVertex3f(x1, y1, z);
		glVertex3f(x, y, z);
	}
	glEnd();

	double s, t0, t1, r0, r1, phi;
	double p[2][3], n[3];

	double rr = rBottom - rTop;
	double nz = rr / sqrt(rr*rr + height*height);
  double nxy = sqrt(1.0 - nz * nz);
	//(Oj
	for(j = 0; j < nStack; j++)
	{
		//j=0͏(x=0, y=0, z=height/2)
		//2tW
		t0 = (double)j / (double)nStack;
		t1 = (double)(j+1) / (double)nStack;
		//ʂ̍
		z0 = height * (1.0 - t0);
		z1 = height * (1.0 - t1);
		//a
		r0 = rBottom + thick + (rTop - rBottom) * z0 / height;
		r1 = rBottom + thick + (rTop - rBottom) * z1 / height;

		//_zW
		p[0][2] = z0 - height / 2.0;
		p[1][2] = z1 - height / 2.0;

		glBegin(GL_QUAD_STRIP);
		for(i = 0; i <= nSlice; i++)
		{
			//sW
			s = (double)i / (double)nSlice;
			phi = 2.0 * M_PI * s + M_PI / 6.0;
			//_xyW
			p[0][0] = r0 * cos(phi);//xW
			p[0][1] = r0 * sin(phi);//yW
			p[1][0] = r1 * cos(phi);//xW
			p[1][1] = r1 * sin(phi);//yW
			//@xNg
			n[0] = nxy * cos(phi);
			n[1] = nxy * sin(phi);
			n[2] = nz;

			glNormal3dv(n);//@xNg
			glVertex3dv(p[0]);//_W
			glVertex3dv(p[1]);//_W
		}
		glEnd();
	}
	//(j
	for(j = 0; j < nStack; j++)
	{
		//j=0͏(x=0, y=0, z=height/2)
		//2tW
		t0 = (double)j / (double)nStack;
		t1 = (double)(j+1) / (double)nStack;
		//ʂ̍
		z0 = height * t0;
		z1 = height * t1;
		//a
		r0 = rBottom + (rTop - rBottom) * z0 / height;
		r1 = rBottom + (rTop - rBottom) * z1 / height;

		//_zW
		p[0][2] = z0 - height / 2.0;
		p[1][2] = z1 - height / 2.0;

		glBegin(GL_QUAD_STRIP);
		for(i = 0; i <= nSlice; i++)
		{
			//sW
			s = (double)i / (double)nSlice;
			phi = 2.0 * M_PI * s + M_PI / 6.0;
			//_xyW
			p[0][0] = r0 * cos(phi);//xW
			p[0][1] = r0 * sin(phi);//yW
			p[1][0] = r1 * cos(phi);//xW
			p[1][1] = r1 * sin(phi);//yW
			//@xNg
			n[0] = -nxy * cos(phi);
			n[1] = -nxy * sin(phi);
			n[2] = -nz;

			glNormal3dv(n);//@xNg
			glVertex3dv(p[1]);//_W
			glVertex3dv(p[0]);//_W
		}
		glEnd();
	}
}

//----------------------------------------------------------------------
void drawCylinderY(float rBottom, float rTop, float height, int nSlice, int nStack)
{ //Y
	//~(rBottom=rTop))A~A~(rTop = 0.0)
	//rBottom:ꔼa, rTop:ꔼa
	//nSlice--ZXfʕ
	//nStack---Y
	//̂̒S͉Ə̒

	int i, j;
	double Z, X, Y, Y0, Y1;
	double theta;
	double theta0 = 2.0*M_PI/(double)nSlice;
	//(Top)
	glBegin(GL_TRIANGLE_FAN);
	glNormal3f(0.0, 1.0, 0.0);
	glVertex3f(0.0, height/2.0, 0.0);
	for(i = 0; i <= nSlice; i++) 
	{ 
		theta = theta0 * (double)i;
		Z = (float)(rTop * cos(theta)); //z
		X = (float)(rTop * sin(theta)); //x
		Y = height/2.0;
		glVertex3f(X, Y, Z);
	}
	glEnd();

	//(Bottom)
	glBegin(GL_TRIANGLE_FAN);
	glNormal3f(0.0, -1.0, 0.0);
	glVertex3f(0.0, -height/2.0, 0.0);
	for(i = 0; i <= nSlice; i++) 
	{ 
		theta = theta0 * (double)(nSlice - i);
		Z = (float)(rBottom * cos(theta)); //z
		X = (float)(rBottom * sin(theta)); //x
		Y = -height/2.0;
		glVertex3f(X, Y, Z);
	}
	glEnd();

	double s, t0, t1, r0, r1, phi;
	double p[2][3], n[3];

	double rr = rBottom - rTop;
	double nY = rr / sqrt(rr*rr + height*height);
  double nZX = sqrt(1.0 - nY * nY);
	//
	for(j = 0; j < nStack; j++)
	{
		//j=0͏(Z=0, X=0, Y=height/2)
		//2tW
		t0 = (double)j / (double)nStack;
		t1 = (double)(j+1) / (double)nStack;
		//ʂ̍
		Y0 = height * (1.0 - t0);
		Y1 = height * (1.0 - t1);
		//a
		r0 = rBottom + (rTop - rBottom) * Y0 / height;
		r1 = rBottom + (rTop - rBottom) * Y1 / height;

		//_YW
		p[0][1] = Y0 - height / 2.0;
		p[1][1] = Y1 - height / 2.0;

		glBegin(GL_QUAD_STRIP);
		for(i = 0; i <= nSlice; i++)
		{
			//sW
			s = (double)i / (double)nSlice;
			phi = 2.0 * M_PI * s + M_PI / 6.0;
			//_ZXW
			p[0][2] = r0 * cos(phi);//ZW
			p[0][0] = r0 * sin(phi);//XW
			p[1][2] = r1 * cos(phi);//ZW
			p[1][0] = r1 * sin(phi);//XW
			//@xNg
			n[2] = nZX * cos(phi);
			n[0] = nZX * sin(phi);
			n[1] = nY;

			glNormal3dv(n);//@xNg
			glVertex3dv(p[0]);//_W
			glVertex3dv(p[1]);//_W
		}
		glEnd();
	}
}

//-----------------------------------------------------------------------------------------

void drawTorus(float radius1, float radius2, int nSide, int nRing)
{	
	//radius1:~fʔa
	//radius2:~̒Sa
	//nSide:~fʂɂ\ʕ_
	//nRing:~̕
	if(radius1 > radius2) { printf("radius1 < radius2ƂĂ \n "); return;}

	int i, j;
	double rr, zz;
	double phi0, phi1, theta;
	double p[2][3];

	for(i = 0; i < nRing; i++)
	{
		//i=0͊{f(x=radius2𒆐SƂ~, y=0j
		phi0 = 2.0 * M_PI * (double)i / (double)nRing;
		phi1 = 2.0 * M_PI * (double)(i+1) / (double)nRing;

		glBegin(GL_QUAD_STRIP);
		for(j = 0; j <= nSide; j++)
		{
			theta = M_PI - 2.0 * M_PI * (double)j / (double)nSide;
			rr = radius2 + radius1 * cos(theta);//z̋
			zz = radius1 * sin(theta);
			//_xyzW(j=0xy)
			p[0][0] = rr * cos(phi0);//xW
			p[0][1] = rr * sin(phi0);//y
			p[0][2] = zz;            //z
			p[1][0] = rr * cos(phi1);//xW
			p[1][1] = rr * sin(phi1);//y
			p[1][2] = zz;            //z      

			glNormal3d(cos(theta)*cos(phi0),cos(theta)*sin(phi0),sin(theta));
			glVertex3dv(p[0]);//_W

			glNormal3d(cos(theta)*cos(phi1),cos(theta)*sin(phi1),sin(theta));
			glVertex3dv(p[1]);//_W
		}
		glEnd();
	}
}
//-----------------------------------------------------------------
void drawSuper(float r, int nSlice, int nStack, double eps1, double eps2)
{
	//㉺̒S_
	int i,j,ip,im,np,npL,npR,npU,npD,k1,k2;
	double ct,theta,phi,z,cc;
	float a[31][31], b[31][31], c[31][31];
	float n1[3], n2[3], n3[3], n4[3];
	float pd[31*31][3];

	if(nSlice > 30) nSlice = 30;
	if(nStack > 30) nStack = 30;

	for(j = 0 ;j <= nStack;j++)
	{
		theta = (M_PI/(double)nStack) * ((double)nStack / 2.0 - (double)j);
		                //thetax-yʂ̕ΊpƂȂĂ

		if(theta >= 0.0) //㔼
		{
			if(theta == 0.0) z = 0.0;//pow(a,b)aa<=0.0ŃG[
			else z = pow(sin(fabs(theta)),eps1);//z
		}
		else  //        
		{
			z = - pow(sin(fabs(theta)), eps1);
		}
		for (i = 0 ;i <= nSlice / 2;i++)
		{
			k1 = nSlice * j + i;// + nSlice / 8.0;//object猩č
			k2 = nSlice * j + nSlice - i;// - nSlice / 8.0;//E
			phi = 2.0 * M_PI * (double)i/(double)nSlice;
			ct = cos(phi);
			if( ct == 0.0 ) cc = 0.0;
			else if (ct > 0) { cc = pow(ct, eps2);}
			else             { cc = -pow(fabs(ct),eps2); }
			if(j == 0 || j == nStack) 
			{
				pd[k1][0] = 0.0f;
				pd[k1][1] = 0.0f;
			}

			else 
			{
				pd[k1][0] = r * (float)(pow(cos(theta),eps1)*cc);
				if(sin(phi) == 0.0) pd[k1][1] = 0.0f;
				else pd[k1][1] = r * (float)(pow(cos(theta),eps1)*pow(fabs(sin(phi)),eps2));
			}
			if(i == 0) k2 = k1;
			pd[k2][0] = pd[k1][0];
			pd[k2][1] = -pd[k1][1];
			pd[k1][2] = r * (float)z;
			pd[k2][2] = r * (float)z;
		}
	}

	//ʂ̖@
	for(i = 0;i < nSlice;i++)
	{
		ip = i+1;
		if(ip == nSlice) ip = 0;
		im = i-1;
		if(i == 0) im = nSlice-1;

		//^(Top)
		a[i][0] = 0.0f; b[i][0] = 0.0f; c[i][0] = 1.0f;
		//^iBottom)
		a[i][nStack] = 0.0f; b[i][nStack] = 0.0f; c[i][nStack] = -1.0f;

		for(j=1;j<nStack;j++)//ׂ荇4̎Op`̖@xNg𕽋ω
		{
			np = j*nSlice+i;//ړ_
			npL = j*nSlice+im;//
			npR = j*nSlice+ip;//E
			npU = np-nSlice;//
			npD = np+nSlice;//
			if(j == 1) 
			{
				n1[0]=0.0f; n1[1]=0.0f; n1[2]=1.0f;//Top
				n2[0]=0.0f; n2[1]=0.0f; n2[2]=1.0f;//Top
				calcNormal(pd[np],pd[npL],pd[npD],n3);//O猩č
				calcNormal(pd[np],pd[npD],pd[npR],n4);//E
			}
			if(j == nStack-1)
			{
				calcNormal(pd[np],pd[npU],pd[npL],n1);//O猩č
				calcNormal(pd[np],pd[npR],pd[npU],n2);//E
				n3[0]=0.0f; n3[1]=0.0f; n3[2]=-1.0f;//Bottom
				n4[0]=0.0f; n4[1]=0.0f; n4[2]=-1.0f;//Bottom
			}
			else 
			{
				calcNormal(pd[np],pd[npU],pd[npL],n1);//O猩č
				calcNormal(pd[np],pd[npR],pd[npU],n2);//E
				calcNormal(pd[np],pd[npL],pd[npD],n3);//O猩č
				calcNormal(pd[np],pd[npD],pd[npR],n4);//E
			}
			a[i][j] = (float)((n1[0]+n2[0]+n3[0]+n4[0])/4.0f);//
			b[i][j] = (float)((n1[1]+n2[1]+n3[1]+n4[1])/4.0f);//
			c[i][j] = (float)((n1[2]+n2[2]+n3[2]+n4[2])/4.0f);//
		}
	}

	glBegin(GL_QUADS);
	for(i = 0;i < nSlice;i++)
	{
		ip = i + 1;
		if(ip == nSlice) ip = 0;
		for(j = 0;j < nStack; j++)
		{
			glNormal3f(a[i][j],b[i][j],c[i][j]);
			glVertex3fv(pd[i+j*nSlice]);
			glNormal3f(a[i][j+1],b[i][j+1],c[i][j+1]);
			glVertex3fv(pd[i+(j+1)*nSlice]);
			glNormal3f(a[ip][j+1],b[ip][j+1],c[ip][j+1]);
			glVertex3fv(pd[ip+(j+1)*nSlice]);
			glNormal3f(a[ip][j],b[ip][j],c[ip][j]);
			glVertex3fv(pd[ip +j*nSlice]);
		}
	}
	glEnd();
}

//-----------------------------------------------------------------------------
//lp`̃bVix-y,S_j
//C̕Œ
void drawElevation(int Nx, int Ny, float sizeX, float sizeY, int sideFlag, float* data)
{
	//Ŝ̕,sizeX, sizeY
	//sideFlag = 0:ʕ\
	//sideFlag = 1:ʕ\

	const int NMAX = 110;
	int i, j;
	float p[NMAX][NMAX][3]; //_W
	float a[NMAX][NMAX], b[NMAX][NMAX], c[NMAX][NMAX];//_̖@
	float pitchX, pitchY;
	float n1[3], n2[3], n3[3], n4[3];

	if(Nx > NMAX) printf("NxNMAX𒴂Ă܂(drawElevation1) \n");
	if(Ny > NMAX) printf("NyNMAX𒴂Ă܂(drawElevation1) \n");

	//Z̃TCY
	pitchX = sizeX / (float)Nx;
	pitchY = sizeY / (float)Ny;

	//e_̍W
	for(j = 0; j <= Ny; j++){
		for(i = 0; i <= Nx; i++){
			p[i][j][0] = (float)(i - Nx / 2) * pitchX;
			p[i][j][1] = (float)(j - Ny / 2) * pitchY;
			p[i][j][2] = data[j * (Nx+1) + i];
		}
	}
	
	//@
	for(i = 0;i <= Nx;i++)
		for(j = 0;j <= Ny;j++)
		{			
			if(j == 0 )
			{
				if(i == 0) 
				{
					calcNormal(p[0][0],p[1][0],p[0][1],n1);
					a[i][j] = n1[0]; b[i][j] = n1[1]; c[i][j] = n1[2]; }
				else if(i == Nx) 
				{
					calcNormal(p[Nx-1][0],p[Nx][0],p[Nx][1],n1);
					a[i][j] = n1[0]; b[i][j] = n1[1]; c[i][j] = n1[2]; }
				else 
				{
					calcNormal(p[i][0],p[i][1],p[i-1][0],n1);//
					calcNormal(p[i][0],p[i+1][0],p[i][1],n2);//E
					a[i][j] = (n1[0]+n2[0])/2.0f;
					b[i][j] = (n1[1]+n2[1])/2.0f;
					c[i][j] = (n1[2]+n2[2])/2.0f; }
			}
			else if(j == Ny)
			{
				if(i == 0) 
				{
					calcNormal(p[0][Ny],p[0][Ny-1],p[1][Ny],n1);
					a[i][j] = n1[0]; b[i][j] = n1[1]; c[i][j] = n1[2]; }
				else if(i == Nx) 
				{
					calcNormal(p[Nx][Ny],p[Nx-1][Ny],p[Nx][Ny-1],n1);
					a[i][j] = n1[0]; b[i][j] = n1[1]; c[i][j] = n1[2]; }
				else 
				{
					calcNormal(p[i][Ny],p[i-1][Ny],p[i][Ny-1],n1);//
					calcNormal(p[i][Ny],p[i][Ny-1],p[i+1][Ny],n2);//E
					a[i][j] = (n1[0]+n2[0])/2.0f;
					b[i][j] = (n1[1]+n2[1])/2.0f;
					c[i][j] = (n1[2]+n2[2])/2.0f; }
			}
			else
			{
				if(i == 0) 
				{
					calcNormal(p[0][j],p[1][j],p[0][j+1],n1);//
					calcNormal(p[0][j],p[0][j-1],p[0][1],n2);//
					a[i][j] = (n1[0]+n2[0])/2.0f;
					b[i][j] = (n1[1]+n2[1])/2.0f;
					c[i][j] = (n1[2]+n2[2])/2.0f; }
				else if(i == Nx) 
				{
					calcNormal(p[Nx][j],p[Nx][j+1],p[Nx-1][j],n1);//
					calcNormal(p[Nx][j],p[Nx-1][j],p[Nx][j-1],n2);//
					a[i][j] = (n1[0]+n2[0])/2.0f;
					b[i][j] = (n1[1]+n2[1])/2.0f;
					c[i][j] = (n1[2]+n2[2])/2.0f; }
				else 
				{//㉺ES̎Op`̕
					calcNormal(p[i][j],p[i][j+1],p[i-1][j],n1);//
					calcNormal(p[i][j],p[i+1][j],p[i][j+1],n2);//E
					calcNormal(p[i][j],p[i-1][j],p[i][j-1],n3);//
					calcNormal(p[i][j],p[i][j-1],p[i+1][j],n4);//E
					a[i][j] = (n1[0]+n2[0]+n3[0]+n4[0])/4.0f;
					b[i][j] = (n1[1]+n2[1]+n3[1]+n4[1])/4.0f;
					c[i][j] = (n1[2]+n2[2]+n3[2]+n4[2])/4.0f; }
			}
		}

	//Op`Ŗʂ`
	glBegin(GL_TRIANGLES);
	for(j = 0;j < Ny;j++)
		for(i = 0;i < Nx;i++)
		{
			//̎Op`
			//e_̖@,_W^B
			glNormal3f(a[i][j],b[i][j],c[i][j]);//@
			glVertex3fv(p[i][j]);//غ݂̒_WiȉJԂj
			glNormal3f(a[i+1][j],b[i+1][j],c[i+1][j]);
			glVertex3fv(p[i+1][j]);
			glNormal3f(a[i][j+1],b[i][j+1],c[i][j+1]);
			glVertex3fv(p[i][j+1]);
			//E̎Op`
			glNormal3f(a[i+1][j],b[i+1][j],c[i+1][j]);
			glVertex3fv(p[i+1][j]);
			glNormal3f(a[i+1][j+1],b[i+1][j+1],c[i+1][j+1]);
			glVertex3fv(p[i+1][j+1]);
			glNormal3f(a[i][j+1],b[i][j+1],c[i][j+1]);
			glVertex3fv(p[i][j+1]);
		}
	glEnd();

	if(sideFlag == 1)//ʕ`
	{
		glBegin(GL_QUADS);
		//+xii=Nx)
		glNormal3f(1.0, 0.0, 0.0);
		for(j = 0; j < Ny; j++)
		{
			glVertex3f(p[Nx][j][0], p[Nx][j][1], 0.0f);
			glVertex3f(p[Nx][j+1][0], p[Nx][j+1][1], 0.0f);
			glVertex3f(p[Nx][j+1][0], p[Nx][j+1][1], p[Nx][j+1][2]);
			glVertex3f(p[Nx][j][0], p[Nx][j][1], p[Nx][j][2]);
		}
		//-xii=0)
		glNormal3f(-1.0, 0.0, 0.0);
		for(j = 0; j < Ny; j++)
		{
			glVertex3f(p[0][j][0], p[0][j][1], 0.0f);
			glVertex3f(p[0][j][0], p[0][j][1], p[0][j][2]);
			glVertex3f(p[0][j+1][0], p[0][j+1][1], p[0][j+1][2]);
			glVertex3f(p[0][j+1][0], p[0][j+1][1], 0.0f);
		}
		//+yij=Ny)
		glNormal3f(0.0, 1.0, 0.0);
		for(i = 0; i < Nx; i++)
		{
			glVertex3f(p[i][Ny][0], p[i][Ny][1], 0.0f);
			glVertex3f(p[i][Ny][0], p[i][Ny][1], p[i][Ny][2]);
			glVertex3f(p[i+1][Ny][0], p[i+1][Ny][1], p[i+1][Ny][2]);
			glVertex3f(p[i+1][Ny][0], p[i+1][Ny][1], 0.0f);
		}
		//-yij=0)
		glNormal3f(0.0, -1.0, 0.0);
		for(i = 0; i < Nx; i++)
		{
			glVertex3f(p[i][0][0], p[i][0][1], 0.0f);
			glVertex3f(p[i+1][0][0], p[i+1][0][1], 0.0f);
			glVertex3f(p[i+1][0][0], p[i+1][0][1], p[i+1][0][2]);
			glVertex3f(p[i][0][0], p[i][0][1], p[i][0][2]);
		}
		glEnd();
	}
}
//----------------------------------------------------------------------
//QiqIuWFNg
void drawGridSquare(int numRow, int numCol, float pd[][3])
{	//ʂ`
	int i, j, np;
	float n1[3], n2[3], n3[3], n4[3];
	float a[101][101], b[101][101], c[101][101];

	//@
	for(i = 0;i < numRow;i++) //
	  for(j = 0;j < numCol;j++)//E
	  {
        np = i * numCol + j;
		if(i == 0 )
		{
			if(j == 0) {
				calcNormal(pd[0],pd[numCol],pd[1],n1);
				a[i][j] = n1[0]; b[i][j] = n1[1]; c[i][j] = n1[2]; }
			else if(j == numCol-1) {
				calcNormal(pd[numCol-2],pd[2*numCol-1],pd[numCol-1],n1);
				a[i][j] = n1[0]; b[i][j] = n1[1]; c[i][j] = n1[2]; }
			else {
				calcNormal(pd[np],pd[np-1],pd[np+numCol],n1);//
				calcNormal(pd[np],pd[np+numCol],pd[np+1],n2);//E
				a[i][j] = (n1[0]+n2[0])/2.0f;
				b[i][j] = (n1[1]+n2[1])/2.0f;
				c[i][j] = (n1[2]+n2[2])/2.0f; }
		}
		else if(i == numRow-1)
		{
			if(j == 0) {
				calcNormal(pd[np],pd[np+1],pd[np-numCol],n1);
				a[i][j] = n1[0]; b[i][j] = n1[1]; c[i][j] = n1[2]; }
			else if(j == numCol-1) {
				calcNormal(pd[np],pd[np-numCol],pd[np-1],n1);
				a[i][j] = n1[0]; b[i][j] = n1[1]; c[i][j] = n1[2]; }
			else {
				calcNormal(pd[np],pd[np-numCol],pd[np-1],n1);//
				calcNormal(pd[np],pd[np+1],pd[np-numCol],n2);//E
				a[i][j] = (n1[0]+n2[0])/2.0f;
				b[i][j] = (n1[1]+n2[1])/2.0f;
				c[i][j] = (n1[2]+n2[2])/2.0f; }
		}
		else
		{
			if(j == 0) {
				calcNormal(pd[np],pd[np+1],pd[np-numCol],n1);//
				calcNormal(pd[np],pd[np+numCol],pd[np+1],n2);//
				a[i][j] = (n1[0]+n2[0])/2.0f;
				b[i][j] = (n1[1]+n2[1])/2.0f;
				c[i][j] = (n1[2]+n2[2])/2.0f; }
			else if(j == numCol-1) {
				calcNormal(pd[np],pd[np-numCol],pd[np-1],n1);//
				calcNormal(pd[np],pd[np-1],pd[np+numCol],n2);//
				a[i][j] = (n1[0]+n2[0])/2.0f;
				b[i][j] = (n1[1]+n2[1])/2.0f;
				c[i][j] = (n1[2]+n2[2])/2.0f; }
			else {//㉺ES̎Op`̕
				calcNormal(pd[np],pd[np-numCol],pd[np-1],n1);//
				calcNormal(pd[np],pd[np+1],pd[np-numCol],n2);//E
				calcNormal(pd[np],pd[np-1],pd[np+numCol],n3);//
				calcNormal(pd[np],pd[np+numCol],pd[np+1],n4);//E
				a[i][j] = (n1[0]+n2[0]+n3[0]+n4[0])/4.0f;
				b[i][j] = (n1[1]+n2[1]+n3[1]+n4[1])/4.0f;
				c[i][j] = (n1[2]+n2[2]+n3[2]+n4[2])/4.0f; }
		}
	}
	//`
	for(i = 0;i < numRow-1;i++)
	  for(j = 0;j < numCol-1;j++){
      np = i * numCol + j;
			glBegin(GL_TRIANGLES);
			//̎Op`
			//e_̖@,øW,_W^B
			glNormal3d(a[i][j],b[i][j],c[i][j]);//@
			glVertex3fv(pd[np]);//غ݂̒_WiȉJԂj
			glNormal3d(a[i+1][j],b[i+1][j],c[i+1][j]);
			glVertex3fv(pd[np+numCol]);
			glNormal3d(a[i+1][j+1],b[i+1][j+1],c[i+1][j+1]);
			glVertex3fv(pd[np+numCol+1]);
			//E̎Op`
			glNormal3d(a[i][j],b[i][j],c[i][j]);
			glVertex3fv(pd[np]);
			glNormal3d(a[i+1][j+1],b[i+1][j+1],c[i+1][j+1]);
			glVertex3fv(pd[np+numCol+1]);
			glNormal3d(a[i][j+1],b[i][j+1],c[i][j+1]);
			glVertex3fv(pd[np+1]);
		glEnd();
	}

}
//-------------------------------------------------------------------
void drawFloor(float widthX, float widthZ, int nx, int nz)
{
  int i, j;
  //FloorP̕
  float wX = widthX / (float)nx;
  float wZ = widthZ / (float)nz;

  float diffuse[][4] = {
//	{ 0.7, 0.7, 0.6, 1.0}, { 0.3f, 0.4, 0.4, 1.0} };
	{ 0.7, 0.7, 0.65, 1.0}, { 0.35, 0.4, 0.4, 1.0} };
  float ambient[] = { 0.2, 0.2, 0.2, 1.0};
  float specular[]= { 0.5, 0.5, 0.5, 1.0};
  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,100);

  glNormal3f(0.0, 1.0, 0.0);
  glPushMatrix();
  for (j = 0; j < nz; j++) 
  {
    float z1 = -widthZ / 2.0 + wZ * j; float z2 = z1 + wZ;
    for (i = 0; i < nx; i++) {
      float x1 = -widthX / 2.0 + wX * i; float x2 = x1 + wX;

      glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuse[(i + j) & 1]);
	  glBegin(GL_QUADS);
      glVertex3f(x1, 0.0, z1);
      glVertex3f(x1, 0.0, z2);
      glVertex3f(x2, 0.0, z2);
      glVertex3f(x2, 0.0, z1);
	  glEnd();
    }
  }
  glPopMatrix();
}

void drawFloorZ(float widthX, float widthY, int nx, int ny)
{//F
  int i, j;
  //FloorP̕
  float wX = widthX / (float)nx;
  float wY = widthY / (float)ny;

  float diffuse[][4] = {
	{ 0.6, 0.6, 0.5, 1.0}, { 0.4, 0.4, 0.5, 1.0} };
//	{ 0.6, 0.6, 0.7, 1.0}, { 0.4, 0.3, 0.2, 1.0} };
  float ambient[] = { 0.2, 0.2, 0.2, 1.0};
  float specular[]= { 0.1, 0.1, 0.1, 1.0};

  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,10);

  glNormal3d(0.0, 0.0, 1.0);
  glPushMatrix();
  for (j = 0; j < ny; j++) 
	{
    float y1 = -widthY / 2.0 + wY * j; float y2 = y1 + wY;
    for (i = 0; i < nx; i++) 
		{
      float x1 = -widthX / 2.0 + wX * i; float x2 = x1 + wX;

      glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuse[(i + j) & 1]);
			glBegin(GL_QUADS);
      glVertex3d(x1, y1, 0.0);
      glVertex3d(x2, y1, 0.0);
      glVertex3d(x2, y2, 0.0);
      glVertex3d(x1, y2, 0.0);
			glEnd();
    }
  }
  glPopMatrix();
}
//------------------------------------------------------------------------------------------------------
void drawGridZ(float widthX, float widthY, int nx, int ny)
{//F
  int i, j;
	float x1, y1, x2, y2;
  //FloorP̕
  float wX = widthX / (float)nx;
  float wY = widthY / (float)ny;

  float diffuse[] = {0.9, 0.6, 0.1, 1.0};
  float ambient[] = { 0.2, 0.2, 0.2, 1.0};
  float specular[]= { 0.1, 0.1, 0.1, 1.0};

  glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuse);
  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,10);

	glColor3f(0.4, 0.4, 0.5);
  glNormal3d(0.0, 0.0, 1.0);
  glPushMatrix();
  for (j = 0; j <= ny; j++) 
	{
    y1 = -widthY / 2.0 + wY * j;
    x1 = -widthX / 2.0; x2 = widthX / 2.0;

	glBegin(GL_LINES);
    glVertex3d(x1, y1, 0.0); glVertex3d(x2, y1, 0.0);
	glEnd();
  }
  for (i = 0; i <= nx; i++) 
	{
    x1 = -widthX / 2.0 + wX * i; 
    y1 = -widthY / 2.0; y2 = widthY / 2.0;

		glBegin(GL_LINES);
    glVertex3d(x1, y1, 0.0); glVertex3d(x1, y2, 0.0);
		glEnd();
    
  }

  glPopMatrix();
}
//----------------------------------------------------------------
void drawSpring(int Nm, int Ns, int Np, float radius, float ratio, float length)
{
	//Nm:~_,Ns:fʉ~_,Np:sb`
	//radius:~a,ratio:fʔa/~a,length:S
	//ol̒Ԃ_
	int i, ii, j, jj, k, k1, k2;
	double phai, ph1, ph2;  //~_xɑ΂Ίp
	double theta, th1, th2; //fʉ~_x-zʂɑ΂Ίp
	float p[21][21][101][3];//e_̍W
	float p1[3], p2[3], p3[3], p4[3];
	float rr[21], zz[21];
	float pitch, dp, hh;
	float r1, r2;

	r1 = radius; //~a
	r2 = ratio * r1;//fʔa
	if( Nm > 20 ) Nm = 20;
	if( Ns > 20 ) Ns = 20;
	if( Np > 100 ) Np = 100;
	pitch = length / (float)Np;

	dp = (float)pitch / (float)Nm;

	//{f(x-z)̍W
	for(j = 0; j < Ns; j++)
	{	theta = M_PI - 2.0 * M_PI*(double)j/(double)Ns;
		rr[j] = r1 + r2 * (float)cos(theta); //_̋
		zz[j] = r2 * (float)sin(theta);//
	}

	//̒fʂ̍W
	hh = 0;
	for(k = 0; k < Np; k++)
		for(i = 0; i < Nm; i++)
		{	phai = 2.0 * M_PI * (double)i/(double)Nm;
			for(j = 0; j < Ns; j++)
			{
				p[i][j][k][0] = rr[j] * (float)cos(phai); //xW
				p[i][j][k][1] = rr[j] * (float)sin(phai); //y
				p[i][j][k][2] = zz[j] + hh - length / 2.0 ;              //z
			}
			hh += dp;//S̍dp
		}

	//ŏI[(k=Np-1,i=Nm)
	k = Np - 1; i = Nm;
	for(j = 0; j < Ns; j++){
		phai = 0.0;
		p[i][j][k][0] = rr[j] * (float)cos(phai); //xW
		p[i][j][k][1] = rr[j] * (float)sin(phai); //y
		p[i][j][k][2] = zz[j] + hh - length / 2.0;            //z
	}

	//_``
	for(k = 0; k < Np; k++)
	for(i = 0; i < Nm; i++){
		ii = i+1;
		k1 = k; k2 = k;
		if(ii == Nm) {
			if(k < Np-1) { ii = 0; k2 = k + 1; }
		}
		ph1 = 2.0*M_PI*(double)i / (double)Nm;
		ph2 = 2.0*M_PI*(double)ii / (double)Nm;
		for(j = 0;j < Ns; j++)
		{
			jj = j+1;
			if(jj == Ns) jj = 0;
			th1 = M_PI - 2.0 * M_PI * (double)j / (double)Ns;
			th2 = M_PI - 2.0 * M_PI * (double)jj / (double)Ns;
			//ʂ̒_   xW                       yW                       zW
			p1[0] = p[i][j][k1][0]   ; p1[1] = p[i][j][k1][1]   ; p1[2] = p[i][j][k1][2];
			p2[0] = p[i][jj][k1][0]  ; p2[1] = p[i][jj][k1][1]  ; p2[2] = p[i][jj][k1][2];
			p3[0] = p[ii][jj][k2][0] ; p3[1] = p[ii][jj][k2][1] ; p3[2] = p[ii][jj][k2][2];
			p4[0] = p[ii][j][k2][0]  ; p4[1] = p[ii][j][k2][1]  ; p4[2] = p[ii][j][k2][2];

			glBegin(GL_QUADS);
				glNormal3d(cos(th1)*cos(ph1),cos(th1)*sin(ph1),sin(th1));glVertex3fv(p1);
				glNormal3d(cos(th2)*cos(ph1),cos(th2)*sin(ph1),sin(th2));glVertex3fv(p2);
				glNormal3d(cos(th2)*cos(ph2),cos(th2)*sin(ph2),sin(th2));glVertex3fv(p3);
				glNormal3d(cos(th1)*cos(ph2),cos(th1)*sin(ph2),sin(th1));glVertex3fv(p4);
			glEnd();
		}
	}
	//n[ik=0)
	glBegin(GL_POLYGON);
		glNormal3d(0.0,-1.0,0.0);
		for(j = Ns-1; j >= 0; j--) glVertex3fv(p[0][j][0]);
	glEnd();
	//I[ik=Np)
	glBegin(GL_POLYGON);
		glNormal3d(0.0,1.0,0.0);
		for(j = 0; j < Ns; j++) glVertex3fv(p[Nm][j][Np-1]);
	glEnd();

}
//----------------------------------------------------------------------
//̊iqIuWFNg
void drawGridCube(int numRow, int numCol, int numStk, float p1[][3],
        float p2[][3], float p3[][3], float p4[][3], float p5[][3],
        float p6[][3])
{
    //ׂēeNX`[
    //㑤
    drawGridSquare(numRow, numCol, p1);
    //
    drawGridSquare(numStk, numCol, p2);
    //E
    drawGridSquare(numStk, numRow, p3);
    //
    drawGridSquare(numStk, numRow, p4);
    //
    drawGridSquare(numStk, numCol, p5);
    //
    drawGridSquare(numRow, numCol, p6);
}
//----------------------------------------------------------------------------
//iqIuWFNg
void drawGridSphere(int Nxy, int Nz, float pd[][3])
{
	int i,j,ip,im,np,npL,npR,npU,npD;
	float a[11][11],b[11][11],c[11][11];//_̖@
	float n[11][3];//_̖@

    if(Nxy > 11) Nxy = 11;
    if(Nz > 11) Nz = 11;
    //Top
    //TopnumCol̎Op`̖@xNg𕽋ω
    a[0][0] = 0.0; b[0][0] = 0.0; c[0][0] = 0.0;
	for(i = 0;i < Nxy;i++){
 		ip = i+1;
		if(ip == Nxy) ip = 0;
        calcNormal(pd[i],pd[i+Nxy],pd[ip+Nxy],n[i]);
        a[0][0] += n[i][0];
        b[0][0] += n[i][1];
        c[0][0] += n[i][2];
    }
    a[0][0] = a[0][0] / (float)Nxy;
    b[0][0] = b[0][0] / (float)Nxy;
    c[0][0] = c[0][0] / (float)Nxy;
    for(i = 1;i < Nxy; i++){ //Top_ׂ͂ē
        a[i][0] = a[0][0]; b[i][0] = b[0][0]; c[i][0] = c[0][0];
    }

	//ʂ̖@
    //ׂ荇4̎Op`̖@xNg𕽋ω
	for(i = 0;i < Nxy;i++){
 		ip = i+1;
		if(ip == Nxy) ip = 0;
		im = i-1;
		if(i == 0) im = Nxy-1;
		for(j = 1;j < Nz-1;j++)
		{
			np =  j * Nxy + i;//ړ_
			npL = j * Nxy + im;//
			npR = j * Nxy + ip;//E
			npU = np - Nxy;//
			npD = np + Nxy;//
            calcNormal(pd[np],pd[npU],pd[npL],n[0]);//O猩č
            calcNormal(pd[np],pd[npR],pd[npU],n[1]);//E
            calcNormal(pd[np],pd[npL],pd[npD],n[2]);//O猩č
            calcNormal(pd[np],pd[npD],pd[npR],n[3]);//E

			a[i][j] = (float)((n[0][0]+n[1][0]+n[2][0]+n[3][0])/4.0f);//
			b[i][j] = (float)((n[0][1]+n[1][1]+n[2][1]+n[3][1])/4.0f);//
			c[i][j] = (float)((n[0][2]+n[1][2]+n[2][2]+n[3][2])/4.0f);//
		}
	}
    //Bottom
    //BottomnumCol̎Op`̖@xNg𕽋ω
    a[0][Nz-1] = 0.0; b[0][Nz-1] = 0.0; c[0][Nz-1] = 0.0;
	for(i = 0;i < Nxy;i++){
        np = (Nz-1) * Nxy +i;
 		ip = i+1;
		if(ip == Nxy) ip = 0;
        calcNormal(pd[np],pd[np-i+ip-Nxy],pd[np-Nxy],n[i]);
        a[0][Nz-1] += n[i][0];
        b[0][Nz-1] += n[i][1];
        c[0][Nz-1] += n[i][2];
    }
    a[0][Nz-1] = a[0][Nz-1] / (float)Nxy;
    b[0][Nz-1] = b[0][Nz-1] / (float)Nxy;
    c[0][Nz-1] = c[0][Nz-1] / (float)Nxy;
    for(i = 1;i < Nxy; i++){ //Top_ׂ͂ē
        a[i][Nz-1] = a[0][Nz-1];
        b[i][Nz-1] = b[0][Nz-1];
        c[i][Nz-1] = c[0][Nz-1];
    }

	//\
	//(4p`pb`j
	float th1, th2, ph1, ph2;

	for(j = 0;j < Nz-1;j++){
		ph1 = 1.0f - (float)j / (float)(Nz-1);
		ph2 = 1.0f - (float)(j + 1) / (float)(Nz-1);
		for(i = 0;i < Nxy;i++)
		{	ip = i+1;
			if(ip == Nxy) ip = 0;
			th1 = (float)i / (float)Nxy;
			th2 = (float)(i+1) / (float)Nxy;
			glBegin(GL_QUADS);
				glNormal3d(a[i][j],b[i][j],c[i][j]);
				glVertex3fv(pd[j*Nxy+i]);
				glNormal3d(a[i][j+1],b[i][j+1],c[i][j+1]);
				glVertex3fv(pd[(j+1)*Nxy+i]);
				glNormal3d(a[ip][j+1],b[ip][j+1],c[ip][j+1]);
				glVertex3fv(pd[(j+1)*Nxy+ip]);
				glNormal3d(a[ip][j],b[ip][j],c[ip][j]);
				glVertex3fv(pd[j*Nxy+ip]);
			glEnd();
		}
	}
}

//----------------------------------------------------------------------
//ʂɉ~e
void drawGridCylinder(int Nxy, int Nz, float p[][3])
{
    //p[0]͏̒SCŌp[]͉̒S
	int i,j,ip,im,np,npL,npR,npU,npD;
	float a[11][11],b[11][11],c[11][11];//_̖@

	float n[11][3];//_̖@

    if(Nxy > 10) Nxy = 10;
    if(Nz > 10) Nz = 10;

    //S_
    int num = Nxy * Nz + 2;

    //Top
    //ꒆSTopnumCol̎Op`̖@xNg𕽋ω
    a[0][0] = 0.0; b[0][0] = 0.0; c[0][0] = 0.0;
    //̎͂̒_ׂ͗荇2̎Op`̖@xNg𕽋ω
    for(i = 1;i <= Nxy; i++){
        a[i][0] = 0.0; b[i][0] = 0.0; c[i][0] = 0.0;
    }
	for(i = 0;i < Nxy;i++){
 		ip = i+1;
		if(ip == Nxy) ip = 0;
        calcNormal(p[0],p[i+1],p[ip+1],n[i]);
        a[0][0] += n[i][0];
        b[0][0] += n[i][1];
        c[0][0] += n[i][2];
        a[i+1][0] += n[i][0];
        b[i+1][0] += n[i][1];
        c[i+1][0] += n[i][2];
        a[ip+1][0] += n[i][0];
        b[ip+1][0] += n[i][1];
        c[ip+1][0] += n[i][2];
    }
    a[0][0] = a[0][0] / (float)Nxy;
    b[0][0] = b[0][0] / (float)Nxy;
    c[0][0] = c[0][0] / (float)Nxy;
    for(i = 1; i < Nxy; i++){
        a[i][0] = a[i][0] / 2.0f;
        b[i][0] = b[i][0] / 2.0f;
        c[i][0] = c[i][0] / 2.0f;
    }
    //Top̕\
    for(i = 1; i <= Nxy; i++){
        ip = i + 1;
        if(ip == Nxy + 1) ip = 1;
		glBegin(GL_TRIANGLES);
			glNormal3f(a[0][0],b[0][0],c[0][0]);glVertex3fv(p[0]);
			glNormal3f(a[i][0],b[i][0],c[i][0]);glVertex3fv(p[i]);
			glNormal3f(a[ip][0],b[ip][0],c[ip][0]);glVertex3fv(p[ip]);
		glEnd();
	}

    //Bottom
    //ꒆSBottomnumCol̎Op`̖@xNg𕽋ω
    a[0][0] = 0.0; b[0][0] = 0.0; c[0][0] = 0.0;
    //̎͂̒_ׂ͗荇2̎Op`̖@xNg𕽋ω
    for(i = 1;i <= Nxy; i++){
        a[i][0] = 0.0; b[i][0] = 0.0; c[i][0] = 0.0;
    }
	for(i = 0;i < Nxy;i++){
 		ip = i+1;
		if(ip == Nxy) ip = 0;
        calcNormal(p[num-1],p[num-2-i],p[num-2-ip],n[i]);
        a[0][0] += n[i][0];
        b[0][0] += n[i][1];
        c[0][0] += n[i][2];
        a[i+1][0] += n[i][0];
        b[i+1][0] += n[i][1];
        c[i+1][0] += n[i][2];
        a[ip+1][0] += n[i][0];
        b[ip+1][0] += n[i][1];
        c[ip+1][0] += n[i][2];
    }
    a[0][0] = a[0][0] / (float)Nxy;
    b[0][0] = b[0][0] / (float)Nxy;
    c[0][0] = c[0][0] / (float)Nxy;
    for(i = 1; i < Nxy; i++){
        a[i][0] = a[i][0] / 2.0f;
        b[i][0] = b[i][0] / 2.0f;
        c[i][0] = c[i][0] / 2.0f;
    }
    //Bottom̕\
    for(i = 1; i <= Nxy; i++){
        ip = i + 1;
        if(ip == Nxy + 1) ip = 1;
		glBegin(GL_TRIANGLES);
			glNormal3f(a[0][0],b[0][0],c[0][0]);glVertex3fv(p[num-1]);
			glNormal3f(a[i][0],b[i][0],c[i][0]);glVertex3fv(p[num-1-i]);
			glNormal3f(a[ip][0],b[ip][0],c[ip][0]); glVertex3fv(p[num-1-ip]);
		glEnd();
	}

	//ʂ̖@
    //̎͒_̑ʂɑ΂@
    //ׂ荇2̎Op`̖@xNg𕽋ω
	for(i = 0;i < Nxy;i++){
 		ip = i+1;
		if(ip == Nxy) ip = 0;
		im = i-1;
		if(i == 0) im = Nxy-1;
        //j = 0;
        np = i+1;//ړ_
        npL = im+1;//
        npR = ip+1;//E
        npD = np + Nxy;//
        calcNormal(p[np],p[npL],p[npD],n[0]);//O猩č
        calcNormal(p[np],p[npD],p[npR],n[1]);//E

        a[i][0] = (float)((n[0][0]+n[1][0])/2.0f);//
        b[i][0] = (float)((n[0][1]+n[1][1])/2.0f);//
        c[i][0] = (float)((n[0][2]+n[1][2])/2.0f);//
	}

    //悤ɉ̒_ɑ΂
	for(i = 0;i < Nxy;i++){
 		ip = i+1;
		if(ip == Nxy) ip = 0;
		im = i-1;
		if(i == 0) im = Nxy-1;
        j = Nz - 1;
        np = j*Nxy+i+1;//ړ_
        npL = j*Nxy+im+1;//
        npR = j*Nxy+ip+1;//E
        npU = np - Nxy;//
        calcNormal(p[np],p[npU],p[npL],n[0]);//O猩č
        calcNormal(p[np],p[npR],p[npU],n[1]);//E

        a[i][j] = (float)((n[0][0]+n[1][0])/2.0f);//
        b[i][j] = (float)((n[0][1]+n[1][1])/2.0f);//
        c[i][j] = (float)((n[0][2]+n[1][2])/2.0f);//
	}

    //̑ʂ̒_ɑ΂Ăׂ͗荇4̎Op`̖@xNg𕽋ω
	for(i = 0;i < Nxy;i++){
 		ip = i+1;
		if(ip == Nxy) ip = 0;
		im = i-1;
		if(i == 0) im = Nxy-1;
		for(j = 1;j < Nz-1;j++)
		{
			np =  j * Nxy + i + 1;//ړ_
			npL = j * Nxy + im + 1;//
			npR = j * Nxy + ip + 1;//E
			npU = np - Nxy;//
			npD = np + Nxy;//
            calcNormal(p[np],p[npU],p[npL],n[0]);//O猩č
            calcNormal(p[np],p[npR],p[npU],n[1]);//E
            calcNormal(p[np],p[npL],p[npD],n[2]);//O猩č
            calcNormal(p[np],p[npD],p[npR],n[3]);//E

			a[i][j] = (float)((n[0][0]+n[1][0]+n[2][0]+n[3][0])/4.0f);//
			b[i][j] = (float)((n[0][1]+n[1][1]+n[2][1]+n[3][1])/4.0f);//
			c[i][j] = (float)((n[0][2]+n[1][2]+n[2][2]+n[3][2])/4.0f);//
		}
	}

	//(4p`pb`j
	float th1, th2, ph1, ph2;
	for(j = 0;j < Nz-1;j++){
		ph1 = 1.0f - (float)j / (float)(Nz-1);
		ph2 = 1.0f - (float)(j + 1) / (float)(Nz-1);
		for(i = 0;i < Nxy;i++)
		{	ip = i+1;
			if(ip == Nxy) ip = 0;
			th1 = (float)i / (float)Nxy;
			th2 = (float)(i+1) / (float)Nxy;
			glBegin(GL_QUADS);
				glNormal3d(a[i][j],b[i][j],c[i][j]);
				glVertex3fv(p[j*Nxy+i+1]);
				glNormal3d(a[i][j+1],b[i][j+1],c[i][j+1]);
				glVertex3fv(p[(j+1)*Nxy+i+1]);
				glNormal3d(a[ip][j+1],b[ip][j+1],c[ip][j+1]);
				glVertex3fv(p[(j+1)*Nxy+ip+1]);
				glNormal3d(a[ip][j],b[ip][j],c[ip][j]);
				glVertex3fv(p[j*Nxy+ip+1]);
			glEnd();
		}
	}
}
