//rigid.h
#include "../../parameters.h"
#include "../../spring.h"

#define RIGID_NUM_MAX 500
int numRigid0 = 2;//̐
int numRigid = 2;//Xg{܂߂

//-------------------------------------------------------------------------
class CRigid{
public:
	//ޕϐ
	Kind kind;     //CRigid̎
	Color color;   //F
	CVector vSize; //TCY
	CVector vPos;  //ʒu
	CVector vEuler;//IC[p
	CVector vForce, vForce0;  //O(Newton)
	CVector vAccel;    //x(m/s^2)
	CVector vVelocity; //x(m/s)
	CVector vVel, vVelK[5];//Runge-Kuttak
	CVector vOmega;    //px(rad/s)
	CVector vAlpha;    //px(rad/s^2)
	CVector vGravityToPoint;//dSՓ˓_܂ł̃xNg
	CMatrix mInertia; //[g̃e\
	CMatrix mInertiaInverse;
	CVector vTorque;
	CQuaternion q;     //NH[^jI
	CVector vAxis;     //]
	double mass;       //(Kg)
	int select;
	//int posType;
	bool flagFixed;
  
	//ފ֐
	CRigid();  //RXgN^
	~CRigid(); //fXgN^
	void draw(bool flagShadow);
	void action3D();
	void calcMomentOfInertia();
};
CRigid rigid[RIGID_NUM_MAX];

//--------------------------------------------------
CRigid::CRigid()
{
	kind = SPHERE;
	color = WHITE;
	vSize = CVector(1.0, 1.0, 1.0);
	vPos = CVector();
	vVelocity = CVector();
	vEuler = CVector();
	q = CQuaternion();
	vAxis = CVector();
	select = 0;
	flagFixed = false;

	mass = 1.0;
}

//--------------------------------------------------
CRigid::~CRigid()
{
}

//---------------------------------------------------------
void CRigid::draw(bool flagShadow)
{
	//_̃}eA
	static float white0[] = { 0.9, 0.9, 0.9, 1.0};//I
	static float specular[]= { 0.8, 0.8, 0.8, 1.0};
	static float specularS[]= { 0.6, 0.6, 0.6, 1.0};
	//ẽ}eA
	static float shadowDiffuse[] =  {0.0, 0.0, 0.0, 0.2};//e̊gU

	glPushMatrix();

  //݈ʒu
	glTranslatef(vPos.x, vPos.y, vPos.z);//sړ

	//]
	glRotatef(vEuler.z, 0.0, 0.0, 1.0);
	glRotatef(vEuler.y, 0.0, 1.0, 0.0);
	glRotatef(vEuler.x, 1.0, 0.0, 0.0);

	if(!flagShadow)
	{
		if(color == RED) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, red);
		if(color == GREEN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, green);
		if(color == BLUE) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, blue);
		if(color == YELLOW) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, yellow);
		if(color == CYAN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, cyan);
		if(color == MAGENTA) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, magenta);
		if(color == WHITE) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, white);
		if(color == GRAY) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, gray);
		if(color == DARK_RED) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_red);
		if(color == DARK_GREEN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_green);
		if(color == DARK_BLUE) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_blue);
		if(color == DARK_YELLOW) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_yellow);
		if(color == DARK_CYAN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_cyan);
		if(color == DARK_MAGENTA) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_magenta);
		if(select) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, white0);

		glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
		glMaterialf(GL_FRONT,GL_SHININESS, 20.0);
	}
	else
	{//e
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
	}

	//XP[O
	glScalef(vSize.x, vSize.y, vSize.z);

	//޼ުĂ̕`
	if(select==1)
	{//Îtexture`
		if(kind == SPHERE) glCallList(sphereTex);
		else if(kind == CUBE) glCallList(cubeTex);
		else if(kind == CYLINDER) glCallList(cylinderTex);
		else if(kind == BOX) glCallList(boxTex);
		else if(kind == COLUMN) glCallList(columnTex);
	}
	else
	{//ʏ
		if(kind == SPHERE) glCallList(sphere);
		else if(kind == CUBE) glCallList(cube);
		else if(kind == CYLINDER) glCallList(cylinder);
		else if(kind == BOX) glCallList(box);
		else if(kind == COLUMN) glCallList(column);
	}
	glPopMatrix();
}
//------------------------------------------------------------------------------
void CRigid::calcMomentOfInertia()
{
	float Ixx, Iyy, Izz;
	if(kind == SPHERE)
	{
		Ixx = Iyy = Izz = vSize.x * vSize.x * mass / 10.0; //vSize͒a
	}
	//[g ̃e\
	mInertia = CMatrix(Ixx, 0.0, 0.0,
					 0.0, Iyy, 0.0,
					 0.0, 0.0, Izz );
	mInertiaInverse = mInertia.inverse();
}

