//rigid3DSM.h(ol_ɗp鍄)
#include "../../parametersSM.h"

#define RIGID_NUM_MAX 2
#define NON_COLLISION -999;
int numRigid0 = 2;//̐
int numRigid = 2;//Xg{܂߂

//-------------------------------------------------------------------------
class CRigid{
public:
	//ޕϐ
	Kind kind;    //CRigid̎
	Color color;  //F
	CVector vSize;//TCY
	CVector vPos; //ʒu
	CVector vPos0;//ݒl
	CVector vEuler;//IC[p(p̏ݒ,deg)
	CVector vAxis; //]
	float angle;   //]px(rad)

	//^V~[Vp
	float mass;        //(Kg)
	CVector vForce;    //O(Newton)
	CVector vForce0, vForce1; //O͏l
	CVector vTorque;   //͂̃[gigN,Newton/mj
	CVector vAccel;    //x(m/s^2)
	CVector vVelocity; //x(m/s)
	CVector vOmega;    //px(rad/s)
	CVector vAlpha;    //px(rad/s^2)
	CVector vGravityToPoint;//dSՓ˓_܂ł̃xNg
	CMatrix mInertia; //[g̃e\
	CMatrix mInertiaInverse;
	CQuaternion q;

	int select;
	bool flagFixed;

	//ފ֐
	CRigid();  //RXgN^
	~CRigid(); //fXgN^
	void draw(bool flagShadow);
	void action2D(float dt);
	void action3D(float dt);
	void sphere2D();
	void calcMomentOfInertia();
private:
	float checkCollisionWithFloor();
	void collisionWithFloor(float dt);
};
CRigid rigid[RIGID_NUM_MAX];

//--------------------------------------------------
CRigid::CRigid()
{
	kind = SPHERE;
	color = WHITE;
	vSize = CVector(0.1, 0.1, 0.1);//Փ˔莞̎_̑傫
	vPos = CVector(0.0, 0.0, 3.0);
	vForce = vForce0 = CVector();
	vVelocity = CVector();
	vOmega = CVector(0.0, 0.0, 0.0);//px(rad)
	vEuler = CVector();
	q = CQuaternion();
	flagFixed = false;
	mass = 1.0;
}

//--------------------------------------------------
CRigid::~CRigid()
{
}

//---------------------------------------------------------
void CRigid::draw(bool flagShadow)
{
	//ẽ}eA
	static float shadowDiffuse[] =  {0.2,0.2,0.2,0.3};//e̊gU
	static float shadowSpecular[] = {0.0,0.0,0.0,1.0};//e̋ʌ

	glPushMatrix();
    //݈ʒu
	glTranslatef(vPos.x, vPos.y, vPos.z);//sړ

	//]
	if(q.s > 1.0) q.s = 1.0;
	if(q.s < -1.0) q.s = -1.0;
	angle = 2.0 * acos(q.s);//[rad]
	vAxis = q.v.norm2();
	glRotatef(angle * RAD_TO_DEG, vAxis.x, vAxis.y, vAxis.z);//]pdegɕϊ

	//̂̃}eA
	static float white0[] = { 0.9, 0.9, 0.9, 1.0};//I
	static float specular[] = { 0.8, 0.8, 0.8, 1.0};
	static float specularS[]= { 0.6, 0.6, 0.6, 1.0};

	if(!flagShadow)
	{
		if(color == RED) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, red);
		if(color == GREEN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, green);
		if(color == BLUE) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, blue);
		if(color == YELLOW) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, yellow);
		if(color == CYAN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, cyan);
		if(color == MAGENTA) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, magenta);
		if(color == WHITE) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, white);
		if(color == GRAY) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, gray);
		if(color == DARK_RED) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_red);
		if(color == DARK_GREEN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_green);
		if(color == DARK_BLUE) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_blue);
		if(color == DARK_YELLOW) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_yellow);
		if(color == DARK_CYAN) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_cyan);
		if(color == DARK_MAGENTA) glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, dark_magenta);

		glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
		glMaterialf(GL_FRONT,GL_SHININESS, 100.0);
	}
	else
	{//e
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,shadowSpecular);
	}

	//XP[O
	glScalef(vSize.x, vSize.y, vSize.z);

	//޼ުĂ̕`
	if(select==1)
	{//Îtexture`
		if(kind == SPHERE) glCallList(sphereTex);
		else if(kind == CUBE) glCallList(cubeTex);
		else if(kind == CYLINDER) glCallList(cylinderTex);
	}
	else
	{//ʏ
		if(kind == SPHERE) glCallList(sphere);
		else if(kind == CUBE) glCallList(cube);
		else if(kind == CYLINDER) glCallList(cylinder);
	}
	glPopMatrix();
}
//----------------------------------------------------------------------------
void CRigid::sphere2D()
{
	float R = vSize.x / 2.0;
	//ڐGʂ̖@irigid猩j
	CVector vNormal = CVector(0.0, 0.0, -1.0);
	//dSڐG_ւ̃xNg
	vGravityToPoint = CVector(0.0, 0.0, -vPos.z);
	//]ɂڐGʂ̑xivVelocityƂ͋tj
	CVector vVelRotate = vCross(vOmega , vGravityToPoint);
	//ڒn_̍x
	CVector vp = vVelocity + vVelRotate; //ڒn_x
	CVector vAxisRote = vCross(vp, vNormal);//]
	vAxisRote.norm();
	//`x̌/
	vForce -= mass * muK * gravity * vp.norm2();
	//]x̉/
	vTorque += mass * muK * gravity * R * vAxisRote;
	//炸ɓ]ꍇłx
	vForce += mass * muK * gravity * (vVelocity.norm2()).reverse2() * 0.1;
	vTorque -= viscous * muK * (vOmega.norm2()) * 0.1;
}

//--------------------------------------------------------------------------------
void CRigid::action2D(float dt)
{	//tẢ^
	float minH = checkCollisionWithFloor();//Œ_
	if(minH < 0.0) {vPos.z += fabs(minH) + 0.001;}//ݍݖh~
	vVelocity.z = 0.0;

	vForce = vForce0;//-z̏d͂Ȃ
	vTorque = CVector();

	if(kind == SPHERE) sphere2D();

	vAccel = vForce / mass;
	vVelocity += vAccel * dt;
	vPos += vVelocity * dt;

	//IuWFNgWnɕϊEuler̉^Kp
	CVector vOmegaObj = qvRotate(~q, vOmega);
	vAlpha = mInertiaInverse * (qvRotate(~q, vTorque) - vCross(vOmegaObj, (mInertia * vOmegaObj)));
	//px̍XV
	vOmega += qvRotate(q, vAlpha * dt);//Wnɕϊ

	q += 0.5 * vOmega * q * dt;
	q.norm();
}
//----------------------------------------------------------
void CRigid::action3D(float dt)
{	
	//tAinʁjɗ܂ł͕^Ȃ
	float minH = checkCollisionWithFloor();//Œ_vGravityToPoint擾
	if(minH < 0.0) {vPos.z += fabs(minH);} //ݍݖh~

	vForce = vForce0 + CVector(0.0, 0.0, -mass * gravity);
	vTorque = CVector() ;

	bool flagCollisionF = false;

	if(minH <= 0.0 && vVelocity.z < -0.2 ) //tAɏՓ
	{
		collisionWithFloor(dt);

		flagCollisionF = true;
		//d͂ƍR͂ɂgN
		vTorque += vCross(vGravityToPoint, CVector(0.0, 0.0, mass * gravity));
	}

	//ʏ2^
	float eps0 = 0.01;
	if( minH < eps0 && vVelocity.z < 0.2 && !flagCollisionF) 
	{
		if(kind == SPHERE) sphere2D();
	}

	vAccel = vForce / mass;
	vVelocity += vAccel * dt;
	vPos += vVelocity * dt;

	//IuWFNgWnɕϊEuler̉^Kp
	CVector vOmegaObj = qvRotate(~q, vOmega);
	vAlpha = mInertiaInverse * (qvRotate(~q, vTorque) - vCross(vOmegaObj, (mInertia * vOmegaObj)));
	//px̍XV
	vOmega += qvRotate(q, vAlpha * dt);//Wnɕϊ
	q += 0.5 * (vOmega * q) * dt;//Wn
	q.norm();
}
//--------------------------------------------------------------
void CRigid::collisionWithFloor(float dt)
{
	CVector vNormal = CVector(0.0, 0.0, -1.0);//Փ˖ʂ̖@(rigid̖@j	
	//Փ˓_̍x
	CVector vp = vVelocity + vCross(vOmega, vGravityToPoint);//Փ˓_x(xNgj
	CVector vTangent = vCross(vNormal, vCross(vp, vNormal)); //ڐxNg
	vTangent.norm();
	
	//͐
	float rikiseki = - (restitut + 1.0) * vDot(vNormal, vp) / (1.0/mass + vDot(vNormal, vCross(mInertiaInverse * vCross(vGravityToPoint, vNormal), vGravityToPoint)));
	//CȂ
	//͂̑a
	vForce += vNormal * rikiseki / dt;
	//͂̃[gigNj̑a
	vTorque += vCross(vGravityToPoint, vNormal) * rikiseki / dt;

	//Cl
	float mu = muK;

	float b = -vDot(vTangent , vp) / (1.0/mass + vDot(vTangent, vCross(mInertiaInverse * vCross(vGravityToPoint, vTangent), vGravityToPoint)));
	float muC = fabs(b / rikiseki);
	if(mu >= muC)
	{
		vForce += b * vTangent / dt;
		vTorque += vCross(vGravityToPoint, vTangent) * b / dt;
	}
	else
	{
		vForce +=  mu * (rikiseki) * vTangent / dt;
		vTorque += vCross(vGravityToPoint, vTangent) * mu * rikiseki / dt;
	}
}
//-------------------------------------------------------------------------
//FloorƂ̏Փ˂𒲂FloorŒʒu̍Ԃ
float CRigid::checkCollisionWithFloor()
{
	float minH;
	//int i, cnt;
	//CVector vCollision[MAX_VERTEX];//Փ˓_̒_ԍ(ʑ)
	//CVector vPointCollision;

	minH = 1000.0;
	float boundingR = vSize.z / 2.0;
	if( vPos.z <= boundingR)
	{//ƏՓ˂̉\
		if(kind == SPHERE)
		{
			minH = vPos.z - boundingR;
			vGravityToPoint = CVector(0.0, 0.0, -vPos.z);

			return minH;
		}
	}
	return minH;
}

//------------------------------------------------------------------------------
void CRigid::calcMomentOfInertia()
{
	float Ixx, Iyy, Izz;
	if(kind == SPHERE)
	{
		Ixx = Iyy = Izz = vSize.x * vSize.x * mass / 10.0; //vSize͒a
	}
	//[g ̃e\
	mInertia = CMatrix(Ixx, 0.0, 0.0,
					 0.0, Iyy, 0.0,
					 0.0, 0.0, Izz );
	mInertiaInverse = mInertia.inverse();
}
