//spring_mass1.h
//1ol_f
//CSЂȂǂ\
#include "../../spring.h"

int flagCollision = 0;//ՓˏL/
int numPole = 2;
int numPoint = 11;
int numHinge = 9;
int numDummy = 0;//˗pol
enum WaveMotion { TRANSVERSE, LONGITUDE, HYBRID};
enum WaveMode { SINGLE, CONTINUOUS};
enum Boundary {B_NON, B_FREE, B_FIXED};

class CSpringMass1
{
public:
    CVector vPos;
    //CVector vEuler;
	double mass;//_P̎
    double constK;
	double hingeK;
	double damping, drag;
    double length0;  //sprinĝP莩R
	double totalLen;
	double frequency;//M̎g
	double amp;      //M̐U

    double radius ;//1ê̔a
	double height0;//Ԃ̍
	
    CVector vForce0;//O͂̏l
	CSpring spring[MAX_SPRING];
	CRigid point[MAX_SPRING + 1];
	CRigid pole[2];
	WaveMotion motion;
	WaveMode mode;
	Boundary boundary;
    //o֐
    CSpringMass1();
    void draw(bool flagShadow);
    void initialize();
	void testHybridWave(double dt);
	void testTransverseWave(double dt);
	void testLongitudinalWave(double dt);
    void calcSpringMass1(CRigid pole[], double dt);
private:
};
CSpringMass1 sm1;
//---------------------------------------------------------------
CSpringMass1::CSpringMass1()
{
    vPos = CVector();
    length0 = 0.1;
	height0 = 0.5;
	constK = 1000.0;
	hingeK = 1000.0;
	totalLen = 1.0;
	mass = 1.0;
	drag = 0.0;
	damping = 0.0;
    radius = 0.03;
	vForce0 = CVector();
	motion =  TRANSVERSE;
	mode = SINGLE;
	boundary = B_NON;
}
//-----------------------------------------------------------------
void CSpringMass1::draw(bool flagShadow)
{
    int i;
    int r1, r2;
    CVector vEuler0, vEuler1;

    //΂ˎ_\
    //_
    for(i = 0; i < numPoint; i++) {
        point[i].color = CYAN;
        if(point[i].flagFixed == true){
            point[i].color= RED;
        }
        point[i].draw(flagShadow);
    }
    for(i = 0; i < numSpring ; i++)
    {
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        spring[i].vPos = (point[r1].vPos + point[r2].vPos) / 2.0;
        spring[i].length = vDist(point[r1].vPos, point[r2].vPos);
        spring[i].vEuler = getEulerZ(point[r1].vPos, point[r2].vPos);
        spring[i].draw(flagShadow);
    }
    for(i = 0; i < numPole; i++)
    {
		pole[i].draw(flagShadow);
	}
}
//-----------------------------------------------------------------
void CSpringMass1::initialize()
{
    int i;
	double length1 = totalLen / (double)numSpring;
    //_̃TCYCʒu
    for(i = 0; i < numPoint + numDummy; i++){
        point[i].kind = SPHERE;
        //point[i].vSize = CVector(1.5*radius, 1.5*radius, 1.5*radius);
        point[i].vSize = CVector(2.0*radius, 2.0*radius, 2.0*radius);
        point[i].vPos.x = 0.0;
        point[i].vPos.y = (double)i * length1;
        point[i].vPos.z = height0;
        point[i].vPos += vPos;//Ŝ̕sړ
		point[i].vVelocity = CVector();
    }

    //olx,yW(_ɋ߂_Œ`jƉ]p
    //olɐڑ鎿_ԍ
    for(i = 0; i < numSpring + numDummy; i++)
    {
        spring[i].kind = S_CYLINDER;
        spring[i].radius = radius;
        spring[i].row1 = i;
        spring[i].row2 = i+1;
    }
}

//-----------------------------------------------------------------------------
//1̃ol}Xf(hinge springlCRԂŉ^)
void CSpringMass1::calcSpringMass1(CRigid pole[], double dt)
{                                           
    int i, j, r1, r2;
    CVector vDir1;//hingeS#1֌PʕxNg(ɂgp)
    CVector vDir2;//hingeS#2֌PʕxNg(ɂgp)
    CVector vFF;
    CVector vRelativeVelocity;
    double dampingF;
    double len, len1, len2, angle;
    double angle0 = M_PI;
    CVector vNormal;

	//͂̑a
    //ݒliȂǂ̊Ój
    for(i = 0; i  < numPoint; i++)
        point[i].vForce = vForce0 + CVector(0.0, 0.0, -gravity * mass);

	//olɂ
    for(i = 0; i < numSpring; i++){
        //e
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;//#1#2ւ̒PʃxNg
        len = vDist(point[r1].vPos, point[r2].vPos);
        vFF = (constK * (len - length0)) * vDir1 ;
        point[r1].vForce += vFF ;//vDirƓ
        point[r2].vForce -= vFF ;//Ε
        //
        vRelativeVelocity = point[r1].vVelocity - point[r2].vVelocity;
        dampingF = damping * vDot(vRelativeVelocity, vDir1);
        point[r1].vForce -= dampingF * vDir1;//ΑxƂ͔Ε
        point[r2].vForce += dampingF * vDir1;//
    }

    //qރoll
    for(i = 1; i < numSpring; i++)
    {
        len1 = vDist(point[i].vPos, point[i-1].vPos);
        len2 = vDist(point[i].vPos, point[i+1].vPos);
        //hinge̒Sאڎ_֌xNg
        vDir1 = point[i].vPos >> point[i-1].vPos;
        vDir2 = point[i].vPos >> point[i+1].vPos;
        //Q̃xNĝȂpx
        angle = getAngle(vDir1, vDir2); //radP
        if(angle == angle0) continue;
        //@
        vNormal = vCross(vDir1, vDir2);
        vDir1 = vCross(vNormal, vDir1); //_1ɍp͂̕
        vFF = hingeK * (angle - angle0) * vDir1 / len1;
        point[i-1].vForce += vFF ;//vDir1Ɠ
        point[i].vForce -= vFF;
        vDir2 = vCross(vNormal, vDir2);//_2ɍp͂̕
        vFF = hingeK * (angle - angle0) * vDir2 / len2;
        point[i+1].vForce -= vFF ;//vDir2̔Ε
        point[i].vForce += vFF;
    }

	if(flagCollision == 1)
	{

		//_m̏Փ˖h~̂ߐ˗͂^
		int m1, m2;
		for(m1 = 0; m1 <numPoint-1; m1++){
			for(m2 = m1+2; m2 <numPoint; m2++){
				vDir1 = point[m1].vPos >> point[m2].vPos;//#1#2ւ̒PʃxNg
				len = vDist(point[m1].vPos, point[m2].vPos);
				if(len < length0) {
					vFF = ( 0.5 / (0.0001+len*len) ) * vDir1 ;
					point[m1].vForce -= vFF ;//vDirƔΕ
					point[m2].vForce += vFF ;//
				}
			}
		}

		CVector vPole;//_Ɠpolëʒu
		//poleƎ_̏Փ˖h~̂ߐ˗͂^
		for(j = 0; j < numPole; j++)
		{
			for(i = 0; i < numPoint; i++){
				if(point[i].flagFixed == true) continue; //Œ
				vPole = pole[j].vPos;
				vPole.z = point[i].vPos.z;//_Ɠpoleʒu
				if(vPole.z > pole[j].vPos.z + pole[j].vSize.z/2.0) continue;//polȅł͎ՂȂ
				if(vPole.z < pole[j].vPos.z - pole[j].vSize.z/2.0) continue;//polẻ
				vDir1 = vPole >> point[i].vPos;//PʃxNg
				len = vDist(vPole, point[i].vPos);
				if(len < radius + pole[j].vSize.x/2.0)
				{
					vFF = ( 0.5 / (0.0001+len*len)) * vDir1 ;
					point[i].vForce += vFF ;//vDir1̕
				}
			}
		}

		//poleƃol̏Փ˖h~̂ߐ˗͂^
		for(j = 0; j < numPole; j++)
		{
			for(i = 0; i < numSpring; i++){
				if(point[i].flagFixed == true) continue; //Œ
				vPole = pole[j].vPos;
				vPole.z = spring[i].vPos.z;//olƓpole[j]ʒu
				if(vPole.z > pole[j].vPos.z + pole[j].vSize.z/2.0) continue;//pole[j]̏ł͎ՂȂ
				if(vPole.z < pole[j].vPos.z - pole[j].vSize.z/2.0) continue;//polẻ
				vDir1 = vPole >> spring[i].vPos;//PʃxNg
				len = vDist(vPole, spring[i].vPos);
				if(len < radius + pole[j].vSize.x/2.0)
				{
					vFF = ( 0.5 / (0.0001+len*len)) * vDir1 ;
					r1 = spring[i].row1;
					r2 = spring[i].row2;
					point[r1].vForce += vFF ;//vDir1̕
					point[r2].vForce += vFF ;//vDir1̕
				}
			}
		}
	}

    //SRƏʏ
    for(i = 0; i < numPoint; i++)
    {
        if(point[i].flagFixed == true) continue; //Œ

        //CSRiSĂ̎_ɈlƉ)
        point[i].vForce -= drag * point[i].vVelocity;

		//ʏ
        if(point[i].vPos.z < radius)
        {
			//ʂɂ鎿_ɑ΂Ăׂ͂薀C^
            point[i].vForce -= (muK * mass * gravity) * point[i].vVelocity.norm2();
            //ʏɐ
            point[i].vPos.z = radius;
            //Ƃ̏Փ
            if(point[i].vVelocity.z < 0.0){ //_ƏʂƂ͒eՓ˂Ƃ

                point[i].vVelocity.z = - restitut * point[i].vVelocity.z ;
            }
        }
        //Euler@
        //x
        point[i].vAccel = point[i].vForce / mass;
        //x
        point[i].vVelocity += point[i].vAccel * dt;

        //ʒu
        point[i].vPos += point[i].vVelocity * dt;
    }
	vPos = point[0].vPos;

}
//-----------------------------------------------------------------------------

//g
void CSpringMass1::testTransverseWave(double dt)
{                                                
	int i, r1, r2;
    CVector vDir1;
    CVector vDir2;
    CVector vFF;
    CVector vRelativeVelocity;
    double dampingF;
    double len;
    CVector vNormal;
	float dragA = drag;
	float dragMax = 30.0;

    //ݒl
    for(i = 0; i  < numPoint + numDummy; i++)
        point[i].vForce = CVector();//d

    //olɂ
    for(i = 0; i < numSpring + numDummy; i++){
       //e
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;//#1#2ւ̒PʃxNg
        len = vDist(point[r1].vPos, point[r2].vPos);
        vFF = (constK * (len - length0)) * vDir1 ;
        point[r1].vForce += vFF ;//vDirƓ
        point[r2].vForce -= vFF ;//Ε
        //
        vRelativeVelocity = point[r1].vVelocity - point[r2].vVelocity;
        dampingF = damping * vDot(vRelativeVelocity, vDir1);
        point[r1].vForce -= dampingF * vDir1;//ΑxƂ͔Ε
        point[r2].vForce += dampingF * vDir1;//
    }

	//particlȇxƈʒu̍XV
    for(i = 0; i < numPoint + numDummy; i++)
    {
        if(point[i].flagFixed == true) continue; //Œ
		if(boundary == B_NON)
		{
			if(i > numPoint+1) dragA = drag + dragMax * (float)(i - numPoint) / (float)numDummy;
		}
        //CSRiSĂ̎_ɈlƉ)
       // point[i].vForce.z -= dragA * point[i].vVelocity.z;
        point[i].vForce -= dragA * point[i].vVelocity;

       //Euler@
        //x(xyWŒj
        point[i].vAccel.z = point[i].vForce.z / mass;
        //x
        point[i].vVelocity.z += point[i].vAccel.z * dt;

        //ʒu
        point[i].vPos.z += point[i].vVelocity.z * dt;
    }
}

//cg
void CSpringMass1::testLongitudinalWave(double dt)
{                                                
	int i, r1, r2;
    CVector vDir1;//hingeS#1֌PʕxNg(ɂgp)
    CVector vDir2;//hingeS#2֌PʕxNg(ɂgp)
    CVector vFF;
    CVector vRelativeVelocity;
    double dampingF;
    double len;//, len1, len2;
//    double angle0 = M_PI;
    CVector vNormal;
	float dragA = drag;

    //͂̑a
    //ݒl
    for(i = 0; i  < numPoint + numDummy; i++)
        point[i].vForce = CVector();//d

    //olɂ
    for(i = 0; i < numSpring + numDummy; i++){
        //e
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;//#1#2ւ̒PʃxNg
        len = vDist(point[r1].vPos, point[r2].vPos);
        vFF = (constK * (len - length0)) * vDir1 ;
        point[r1].vForce += vFF ;//vDirƓ
        point[r2].vForce -= vFF ;//Ε
        //
        vRelativeVelocity = point[r1].vVelocity - point[r2].vVelocity;
        dampingF = damping * vDot(vRelativeVelocity, vDir1);
        point[r1].vForce -= dampingF * vDir1;//ΑxƂ͔Ε
        point[r2].vForce += dampingF * vDir1;//
    }

    //particlȇxƈʒu̍XV
    for(i = 0; i < numPoint + numDummy; i++)
    {
        if(point[i].flagFixed == true) continue; //Œ
		if(boundary == B_NON)
		{
			if(i > numPoint+1) dragA = drag + 1.0 * (float)(i - numPoint);
			else dragA = drag;
		}

        //CSRiSĂ̎_ɈlƉ)
        point[i].vForce -= dragA * point[i].vVelocity;

        //Euler@
        //xiy̐Uj
        point[i].vAccel.y = point[i].vForce.y / mass;
        //x
        point[i].vVelocity.y += point[i].vAccel.y * dt;

        //ʒu
        point[i].vPos.y += point[i].vVelocity.y * dt;
    }
}

//g
void CSpringMass1::testHybridWave(double dt)
{                                                
	int i, r1, r2;
    CVector vDir1, vDir2, vFF;
    CVector vRelativeVelocity;
    double dampingF;
    double len;
    CVector vNormal;
	float dragA = drag;

	//͂̑a
    //ݒl
    for(i = 0; i  < numPoint + numDummy; i++)
        point[i].vForce = CVector();//d

    //olɂ
    for(i = 0; i < numSpring + numDummy; i++){
        //e
        r1 = spring[i].row1;
        r2 = spring[i].row2;
        vDir1 = point[r1].vPos >> point[r2].vPos;//#1#2ւ̒PʃxNg
        len = vDist(point[r1].vPos, point[r2].vPos);
        vFF = (constK * (len - length0)) * vDir1 ;
        point[r1].vForce += vFF ;//vDirƓ
        point[r2].vForce -= vFF ;//Ε
        //
        vRelativeVelocity = point[r1].vVelocity - point[r2].vVelocity;
        dampingF = damping * vDot(vRelativeVelocity, vDir1);
        point[r1].vForce -= dampingF * vDir1;//ΑxƂ͔Ε
        point[r2].vForce += dampingF * vDir1;//
    }

    //particlȇxƈʒu̍XV
    for(i = 0; i < numPoint + numDummy; i++)
    {
        if(point[i].flagFixed == true) continue; //Œ
		if(boundary == B_NON)
		{
			if(i > numPoint+1) dragA = drag + 1.0 * (float)(i - numPoint);
			else dragA = drag;
		}

        //CSRiSĂ̎_ɈlƉ)
        point[i].vForce -= dragA * point[i].vVelocity;

        //Euler@
        //x
        point[i].vAccel = point[i].vForce / mass;
        //x
        point[i].vVelocity += point[i].vAccel * dt;

        //ʒu
        point[i].vPos += point[i].vVelocity * dt;
    }
}


