//spring_mass2.h
//Qêol-_̏ŴŌvZ
//zSȂǂ\

#include "../../spring.h"

#define MAX_NUM_ROW 21
#define MAX_NUM_COL 21
#define MAX_NUM_STRUCT 840
#define MAX_NUM_SHEAR 800

int flagShearDisp = 0;
int flagCollision = 0;//_ǂ̏ՓˏL/
int numPole = 4;
int numPoint;
int numStruct; //ʏ̍\ol
int numHinge ; //lԃol
int numShear ; //Ίpɑ}fol

enum DispType {NON_TEX, TEXTURE, CHECK, SMM};
DispType dispType = CHECK;
int flagShear_Disp = 0;

class CSpringMass2
{
public:
    CVector vPos;
    CVector vEuler;
	double mass;//_P̎
	float inertialInverse;//_1̊[g̋t
    float structK, shearK, hingeK;
    float damping, drag;
    int numRow;    //s(xj
    int numCol;    //(yj
    CSpring structS[MAX_NUM_STRUCT];//[180];
    CSpring shearS[MAX_NUM_SHEAR];//[200];//[100];//[162];
    CSpring hingeS[MAX_NUM_ROW][MAX_NUM_COL];
    CRigid point[MAX_NUM_ROW][MAX_NUM_COL];
    double lengthX0, lengthY0;//spring̊{
	double totalLenX, totalLenY;//Ŝ̕
    double pointRadius;//_̔a
	double height;
    CVector vForce0;//O
	CRigid pole[10];
	CRigid rigid2;//_ƏՓ˂鍄

    //F
    //o֐
    CSpringMass2();
    void draw(bool flagShadow, int selLoc);
    void initialize();
    void calcSpringMass(CRigid pole[], double dt);
private:
};
CSpringMass2 sm2;
//---------------------------------------------------------------
CSpringMass2::CSpringMass2()
{
//    int i, j;
    numRow = 10;
    numCol = 10;
    lengthX0 = 0.1;
    lengthY0 = 0.1;
    numStruct = 180;
    numShear = 100;
    numPoint = (numRow+1)*(numCol+1);
    pointRadius = 0.02;//_̔a
	height = 1.0;
}
//-----------------------------------------------------------------
void CSpringMass2::draw(bool flagShadow, int selLoc)
{
    int i, j, np;
    int r1, r2, c1, c2;//, s1, s2;
    float p[MAX_NUM_ROW * MAX_NUM_COL][3]; //_W

	//pole
	glUniform1i(selLoc, 0);
    for(i = 0; i < numPole; i++) pole[i].draw(flagShadow);

	//_̃}eA
	static float white0[] = { 0.9, 0.9, 0.9, 1.0};//I
	static float specular[]= { 0.8, 0.8, 0.8, 1.0};
	static float specularS[]= { 0.6, 0.6, 0.6, 1.0};
	//ẽ}eA
	static float shadowDiffuse[] =  {0.0, 0.0, 0.0, 0.2};//e̊gU
	if(!flagShadow)
	{
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, white0);
		glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
		glMaterialf(GL_FRONT,GL_SHININESS, 100.0);
	}
	else
	{
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,specularS);
		glMaterialf(GL_FRONT,GL_SHININESS, 100.0);
	}

	if(dispType == SMM) goto SMM_DISP;
    
	//e_̍W
    for(j = 0; j <= numCol; j++){
	    for(i = 0; i <= numRow; i++){
		    np = i * (numCol + 1) + j;
		    p[np][0] = point[i][j].vPos.x;
		    p[np][1] = point[i][j].vPos.y;
		    p[np][2] = point[i][j].vPos.z;
	    }
    }
	if(dispType == TEXTURE) glUniform1i(selLoc, 1);
	else glUniform1i(selLoc,0);

	if(dispType == NON_TEX) drawGridSquare(numRow+1, numCol+1, p);
	else if(dispType == TEXTURE) drawTexGridSquare(numRow+1, numCol+1, p);
    else if(dispType == CHECK) drawCheckSquare(numRow+1, numCol+1, p, flagShadow);
    return;

SMM_DISP:;

	//glUniform1i(selLoc, 0);
    //\΂
    for(i = 0; i < numStruct; i++)
    {
        r1 = structS[i].row1; c1 = structS[i].col1;
        r2 = structS[i].row2; c2 = structS[i].col2;
        structS[i].length = vDist(point[r1][c1].vPos, point[r2][c2].vPos);
        structS[i].vEuler = getEulerZ(point[r1][c1].vPos, point[r2][c2].vPos);
        structS[i].kind = S_CYLINDER;
        structS[i].radius = pointRadius * 0.5;
        structS[i].vPos = (point[r1][c1].vPos + point[r2][c2].vPos) / 2.0;
        structS[i].num1 = 6.0;
    }
    //f΂
    for(i = 0; i < numShear; i++)
    {
        r1 = shearS[i].row1; c1 = shearS[i].col1;
        r2 = shearS[i].row2; c2 = shearS[i].col2;
        shearS[i].length = vDist(point[r1][c1].vPos, point[r2][c2].vPos);//sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));
        shearS[i].vEuler = getEulerZ(point[r1][c1].vPos, point[r2][c2].vPos);
        shearS[i].kind = S_CYLINDER;
        shearS[i].radius = pointRadius * 0.5;
        shearS[i].vPos = (point[r1][c1].vPos + point[r2][c2].vPos) / 2.0;
    }
    //_
    for(i = 0; i <= numRow; i++)
    for(j = 0; j <= numCol; j++) {
        point[i][j].color = CYAN;
        if(point[i][j].flagFixed == true){
            point[i][j].color= RED;
        }
        point[i][j].draw(flagShadow);
    }

	for(i = 0; i < numStruct; i++) structS[i].draw(flagShadow);

    //fol\
    if(flagShearDisp == 1)
	{
        for(i = 0; i < numShear; i++) shearS[i].draw(flagShadow);
    }

}

//-----------------------------------------------------------------
void CSpringMass2::initialize()
{
    int i, j, cnt;

    //_̃TCYCʒu
    for(i = 0; i <= numRow; i++)
        for(j = 0; j <= numCol; j++){
            point[i][j].vSize = CVector(2.0*pointRadius, 2.0*pointRadius, 2.0*pointRadius);
            point[i][j].vPos.x = (double)i * totalLenX / (double)numRow;//lengthX0;
            point[i][j].vPos.y = (double)j * totalLenY / (double)numCol;//lengthY0;
            point[i][j].vPos.z = 0.0;
            point[i][j].vPos = rotate(point[i][j].vPos, vEuler);
            point[i][j].vPos += vPos;//Ŝ̕sړ
        }

    //olɐڑ鎿_ԍirow,colŎwj
    cnt = 0;
    for(i = 0; i <= numRow; i++)
    {
        for(j = 0; j < numCol; j++)
        {
            structS[cnt].row1 = i;
            structS[cnt].col1 = j;
            structS[cnt].row2 = i;
            structS[cnt].col2 = j + 1;
            cnt++;
        }
    }
    for(i = 0; i < numRow; i++)
    {
        for(j = 0; j <= numCol; j++)
        {
            structS[cnt].row1 = i;
            structS[cnt].col1 = j;
            structS[cnt].row2 = i + 1;
            structS[cnt].col2 = j;
            cnt++;
        }
    }
    numStruct = cnt;

    //fol
    float len0 = sqrt(lengthX0*lengthX0+lengthY0*lengthY0);
    cnt = 0;
    for(i = 0; i < numRow; i++)
    {
        for(j = 0; j < numCol; j++)
        {
            shearS[cnt].row1 = i;   shearS[cnt].col1 = j;
            shearS[cnt].row2 = i+1; shearS[cnt].col2 = j+1;
            cnt++;
        }
    }
    for(i = 0; i < numRow; i++)
    {
        for(j = 0; j < numCol; j++)
        {
            shearS[cnt].row1 = i+1; shearS[cnt].col1 = j;
            shearS[cnt].row2 = i;   shearS[cnt].col2 = j+1;
            cnt++;
        }
    }
    numShear = cnt;

    //qނ̃oll
	numHinge = 2 * (numRow+1) * (numCol+1);
    hingeS[0][0].num = 0;
    hingeS[0][numCol].num = 0;
    hingeS[numRow][0].num = 0;
    hingeS[numRow][numCol-1].num = 0;
    //אڂ鎿_ԍCyA
    //edge
    //j = 0
    for(i = 1; i < numRow; i++)
    {
        hingeS[i][0].num = 1;
        hingeS[i][0].row[0] = i-1; hingeS[i][0].col[0] = 0;
        hingeS[i][0].row[1] = i+1; hingeS[i][0].col[1] = 0;
    }
    //j = numCol
    for(i = 1; i < numRow; i++)
    {
        hingeS[i][numCol].num = 1;
        hingeS[i][numCol].row[0] = i-1; hingeS[i][numCol].col[0] = numCol;
        hingeS[i][numCol].row[1] = i+1; hingeS[i][numCol].col[1] = numCol;
    }
    //i = 0
    for(j = 1; j < numCol; j++)
    {
        hingeS[0][j].num = 1;
        hingeS[0][j].row[0] = 0; hingeS[0][j].col[0] = j-1;
        hingeS[0][j].row[1] = 0; hingeS[0][j].col[1] = j+1;
    }
    //i = numRow
    for(j = 1; j < numCol; j++)
    {
        hingeS[numRow][j].num = 1;
        hingeS[numRow][j].row[0] = numRow; hingeS[numRow][j].col[0] = j-1;
        hingeS[numRow][j].row[1] = numRow; hingeS[numRow][j].col[1] = j+1;
    }
    //inside
    for(i = 1; i < numRow; i++)
        for(j = 1; j < numCol; j++)
        {
            hingeS[i][j].num = 2;
            hingeS[i][j].row[0] = i-1; hingeS[i][j].col[0] = j;
            hingeS[i][j].row[1] = i+1; hingeS[i][j].col[1] = j;
            hingeS[i][j].row[2] = i  ; hingeS[i][j].col[2] = j-1;
            hingeS[i][j].row[3] = i  ; hingeS[i][j].col[3] = j+1;
        }
}

//-----------------------------------------------------------------------------
//Q̃ol}Xf(hinge springlCRԂŉ^)
void CSpringMass2::calcSpringMass(CRigid pole[], double dt)
{                        
    int i, j, k, r1, r2, c1, c2, m;
    CVector vDir1;//hingeS#1֌PʕxNg(ɂgp)
    CVector vDir2;//hingeS#2֌PʕxNg(ɂgp)
    CVector vFF;
    CVector vRelativeVelocity;
    float len, len1, len2;
    float lenShear0 = sqrt(lengthX0*lengthX0 + lengthY0*lengthY0);
    float angle0 = M_PI;
    float angle;
	float dampingF;
    CVector vNormal;
    CVector vPole;//_Ɠpolëʒu

    //͂̑a
    //ݒliȂǂ̊Ój
    for(i = 0; i <= numRow; i++)
        for(j = 0; j <= numCol; j++){
            point[i][j].vForce = vForce0 + CVector(0.0, 0.0, - mass * gravity);
        }

    //\olɂ
    for(i = 0; i < numStruct; i++){
        //e
        r1 = structS[i].row1; c1 = structS[i].col1;
        r2 = structS[i].row2; c2 = structS[i].col2;
        len = vDist(point[r1][c1].vPos, point[r2][c2].vPos);
		vDir1 =  (point[r2][c2].vPos - point[r1][c1].vPos)/len; 
        if(r1 == r2)//s̃ol
            vFF = (structK * (len - lengthY0)) * vDir1 ;
        else//̃ol
            vFF = (structK * (len - lengthX0)) * vDir1 ;
        point[r1][c1].vForce += vFF ;//vDirƓ
        point[r2][c2].vForce -= vFF ;//Ε
        //
        vRelativeVelocity = point[r1][c1].vVelocity - point[r2][c2].vVelocity;
        dampingF = damping * vDot(vRelativeVelocity , vDir1);
        point[r1][c1].vForce -= dampingF * vDir1;//ΑxƂ͔Ε
        point[r2][c2].vForce += dampingF * vDir1;//
    }

    //folɂ
    for(i = 0; i < numShear; i++){
        r1 = shearS[i].row1; c1 = shearS[i].col1;
        r2 = shearS[i].row2; c2 = shearS[i].col2;
        len = vDist(point[r1][c1].vPos, point[r2][c2].vPos);
		vDir1 =  (point[r2][c2].vPos - point[r1][c1].vPos)/len; 
        vFF = (shearK * (len - lenShear0)) * vDir1 ;
        point[r1][c1].vForce += vFF ;//vDirƓ
        point[r2][c2].vForce -= vFF ;//Ε
        //
        vRelativeVelocity = point[r1][c1].vVelocity - point[r2][c2].vVelocity;
        dampingF = damping * vDot(vRelativeVelocity, vDir1);

        point[r1][c1].vForce -= dampingF * vDir1;//ΑxƂ͔Ε
        point[r2][c2].vForce += dampingF * vDir1;//
    }

    //qށiԁjoll
    for(i = 0; i <= numRow; i++)
    {
        for(j = 0; j <= numCol; j++)
        {
            for(m = 0; m < hingeS[i][j].num; m++)
            {
                if(i == 0 && j == 0) continue;
                if(i == 0 && j == numCol-1) continue;
                if(i == numRow && j == 0) continue;
                if(i == numRow && j == numCol) continue;

                r1 = hingeS[i][j].row[2*m];   c1 = hingeS[i][j].col[2*m];
                r2 = hingeS[i][j].row[2*m+1]; c2 = hingeS[i][j].col[2*m+1];

                len1 = vDist(point[i][j].vPos, point[r1][c1].vPos);
                len2 = vDist(point[i][j].vPos, point[r2][c2].vPos);
                //hinge̒Sאڎ_֌xNg
                vDir1 = point[i][j].vPos >> point[r1][c1].vPos;
                vDir2 = point[i][j].vPos >> point[r2][c2].vPos;
                //Q̃xNĝȂpx
                angle = getAngle(vDir1, vDir2);
                //@
                vNormal = vCross(vDir1, vDir2);
                //_1ɍp
                vDir1 = vCross(vNormal, vDir1);
                vFF = hingeK * (angle - angle0) * vDir1 / len1;
                point[r1][c1].vForce += vFF ;//vDirƓ
                point[i][j].vForce -= vFF ;//ړ_ł͔Ε
                //_2ɍp
                vDir2 = vCross(vNormal, vDir2);
                vFF = hingeK * (angle - angle0) * vDir2 / len2;
                point[r2][c2].vForce -= vFF ;//vDir2̔Ε
                point[i][j].vForce += vFF ;//ړ_ł͔Ε
             }
        }
    }

	if(flagCollision == 0) goto Euler;

	//_ǂ̏Փ
	double dia = 0.2;
    for(j = 0; j <= numCol; j++)
	{
		for(i = 0; i <= numRow; i++)
		{
			for(int J = 0; J <= numCol; J++)
			{
				for(int I = 0; I <= numRow; I++)
				{
					//דm͏
					if(abs(i - I) <= 1 && abs(j - J) <= 1) continue;
					vDir1 = point[i][j].vPos >> point[I][J].vPos;//#1#2ւ̒PʃxNg
					len = vDist(point[i][j].vPos, point[I][J].vPos);
					if(len < dia) {
						vFF = ( 0.5 / (0.0001+len*len) ) * vDir1 ;
						point[i][j].vForce -= vFF ;//vDirƔΕ
						point[I][J].vForce += vFF ;//
					}
				}
			}
        }
    }

    //poleƎ_
	for(k = 0; k < numPole; k++)
	{
		for(i = 0; i <= numRow; i++)
		{
			for(j = 0; j <= numCol; j++) 
			{
		        if(point[i][j].flagFixed == true) continue; //Œ

				vPole = pole[k].vPos;
				vPole.z = point[i][j].vPos.z;//_Ɠpoleʒu
				if(vPole.z > pole[k].vPos.z + pole[k].vSize.z/2.0) continue;
				if(vPole.z < pole[k].vPos.z - pole[k].vSize.z/2.0) continue;
				vDir1 = vPole >> point[i][j].vPos;//PʃxNg
				len = vDist(vPole, point[i][j].vPos);
				if(len < dia + pole[k].vSize.x/2.0)
				{
					vFF = ( 0.2 / (0.0001+len*len) ) * vDir1 ;
					point[i][j].vForce += vFF ;//vDir1̕
				}
			}
		}
	}
Euler:;
    //point̑xƈʒu̍XV(Euler@)
    for(i = 0; i <= numRow; i++)
    {
        for(j = 0; j <= numCol; j++)
        {
            if(point[i][j].flagFixed == true) continue; //Œ
            //CSRiSĂ̎_ɈlƉ)
			point[i][j].vForce -= drag * point[i][j].vVelocity;
            if( point[i][j].vPos.z <= pointRadius){//ʂɂ鎿_ɑ΂Ăׂ͂薀C^
                point[i][j].vForce -= (muK * point[i][j].mass * gravity) * point[i][j].vVelocity.norm2();
            }
            //x
            point[i][j].vAccel = point[i][j].vForce / point[i][j].mass;
            //x
            point[i][j].vVelocity += point[i][j].vAccel * dt;
            //ʒu
            point[i][j].vPos += point[i][j].vVelocity * dt;
            //ʏ

            if(point[i][j].vPos.z < pointRadius)
            {
                //ʏɐ
                point[i][j].vPos.z = pointRadius;
                //Ƃ̏Փ
                if(point[i][j].vVelocity.z < 0.0){ //_ƏʂƂ͒eՓ˂Ƃ
                     point[i][j].vVelocity.z = - restitut * point[i][j].vVelocity.z ;
                }
            }
        }
    }
    //sm2̈ʒu(lp̕ψʒu)
    vPos = point[0][0].vPos;
}

