//spring_mass3.h

#include "../../spring.h"

//Rêol-_̏Ŵō쐬
//Ɖ~̂Ƃ@numCol <= 10, numStk <= 10
//̂̂Ƃ    numRow <= 4, numCol <= 4, numStk <= 10
#define MAX_NUM_POINT 275//160
#define MAX_NUM_STRUCT 690
#define MAX_NUM_SHEAR  1152

enum DispType {NON_TEX, TEXTURE, CHECK, SMM};
DispType dispType = CHECK;
int flagShear_Disp = 0;

enum Forced {NON, FORCED_Y, FORCED_Z};
Forced forced = NON;

int numStruct; //ʏ̍\ol
int numShear ; //Ίpɑ}fol

float amp = 1.0;
float frequency = 0.8;

class CSpringMass3
{
public:
    int kind;
    CVector vPos;
    CVector vSize;
    CVector vEuler;
    CVector vForce0, vForce;
    CVector vVelocity, vAccel;
    float structK, shearK;
    float damping, drag;
    float lengthX0, lengthY0, lengthZ0;//spring̊{
	CVector vGravityToPoint;
    float pointRadius ;//_̔a
    float mass;        //_̎
	float inertialInverse;//_1̊[g̋t
    
	int numPoint;//_
    int numRow;//s(xolj
    int numCol;//(yolj
    int numStk;//͐ϐ(zol)
    CSpring structS[MAX_NUM_STRUCT];
    CSpring shearS[MAX_NUM_SHEAR];
    CRigid point[MAX_NUM_POINT];
	CRigid rigid2;//_ƏՓ˂鍄

    CSpringMass3();
 
    //o֐
    void draw(bool flagShadow);
    void initializeCube();
    void initializeSphere();
    void initializeCylinder();
    void calcSpringMass(float dt, float tt);
private:
};
CSpringMass3 sm3;
//---------------------------------------------------------------
CSpringMass3::CSpringMass3()
{
	kind = CUBE;
    numRow = 3;
    numCol = 3;
    numStk = 3;
    structK = 5000.0;
    shearK = 5000.0;
    pointRadius = 0.02;//0.03;
	inertialInverse;
}
//-----------------------------------------------------------------
void CSpringMass3::draw(bool flagShadow)
{
    int i, j, k, np, n, np1, np2;
    float p1[130][3], p2[70][3], p3[70][3]; //eʂ̒_W(p1͋,~ɂgpj
    float p4[70][3], p5[70][3], p6[70][3]; //eʂ̒_W

	//ƔˌR,G,BWŎw肳Ă
    float ambient[] = {0.f, 0.5f, 0.5f, 1.0f};
    float specular[] = {0.5f, 0.5f, 0.5f, 1.0f};
    float highlight = 100.0f;
	float diffuse[] = {1.0f, 1.0f, 1.0f, 1.0f};
	float shadowDiffuse[] = {0.2f, 0.2f, 0.2f, 0.3f};
    float shadowSpecular[] = {0.0f,0.0f,0.0f,1.0f};//e̋ʌ

	if(flagShadow == false){
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,diffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
		glMaterialf(GL_FRONT,GL_SHININESS,highlight);
	}
	else{//e
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,shadowSpecular);
	}

	if(dispType == SMM) goto SMM_DISP;
	
	if(kind == CUBE)
    {
	    //e_̍W
        //Top(k=0Top)
        k = 0;
	    for(j = 0; j <= numCol; j++)
		    for(i = 0; i <= numRow; i++){
			    np = i * (numCol+1) + j; //texture̒_ԍ
                n = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j;//spring_mass_model
			    p1[np][0] = (float)point[n].vPos.x;
			    p1[np][1] = (float)point[n].vPos.y;
			    p1[np][2] = (float)point[n].vPos.z;
		    }
        //Front
        i = numRow;
	    for(j = 0; j <= numCol; j++)
		    for(k = 0;k <= numStk; k++){
			    np = k * (numCol+1) + j;
                n = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j;
			    p2[np][0] = (float)point[n].vPos.x;
			    p2[np][1] = (float)point[n].vPos.y;
			    p2[np][2] = (float)point[n].vPos.z;
		    }
        //Right(IuWFNgg猩āj
        j = 0;
	    for(i = 0; i <= numRow; i++)
	    	for(k = 0; k <= numStk; k++){
			    np = k * (numRow+1) + i;
                n = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j;
			    p3[np][0] = (float)point[n].vPos.x;
			    p3[np][1] = (float)point[n].vPos.y;
			    p3[np][2] = (float)point[n].vPos.z;
		    }
        //Left(IuWFNgg猩āj
        j = numCol;
	    for(i = numRow; i >= 0; i--)
		    for(k = 0;k <= numStk; k++){
			    np = k * (numRow+1) + numRow - i;
                n = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j;
			    p4[np][0] = (float)point[n].vPos.x;
			    p4[np][1] = (float)point[n].vPos.y;
			    p4[np][2] = (float)point[n].vPos.z;
		    }
        //Rear(IuWFNgg猩āj
        i = 0;
	    for(j = numCol; j >= 0; j--)
	    	for(k = 0; k <= numStk; k++){
			    np = k * (numCol+1) + numCol-j;
                n = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j;
			    p5[np][0] = point[n].vPos.x;
			    p5[np][1] = point[n].vPos.y;
			    p5[np][2] = point[n].vPos.z;
		    }
        //Bottom
        k = numStk;
	    for(j = numCol; j >= 0; j--)
		    for(i = 0; i <= numRow; i++){
			    np = i * (numCol+1) + numCol-j;
                n = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j;
			    p6[np][0] = point[n].vPos.x;
			    p6[np][1] = point[n].vPos.y;
			    p6[np][2] = point[n].vPos.z;
		    }
			if(dispType == NON_TEX) drawGridCube(numRow+1, numCol+1, numStk+1, p1, p2, p3, p4, p5, p6);
			else if(dispType == TEXTURE) drawTexGridCube(numRow+1, numCol+1, numStk+1, p1, p2, p3, p4, p5, p6);
            else if(dispType == CHECK) drawCheckCube(numRow+1, numCol+1, numStk+1, p1, p2, p3, p4, p5, p6, flagShadow);
	}

    else if(kind == SPHERE)
    {
        for(k = 0; k <= numStk; k++){
            if(k == 0){ //Top(renderingCŏ_numCol̒_Ƃj
                for(j = 0; j < numCol; j++){
                    p1[j][0] = point[0].vPos.x;
                    p1[j][1] = point[0].vPos.y;
                    p1[j][2] = point[0].vPos.z;
                }
            }
            else if(k == numStk){ //Bottom
                n = numPoint-2;   //spring_mass model̒_ԍ
                for(j = 0; j < numCol; j++){
                    np = k * numCol + j;//rendering̒_ԍ
                    p1[np][0] = point[n].vPos.x;
                    p1[np][1] = point[n].vPos.y;
                    p1[np][2] = point[n].vPos.z;
                }
            }
            else{
                for(j = 0; j < numCol; j++){
                    n = (k-1) * numCol + j + 1;//spring_mass model̒_ԍ
                    np = k * numCol + j;       //rendering̒_ԍ
                    p1[np][0] = point[n].vPos.x;
                    p1[np][1] = point[n].vPos.y;
                    p1[np][2] = point[n].vPos.z;
                }
            }
        }
		if(dispType == NON_TEX) drawGridSphere(numCol, numStk+1, p1);
		else if(dispType == TEXTURE) drawTexGridSphere(numCol, numStk+1, p1);
        else if(dispType == CHECK) drawCheckSphere(numCol, numStk+1, p1, flagShadow);
 	}
    else if(kind == CYLINDER)
    {   //textureł́CŜ̏Ɖɒ_u
        //̒S
        p1[0][0] = point[0].vPos.x;
        p1[0][1] = point[0].vPos.y;
        p1[0][2] = point[0].vPos.z;
        //̒S
        n = numStk * (numCol + 1);//SMM̎_ԍ
        np = 1 + (numStk+1) * (numCol);//rendering̒_ԍ
        p1[np][0] = point[n].vPos.x;
        p1[np][1] = point[n].vPos.y;
        p1[np][2] = point[n].vPos.z;
        //
        for(k = 0; k <= numStk; k++)
            for(j = 0; j < numCol; j++)
			{
                n = k * (numCol+1) + j + 1; //SMM̎_ԍ
                np = k * numCol + j + 1;//textureiԒi̒Sɂ͒_sKvj
                p1[np][0] = point[n].vPos.x;
                p1[np][1] = point[n].vPos.y;
                p1[np][2] = point[n].vPos.z;
            }
 			if(dispType == NON_TEX) drawGridCylinder(numCol, numStk+1, p1);
			else if(dispType == TEXTURE) drawTexGridCylinder(numCol, numStk+1, p1);
            else if(dispType == CHECK) drawCheckCylinder(numCol, numStk+1, p1, flagShadow);
    }
    return;

SMM_DISP:;//_\
    //ol̒C]p߂
    for(i = 0; i < numStruct; i++)
    {
        np1 = structS[i].np1;
        np2 = structS[i].np2;
        structS[i].length = vDist(point[np1].vPos,point[np2].vPos);
        structS[i].vEuler = getEulerZ(point[np1].vPos,point[np2].vPos);
        structS[i].kind = S_CYLINDER;
        structS[i].radius = pointRadius * 0.7;
        structS[i].vPos = (point[np1].vPos + point[np2].vPos) / 2.0;
    }
    for(i = 0; i < numShear; i++)
    {
        np1 = shearS[i].np1;
        np2 = shearS[i].np2;
        shearS[i].length = vDist(point[np1].vPos, point[np2].vPos);
        shearS[i].vEuler = getEulerZ(point[np1].vPos, point[np2].vPos);
        shearS[i].kind = S_CYLINDER;
        shearS[i].radius = pointRadius * 0.7;
        shearS[i].vPos = (point[np1].vPos + point[np2].vPos) / 2.0;
    }
    //_
    for(n = 0; n < numPoint; n++)
    {
		point[n].kind = SPHERE;
		point[n].vSize = CVector(2.0*pointRadius, 2.0*pointRadius, 2.0*pointRadius);
		point[n].color = CYAN;//YELLOW;
		if(point[n].flagFixed == true){
			point[n].color = RED;
		}
		point[n].draw(flagShadow);
    }

    for(i = 0; i < numStruct; i++) structS[i].draw(flagShadow);

    if(flagShear_Disp == 1){
        for(i = 0; i < numShear; i++) shearS[i].draw(flagShadow);
    }
}
//-----------------------------------------------------------------
void CSpringMass3::initializeCube()
{
    int i, j, k, cnt, np1, np2;
/*
    numStruct = (numRow * (numCol+1) + (numRow+1) * numCol) * (numStk+1) 
                + (numRow+1) * (numCol+1) * numStk;
    numShear = 2 * numRow * numCol * (numStk+1)
                + 2 * numRow * numStk * (numCol+1)
                + 2 * numCol * numStk * (numRow+1);
*/
    //olR
    lengthX0 = vSize.x / (float)numRow;
    lengthY0 = vSize.y / (float)numCol;
    lengthZ0 = vSize.z / (float)numStk;
    //_
	numPoint = (numRow+1) * (numCol+1) * (numStk+1);

    //_̈ʒu
    for(k = 0; k <= numStk; k++)
    for(i = 0; i <= numRow; i++)
    for(j = 0; j <= numCol; j++)
	{
		int n = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j;
		point[n].kind = SPHERE;
		point[n].vPos.x =  (float)i * lengthX0 - vSize.x / 2.0;
		point[n].vPos.y =  (float)j * lengthY0 - vSize.y / 2.0; 
		point[n].vPos.z = -(float)k * lengthZ0 + vSize.z / 2.0;
		point[n].vPos = rotate(point[n].vPos, vEuler);
		point[n].vPos += vPos;
	}

    //olɐڑ鎿_ԍ
    //ʏ̍\ol
    cnt = 0;
    //x-y
    for(k = 0; k <= numStk; k++)
	{
		for(i = 0; i <= numRow; i++)
		{
			for(j = 0; j < numCol; j++)
			{
				np1 = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j;
				np2 = np1+1;
				structS[cnt].np1 = np1;
				structS[cnt].np2 = np2;
				structS[cnt].length0 = vDist(point[np1].vPos, point[np2].vPos);
				cnt++;
			}
		}
		//xɕsspring
		for(i = 0; i < numRow; i++)
		{
			for(j = 0; j <= numCol; j++)
			{
				np1 = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j;
				np2 = np1 + numCol+1;
				structS[cnt].np1 = np1;
				structS[cnt].np2 = np2;
				structS[cnt].length0 = vDist(point[np1].vPos,point[np2].vPos);
				cnt++;
			}
		}
	}
    // zɕsspring
    for(k = 0; k < numStk; k++)
	{
		for(i = 0; i <= numRow; i++)
		{
			for(j = 0; j <= numCol; j++)
			{
				np1 = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j;
				np2 = np1 + (numRow+1)*(numCol+1);
				structS[cnt].np1 = np1;
				structS[cnt].np2 = np2;
				structS[cnt].length0 = vDist(point[np1].vPos,point[np2].vPos);
				cnt++;
			}
		}
    }
    numStruct = cnt;

    //fol
    cnt = 0;
    //x-y
    for(k = 0; k <= numStk; k++)
	{
		for(i = 0; i < numRow; i++)
		{
			for(j = 0; j < numCol; j++)
			{
				np1 = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j;
				np2 = k*(numRow+1)*(numCol+1) + (i+1)*(numCol+1) + j+1;
				shearS[cnt].np1 = np1;
				shearS[cnt].np2 = np2;
				shearS[cnt].length0 = vDist(point[np1].vPos, point[np2].vPos);
				cnt++;
				np1 = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j+1;
				np2 = k*(numRow+1)*(numCol+1) + (i+1)*(numCol+1) + j;
				shearS[cnt].np1 = np1;
				shearS[cnt].np2 = np2;
				shearS[cnt].length0 = vDist(point[np1].vPos, point[np2].vPos);
				cnt++;
			}
		}
    }
    //y-z
    for(i = 0; i <= numRow; i++)
	{
		for(k = 0; k < numStk; k++)
		{
			for(j = 0; j < numCol; j++)
			{
				np1 = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j;
				np2 = (k+1)*(numRow+1)*(numCol+1) + i*(numCol+1) + j+1;
				shearS[cnt].np1 = np1;
				shearS[cnt].np2 = np2;
				shearS[cnt].length0 = vDist(point[np1].vPos,point[np2].vPos);
				cnt++;
				np1 = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j+1;
				np2 = (k+1)*(numRow+1)*(numCol+1) + i*(numCol+1) + j;
				shearS[cnt].np1 = np1;
				shearS[cnt].np2 = np2;
				shearS[cnt].length0 = vDist(point[np1].vPos,point[np2].vPos);
				cnt++;
			}
		}
    }
    //x-z
    for(j = 0; j <= numCol; j++)
    {
		for(i = 0; i < numRow; i++)
		{
			for(k = 0; k < numStk; k++)
			{
				np1 = k*(numRow+1)*(numCol+1) + i*(numCol+1) + j;
				np2 = (k+1)*(numRow+1)*(numCol+1) + (i+1)*(numCol+1) + j;
				shearS[cnt].np1 = np1;
				shearS[cnt].np2 = np2;
				shearS[cnt].length0 = vDist(point[np1].vPos, point[np2].vPos);
				cnt++;
				np1 = (k+1)*(numRow+1)*(numCol+1) + i*(numCol+1) + j;
				np2 = k*(numRow+1)*(numCol+1) + (i+1)*(numCol+1) + j;
				shearS[cnt].np1 = np1;
				shearS[cnt].np2 = np2;
				shearS[cnt].length0 = vDist(point[np1].vPos,point[np2].vPos);
				cnt++;
			}
		}
    }
    numShear = cnt;
//printf("numPoint=%d numStruct=%d numShear=%d \n", numPoint,numStruct, numShear);
}

//-----------------------------------------------------------------------------

void CSpringMass3::calcSpringMass(float dt, float time)
{                             
    int i, k;
    int np1, np2;
    CVector vDir, vDir1, vDir2;
    CVector vFF;
    CVector vRelativeVelocity;
    CVector vNormal;
    float len;
    float dampingF;

	for(k = 0; k < numPoint; k++)
	{
		//͂̏ݒl
		point[k].vForce = vForce0 + CVector(0.0, 0.0, - mass * gravity);
//printf("flagForcedY = %d, flagForcedZ = %d freq=%f amp = %f time=%f \n", flagForcedY, flagForcedZ, frequency, amp, time);

		if(forced == FORCED_Y)
		{//U
			if(point[k].flagFixed == false)
			{
				point[k].vForce.y  += amp * sin(2.0*M_PI * frequency * time);
			}
		}
		if(forced == FORCED_Z)
		//if(flagForcedZ == true)
		{
			if(point[k].flagFixed == false)
			{
			   point[k].vForce.z  += amp*sin(2.0*M_PI*frequency*time);
			}
		}
	}

    //\olɂ
    for(i = 0; i < numStruct; i++)
	{
		np1 = structS[i].np1;
		np2 = structS[i].np2;
		vDir = point[np1].vPos >> point[np2].vPos;//#1#2ւ̒PʃxNg
		len = vDist(point[np1].vPos, point[np2].vPos);
		if(len < structS[i].length0 * 0.8) len = structS[i].length0 * 0.8;
		if(len > structS[i].length0 * 1.2) len = structS[i].length0 * 1.2;
		//e
		vFF = (structK * (len - structS[i].length0)) * vDir ;
		point[np1].vForce += vFF ;//vDirƓ
		point[np2].vForce -= vFF ;//Ε
		//
		vRelativeVelocity = point[np1].vVelocity - point[np2].vVelocity;
		dampingF = damping * vDot(vRelativeVelocity, vDir);
		point[np1].vForce -= dampingF * vDir;//ΑxƂ͔Ε
		point[np2].vForce += dampingF * vDir;//
	}

    //folɂ
    for(i = 0; i < numShear; i++)
	{
		//e
		np1 = shearS[i].np1;
		np2 = shearS[i].np2;
		vDir = point[np1].vPos >> point[np2].vPos;//#1#2ւ̒PʃxNg
		len = vDist(point[np1].vPos, point[np2].vPos);
		if(len < shearS[i].length0 * 0.8) len = shearS[i].length0 * 0.8;
		if(len > shearS[i].length0 * 1.2) len = shearS[i].length0 * 1.2;
		vFF = (shearK * (len - shearS[i].length0)) * vDir ;
		point[np1].vForce += vFF ;//vDirƓ
		point[np2].vForce -= vFF ;//Ε
		//
		vRelativeVelocity = point[np1].vVelocity - point[np2].vVelocity;
		dampingF = damping * vDot(vRelativeVelocity, vDir);
		point[np1].vForce -= dampingF * vDir;//ΑxƂ͔Ε
		point[np2].vForce += dampingF * vDir;//
    }
    //point̑xƈʒu̍XV (Euler Metod)
    for(k = 0; k < numPoint; k++)
    {
		if(point[k].flagFixed == true) continue; //Œ
		//SR(SĂ̎_ɈlƉ)
		point[k].vForce -= drag * point[k].vVelocity;
		//CR
		if(point[k].vPos.z <= pointRadius){
			//if(flagFloo == true) 
			//	point[k].vForce = CVector(0.0, 0.0, 0.0);
			//else 
			point[k].vForce -= (muK * mass * gravity) * point[k].vVelocity.normXY2();
		}
		//x

		point[k].vAccel = point[k].vForce / mass;
		//x
		point[k].vVelocity += point[k].vAccel * dt;
		//ʒu
		point[k].vPos += point[k].vVelocity * dt ;

		if(point[k].vPos.z <= pointRadius)
		{
			//ʏɐ
			point[k].vPos.z = pointRadius;
			//Ƃ̏Փ
			if(point[k].vVelocity.z < 0.0){ //_ƏʂƂ͒eՓ˂Ƃ
			   point[k].vVelocity.z = - restitut * point[k].vVelocity.z ;
			}
		}
    }

    //SpringMassModeel3̈ʒu
    if(kind == CUBE)
    {
        //Ŝ8̊p̒_W𕽋
        vPos = point[0].vPos + point[numRow*(numCol+1)].vPos;
        vPos += point[numRow*(numCol+1)].vPos + point[numCol].vPos;
        vPos += point[numStk*(numRow+1)*(numCol+1)].vPos + point[numStk*(numRow+1)*(numCol+1)+numRow*(numCol+1)].vPos;
        vPos += point[numStk*(numRow+1)*(numCol+1)+numCol * (numCol+1)].vPos + point[numStk*(numRow+1)*(numCol+1)+numCol].vPos;
        vPos /= 8.0;
    }
    else if(kind == SPHERE) vPos = point[numPoint-1].vPos;//S_
    else //Cylinder
    {
        //Ɖ̒SW𕽋
        vPos = (point[0].vPos + point[numStk*(numCol+1)].vPos) / 2.0;
    }
}

//-----------------------------------------------------------------------------
void CSpringMass3::initializeSphere()
{
    int j, jp, kp, k, np, np1, np2, cnt;
    float phi, theta;
    float rx, ry, rz;//e̋Ŝ̔a

    //a
    rx = vSize.x / 2.0;
    ry = vSize.y / 2.0;
    rz = vSize.z / 2.0;
    //S_
    numPoint = (numStk-1) * numCol + 3;

    //numStk---z̃ol
    //numCol---x-yʁiʊpCoxj̃ol
    //Sɂ_uinumPoint-1Ԗ)

    //_̃TCYCʒu
    //Top
    np = 0;
	point[np].vPos.x = 0.0; //xW
	point[np].vPos.y = 0.0; //y
	point[np].vPos.z = rz;//z̔a
	point[np].vPos = rotate(point[0].vPos, vEuler);
	point[np].vPos += vPos;
	//Bottom
	np = numPoint - 2;
	point[np].vPos.x = 0.0; //xW
	point[np].vPos.y = 0.0; //y
	point[np].vPos.z = - rz;//z
	point[np].vPos = rotate(point[np].vPos, vEuler);
	point[np].vPos += vPos;
//printf("np=%d, x=%f, y=%f, z=%f \n", np, point[np].vPos.x, point[np].vPos.y, point[np].vPos.z);
    for(k = 1; k < numStk; k++)
    {
        theta = M_PI/2.0-M_PI*(double)k/(double)numStk;
        for(j = 0; j < numCol; j++)
		{   //^j=0
			np = (k-1)*numCol + j + 1;
			phi = 2.0*M_PI*(double)j/(double)numCol;
			point[np].vPos.x = -(float)(rx*cos(phi)*cos(theta)); //xW
			point[np].vPos.y = -(float)(ry*sin(phi)*cos(theta)); //y
			point[np].vPos.z = (float)(rz*sin(theta));             //z
			point[np].vPos = rotate(point[np].vPos, vEuler);
			point[np].vPos += vPos;
        }
    }
    //SiSɂ_)
    np = numPoint-1;
	point[np].vPos = vPos;

    //olx,y,zW(_ɋ߂_Œ`jƉ]p
    //olɐڑ鎿_ԍ
    //
    cnt = 0;
    for(k = 1; k < numStk; k++)
    {
        for(j = 0; j < numCol; j++)
        {
            np1 = (k-1)*numCol + j + 1;
            jp = j + 1;
            if(jp == numCol) jp = 0;
            np2 = (k-1)*numCol + jp + 1;
            structS[cnt].vPos = point[np1].vPos;
            structS[cnt].length0 = vDist(point[np1].vPos,point[np2].vPos);
            structS[cnt].np1 = np1;
            structS[cnt].np2 = np2;
            cnt++;
        }
    }
    //c
    k = 0;  //Top
    for(j = 0; j < numCol; j++)
    {
        np1 = 0;
        np2 = j + 1;
        structS[cnt].vPos =point[np1].vPos;
        structS[cnt].length0 = vDist(point[np1].vPos,point[np2].vPos);
        structS[cnt].np1 = np1;
        structS[cnt].np2 = np2;
        cnt++;
    }
    //
    for(k = 1; k < numStk-1; k++)
    {
        kp = k + 1;
        for(j = 0; j < numCol; j++)
        {
            np1 = (k-1)*numCol + j + 1;
            np2 = (kp-1)*numCol + j + 1;

            structS[cnt].vPos =point[np1].vPos;
            structS[cnt].length0 = vDist(point[np1].vPos, point[np2].vPos);
            structS[cnt].np1 = np1;
            structS[cnt].np2 = np2;
            cnt++;
        }
    }
    k = numStk-1;//Botom
    for(j = 0; j < numCol; j++)
    {
        np1 = (k-1)*numCol + j + 1;
        np2 = numPoint - 2;
        structS[cnt].vPos = point[np1].vPos;
        structS[cnt].length0 = vDist(point[np1].vPos, point[np2].vPos);
        structS[cnt].np1 = np1;
        structS[cnt].np2 = np2;
        cnt++;
    }
    //SƎ_(SɎ_z)
    for(k = 0; k < numPoint-1; k++)
    {
        np1 = k;
        np2 = numPoint-1;//S
        structS[cnt].np1 = np1;
        structS[cnt].np2 = np2;
        structS[cnt].vPos = point[np1].vPos;
        structS[cnt].length0 = vDist(point[np1].vPos, point[np2].vPos);
        cnt++;
    }
    numStruct = cnt;

    //fol
    cnt = 0;
    for(k = 1; k < numStk-1; k++)
    {
        for(j = 0; j < numCol; j++){
            jp = j + 1;
            if(jp == numCol) jp = 0;
            np1 = (k-1) * numCol + j + 1;
            np2 = k * numCol + jp + 1;
            shearS[cnt].vPos = point[np1].vPos;
            shearS[cnt].length0 = vDist(point[np1].vPos, point[np2].vPos);
            shearS[cnt].np1 = np1;
            shearS[cnt].np2 = np2;
            cnt++;
            np1 = (k-1) * numCol + jp + 1;
            np2 = k * numCol + j + 1;
            shearS[cnt].vPos = point[np1].vPos;
            shearS[cnt].length0 = vDist(point[np1].vPos, point[np2].vPos);
            shearS[cnt].np1 = np1;
            shearS[cnt].np2 = np2;
            cnt++;
        }
    }
    numShear = cnt;
//printf("numPoint=%d numStruct=%d numShear=%d \n", numPoint,numStruct, numShear);
}

//-----------------------------------------------------------------------------
void CSpringMass3::initializeCylinder()
{
    int j, jp, k, n, np1, np2, cnt;
    float phi;
    float rx, ry, h;

    rx = vSize.x / 2.0;
    ry = vSize.y / 2.0;
    h = vSize.z;
    lengthZ0 = h / (float)numStk;

    numPoint = (numStk+1) * (numCol + 1);
    //numStk---ž
    //numCol---x-yʁiʊpCox,iȉꉺ̒Sɂ_uj
                   //~̎_{1iOԖڂS)

    //_̈ʒu
    for(k = 0; k <= numStk; k++)
    {
        //S
       n = k * (numCol+1);
       point[n].vPos.x = 0.0; //x
       point[n].vPos.y = 0.0; //y
       point[n].vPos.z = -(float)k * lengthZ0 + h / 2.0;//z
       point[n].vPos = rotate(point[n].vPos, vEuler);
       point[n].vPos += vPos;
        //~
        for(j = 0; j < numCol; j++){ //^j=0
           n = k*(numCol+1) + j + 1;
            phi = 2.0*M_PI*(double)j/(double)numCol;
           point[n].vPos.x = -(float)(rx*cos(phi)); //xW
           point[n].vPos.y = -(float)(ry*sin(phi)); //y
           point[n].vPos.z = -(float)k * lengthZ0 + h / 2.0;//z
           point[n].vPos = rotate(point[n].vPos, vEuler);
           point[n].vPos += vPos;
        }
    }
    //\olx,y,zW
    //olɐڑ鎿_ԍ
    cnt = 0;
    for(k = 0; k <= numStk; k++){
        //SƉ~̎_
        for(j = 1; j <= numCol; j++){
            np1 = k * (numCol + 1);//S
            np2 = k * (numCol + 1) + j;
            structS[cnt].vPos = point[np1].vPos;
            structS[cnt].length0 = vDist(point[np1].vPos,point[np2].vPos);
            structS[cnt].np1 = np1;
            structS[cnt].np2 = np2;
            cnt++;
        }
        //i~̎_ԁj
        for(j = 1; j <= numCol; j++)
        {
            np1 = k * (numCol+1) + j ;
            jp = j + 1;
            if(jp == numCol+1) jp = 1;
            np2 = k * (numCol+1) + jp;
            structS[cnt].vPos =point[np1].vPos;
            structS[cnt].length0 = vDist(point[np1].vPos,point[np2].vPos);
            structS[cnt].np1 = np1;
            structS[cnt].np2 = np2;
            cnt++;
        }
    }
    //ci㉺̒SԂщ~)
    for(k = 0; k < numStk; k++)
    {
        for(j = 0; j <= numCol; j++)
        {
            np1 = k * (numCol+1) + j;
            np2 = (k+1) * (numCol+1) + j;
            structS[cnt].vPos = point[np1].vPos;
            structS[cnt].length0 = vDist(point[np1].vPos, point[np2].vPos);
            structS[cnt].np1 = np1;
            structS[cnt].np2 = np2;
            cnt++;
        }
    }
    numStruct = cnt;

    //~̂fol
    cnt = 0;
    for(k = 0; k < numStk; k++)
    {
        for(j = 0; j < numCol; j++){
            jp = j + 1;
            if(jp == numCol) jp = 0;
            np1 = k * (numCol+1) + j + 1;
            np2 = (k+1) * (numCol+1) + jp + 1;
            shearS[cnt].vPos = point[np1].vPos;
            shearS[cnt].length0 = vDist(point[np1].vPos, point[np2].vPos);
            shearS[cnt].np1 = np1;
            shearS[cnt].np2 = np2;
            cnt++;
            np1 = k * (numCol+1) + jp + 1;
            np2 = (k+1) * (numCol+1) + j + 1;
            shearS[cnt].vPos = point[np1].vPos;
            shearS[cnt].length0 = vDist(point[np1].vPos, point[np2].vPos);
            shearS[cnt].np1 = np1;
            shearS[cnt].np2 = np2;
            cnt++;
        }
    }

    //fol(evf̒S̔Αƌԁj
    for(k = 0; k < numStk; k++)
    {
        for(j = 1; j <= numCol; j++){
            jp = numCol/2 + j;
            if(jp > numCol) jp -= numCol;
            np1 = k * (numCol+1) + j;
            np2 = (k+1) * (numCol+1) + jp;
            shearS[cnt].vPos = point[np1].vPos;
            shearS[cnt].length0 = vDist(point[np1].vPos, point[np2].vPos);
            shearS[cnt].np1 = np1;
            shearS[cnt].np2 = np2;
            cnt++;
        }
    }
    numShear = cnt;
//printf("numPoint=%d numStruct=%d numShear=%d \n", numPoint,numStruct, numShear);
}
