//vehicle.h

float radiusTire1 = 0.2;//^Cf
float radiusTire2 = 0.5;//Sa(radiusTire1<radiusTire2)
float lightR = 0.3;     //Cg

//display list
int trunk, wheel, light;

void createTrunk()
{
	trunk = glGenLists(1);
	if(trunk == 0) { printf("display list mۂł܂ł\n"); return; }
	glNewList(trunk, GL_COMPILE);
	drawSuper(0.5, 10, 10, 0.2, 0.2);
	glEndList();
}

void createTire()
{
	wheel = glGenLists(1);
	if(wheel == 0) { printf("display list mۂł܂ł\n"); return; }
	glNewList(wheel, GL_COMPILE);
	glPushMatrix();
		glRotatef(90.0, 1.0, 0.0, 0.0);
		glScalef(1.0, 1.0, 0.8);
		drawTorus(radiusTire1, radiusTire2, 10, 10);
	glPopMatrix();
	glPushMatrix();
		glScalef(0.15, 0.2, 1.0);
		drawCube(1.0);
	glPopMatrix();
	glPushMatrix();
		glScalef(1.0, 0.2, 0.15);
		drawCube(1.0);
	glPopMatrix();

	glEndList();
}

void createLight()
{
	light = glGenLists(1);
	if(light == 0) { printf("display list mۂł܂ł\n"); return; }
	glNewList(light, GL_COMPILE);
	glPushMatrix();
		glRotatef(90.0, 0.0, 1.0, 0.0);
		glScalef(1.0, 1.0, 0.4);
		drawSuper(lightR, 10, 10, 0.2, 1.0);
	glPopMatrix();
	glEndList();
}

void createDisplayListsVehicle()
{
	createTrunk();
	createTire();
	createLight();
}
void deleteDisplayListsVehicle()
{
	glDeleteLists(trunk, 1);
	glDeleteLists(wheel, 1);
	glDeleteLists(light, 1);
}

class CVehicle
{
public:
	CVehicle(void);
	~CVehicle(void) { };
//	CVector root; //[gʒu
	float lngth;  //x
	float width;  //y
	float height; //z(^C܂ޑŚj
	float height0;//i{̂̍j
	float speed0 ;//ݒXs[h
	float speed  ;//݂̃Xs[h
	float radius; //wheel(Śj
	float steerAngle;   //Oւ̑Ǌpideg)
	float wheelRotAngle;//ԗւ̉]pideg)
	float slideAngle;
	float maxSpeed;
	float accelRate;
	//bool flagDrive;
	bool flagBrake;
	void draw(bool flagShadow);
};

CVehicle::CVehicle()
{
	lngth = 5.0;
	width = 3.0;
	height = 4.0;//wheel܂
//	root = CVector(0.0, 0.0, height / 2.0);//{p
	radius = radiusTire1 + radiusTire2;
	height0 = height - radius;//{̂̍
	speed0 = 10.0;
	steerAngle = 0.0;//Ǌp
	wheelRotAngle = 0.0;
	slideAngle = 50.0;
	maxSpeed = 30.0;//108Km
	accelRate = 0.01;
	//flagDrive = true;
	flagBrake = false;
}

void CVehicle::draw(bool flagShadow)
{
  static float diffuse0[] = {0.4, 0.9, 0.6, 1.0};//{̂̊gU
  static float tireDiffuse0[] = { 0.1, 0.1, 0.5, 1.0};
  static float lightDiffuse0[] = {0.9, 0.9, 0.6, 1.0};
  static float specular0[] = {0.7, 0.7, 0.7, 1.0}; //ʌ
	//ẽ}eA
	static float shadowDiffuse[] =  {0.0,0.0,0.0,0.3};//e̊gU
	static float shadowSpecular[] = {0.0,0.0,0.0,1.0};//e̋ʌ

	//{
	if(!flagShadow)
	{
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,diffuse0);
		glMaterialfv(GL_FRONT,GL_SPECULAR,specular0);
		glMaterialf(GL_FRONT,GL_SHININESS,50.0);
	}
	else
	{
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,shadowSpecular);
		glMaterialf(GL_FRONT,GL_SHININESS,0.0);
	}

	glPushMatrix();
	glTranslatef(0.0, 0.0, radius / 2.0);//{̒S̈ʒu

	//{
	glPushMatrix();
	glScalef(lngth, width, height0);
	glCallList(trunk);
//	drawSuper(0.5, 10, 10, 0.2, 0.2);
	glPopMatrix();

	//tire
	if(!flagShadow)
	{
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,tireDiffuse0);
		glMaterialfv(GL_FRONT,GL_SPECULAR,specular0);
		glMaterialf(GL_FRONT,GL_SHININESS,10.0);
	}
	else
	{
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,shadowSpecular);
		glMaterialf(GL_FRONT,GL_SHININESS,0.0);
	}

	//O
	glPushMatrix();
	  glTranslatef(lngth/4.0, width/2.0, -height0/2.0);
		glRotatef(steerAngle, 0.0, 0.0, 1.0);
		glRotatef(wheelRotAngle, 0.0, 1.0, 0.0);//wheelg̐]
		glCallList(wheel);
//		drawTorus(radius1, radius2, 10, 10);
	glPopMatrix();
	//EO
	glPushMatrix();
	  glTranslatef(lngth/4.0, -width/2.0, -height0/2.0);
		glRotatef(steerAngle, 0.0, 0.0,1.0);
		glRotatef(wheelRotAngle, 0.0, 1.0, 0.0);//wheelg̐]
		//glRotatef(90.0, 1.0, 0.0, 0.0);
		//glScalef(1.0, 1.0, 0.8);
		glCallList(wheel);
//		drawTorus(radius1, radius2, 10, 10);
	glPopMatrix();
	//
	glPushMatrix();
	  glTranslatef(-lngth/4.0, width/2.0, -height0/2.0);
		glRotatef(wheelRotAngle, 0.0, 1.0, 0.0);//wheelg̐]
		//glRotatef(90.0, 1.0, 0.0, 0.0);
		//glScalef(1.0, 1.0, 0.8);
		glCallList(wheel);
//		drawTorus(radius1, radius2, 10, 10);
	glPopMatrix();
	//E
	glPushMatrix();
	  glTranslatef(-lngth/4.0, -width/2.0, -height0/2.0);
		glRotatef(wheelRotAngle, 0.0, 1.0, 0.0);//wheelg̐]
		//glRotatef(90.0, 1.0, 0.0, 0.0);
		//glScalef(1.0, 1.0, 0.8);
		glCallList(wheel);
		//drawTorus(radius1, radius2, 10, 10);
	glPopMatrix();

	//light
	if(!flagShadow)
	{
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,lightDiffuse0);
		glMaterialfv(GL_FRONT,GL_SPECULAR,specular0);
		glMaterialf(GL_FRONT,GL_SHININESS,10.0);
	}
	else
	{
		glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,shadowSpecular);
		glMaterialf(GL_FRONT,GL_SHININESS,0.0);
	}
	//
	glPushMatrix();
	  glTranslatef(lngth/2.0, width/2.0-0.3, 0.0);
		glCallList(light);
	glPopMatrix();
	//E
	glPushMatrix();
	  glTranslatef(lngth/2.0, -width/2.0+0.3, 0.0);
		glCallList(light);
	glPopMatrix();
glPopMatrix();
}
